%### RCREF.SL

% Fix to make Rcref compile while being loaded as fast loading (*.k)
% files for Culisp are not working. JEA.
(NOTLOADTIME (SETQ !*COMP T))

(GLOBAL '(ARGV!* GOFN!* !*FNARGNOLIST !*NOEXTRA NOLIST!* EXNOLIST!*
          USEFN!* !*USEFN !*CREFSUMMARY !*LOSE !*INDEX !*IDPROPS
          !*FORCE !*RCALL !*NOVARFN !*APPLYLOCAL !*PROPS !*GLOBALS
          !*IFPEXPAND !*CREFTIME !*STRICTCOND KNLIST!* !*LISTALL
          CRFOUTNM!* !*FILEPROPS !*SAVEPROPS !*CHKONLY !*EXPERT
          !*PREDECLS !*NOFPAG))

(GLOBAL '(CALLINITSW!*))

(FLUID '(LI!_NUM!* PG!_NUM!*))

% Command line switches:

% e     Turn on expert mode.
(DE !e!_RCINIT () (SETQ !*EXPERT T) NIL)

% o <file>  Use file name <file> as name of cross reference listing.
(DE !o!_RCINIT () (SETQ CRFOUTNM!* (CHKERARGV)) NIL)

% v     Do not complain about variable in function position.
(DE !v!_RCINIT () (SETQ !*NOVARFN NIL))

% a     Regard lambda expressions to apply as not knowning local
%       variables.
(DE !a!_RCINIT () (SETQ !*APPLYLOCAL T) NIL)

% g     Only accept non-local declarations in file, not in a preloaded
%       file.
(DE !g!_RCINIT () (SETQ !*PREDECLS NIL) NIL)

% m     Do not define macros, only analyse them.
(DE !m!_RCINIT () (REMFLAG '(DMACRO DS DM CMMACRO) 'EVAL) NIL)

% M     Expand all macros (except nonforceable ones).
(DE !M!_RCINIT () (SETQ !*FORCE T) NIL)

% K     Do not see other known functions.
(DE !K!_RCINIT () (SETQ !*NOEXTRA T) NIL)

% k     See all functions, i.e. standard functions also.
(DE !k!_RCINIT () (SETQ !*LISTALL T) NIL)

% f <file>  Load file <file>.
(DE !f!_RCINIT () (MLOAD (CHKERARGV)) NIL)

% C <file>  Load file <file> inside Rcref.
(DE !C!_RCINIT () (LIST 'DSKIN (CHKERARGV)))

% Y     Regard known functions as standard functions.
(DE !Y!_RCINIT () (SETSTDFN KNLIST!*) NIL)

% y     Regard known functions as other known functions.
(DE !y!_RCINIT () (SETEXFN KNLIST!*) NIL)

% L     Also analyse "lost" functions.
(DE !L!_RCINIT () (SETQ !*LOSE NIL))

% P     Do not analyse all identifier properties.
(DE !P!_RCINIT () (SETQ !*PROPS NIL))

% V     Do not analyse variable use.
(DE !V!_RCINIT () (SETQ !*GLOBALS NIL))

% b     Analyse all branches in conditional coding.
(DE !b!_RCINIT () (SETQ !*IFPEXPAND NIL))

% c     Give all calls recursively.
(DE !c!_RCINIT () (SETQ !*RCALL T) NIL)

% r <fn>  Print all functions (recursively) that calls <fn>.
(DE !r!_RCINIT () (FLAG1 (CHKERARGV) 'RCLD) NIL)

% R <fn>  Print all functions (recursively) that are called by <fn>.
(DE !R!_RCINIT () (FLAG1 (CHKERARGV) 'RCAL) NIL)

% N     Only load and check files. Do not print summary or other output.
(DE !N!_RCINIT () (SETQ !*CHKONLY T) NIL)

% s     Do not print specification for each function.
(DE !s!_RCINIT () (SETQ !*CREFSUMMARY T) NIL)

% Z     Print function database.
(DE !Z!_RCINIT () (SETQ !*FNARGNOLIST T) NIL)

% W     Print list of not called known functions.
(DE !W!_RCINIT () (SETQ !*USEFN T) NIL)

% i     Do not print index.
(DE !i!_RCINIT () (SETQ !*INDEX NIL))

% p     Print all identifier properties.
(DE !p!_RCINIT () (SETQ !*IDPROPS T) NIL)

% F     Give analysis for each file.
(DE !F!_RCINIT () (SETQ !*FILEPROPS T) NIL)

% n     Do not fit into pages.
(DE !n!_RCINIT () (SETQ !*NOFPAG T) NIL)

% S     Do not keep database lists.
(DE !S!_RCINIT () (SETQ !*SAVEPROPS NIL))

% t     Give timings for cross reference program.
(DE !t!_RCINIT () (SETQ !*CREFTIME T) NIL)

% h     Complain if COND is used with singe bucket. Added by JEA.
(DE !h!_RCINIT () (SETQ !*STRICTCOND T) NIL)

(DE DOCREF ()
 (SLET (X AL)
  (DEFLIST '(
    (!a !a!_RCINIT)
    (!b !b!_RCINIT)
    (!c !c!_RCINIT)
    (!C !C!_RCINIT)
    (!e !e!_RCINIT)
    (!f !f!_RCINIT)
    (!F !F!_RCINIT)
    (!g !g!_RCINIT)
    (!h !h!_RCINIT)     % JEA
    (!i !i!_RCINIT)
    (!k !k!_RCINIT)
    (!K !K!_RCINIT)
    (!L !L!_RCINIT)
    (!m !m!_RCINIT)
    (!M !M!_RCINIT)
    (!n !n!_RCINIT)
    (!N !N!_RCINIT)
    (!o !o!_RCINIT)
    (!p !p!_RCINIT)
    (!P !P!_RCINIT)
    (!r !r!_RCINIT)
    (!R !R!_RCINIT)
    (!s !s!_RCINIT)
    (!S !S!_RCINIT)
    (!t !t!_RCINIT)
    (!v !v!_RCINIT)
    (!V !V!_RCINIT)
    (!W !W!_RCINIT)
    (!y !y!_RCINIT)
    (!Y !Y!_RCINIT)
    (!Z !Z!_RCINIT) )
   'INITLINEFN)
  (SETQ !*SAVEPROPS T)
  (SETQ CALLINITSW!* NIL)
  (SETQ CRFOUTNM!* NIL)
  (WHILE ARGV!*
   (COND ((NOT (TRYINICHSWITCH (SETQ X (CHKERARGV)))) (XPUSH AL X))) )
  (COND
   (AL
    (SETQ AL (REVERSIP AL))
    (CREFOUTF
     (OR CRFOUTNM!* (CADR (FILNAM (CAR AL)))) ) ) )
  (COND (CALLINITSW!*
         (EVAL (CONS 'PROGN CALLINITSW!*)) (SETQ CALLINITSW!* NIL) ))
  (COND (AL (EVAL (CONS 'DSKIN AL)) (CREFEND))) ) )

(INCLUDE "REDIO.SL")

(NOTLOADTIME (FLAG '(ANEXPD) 'LOSE))

(INCLUDE "IRCREF.SL")

(NOTLOADTIME (REMFLAG '(ANEXPD) 'LOSE))

(INCLUDE "EXRCRF.SL")

(NOTLOADTIME (COND (!*CREF
   (DEFLIST '((CREF51 ANFORMGET) (CREF61 ANFORMGET)
              (TOPUT ANTOPUT) (TRAPUT ANTOPUT))
            'ANLFN)
   (DE ANTOPUT (U)
    (PROG (X)
     (SETQ X (QCRFA U 1))
     (ANFORM (CADDR U))
     (SETQ U (QCRFA U 2))
     (ANGET X U)
     (ANPUT X U) ) )
   (DC REMPROPSS ANLFN (U)
    (PROG (X)
     (SETQ X (QCRFA U 1)) (SETQ U (QCRFA U 2))
     (COND
      ((PAIRP X)
       (FOREACH Y IN X DO
        (COND
         ((PAIRP U) (FOREACH Z IN U DO (ANREMPROP Y Z)))
         (T (ANREMPROP Y U)) )))
      ((PAIRP U) (FOREACH Z IN U DO (ANREMPROP X Z)))
      (T (ANREMPROP X U)) ) ) )
   (DC REMFLAGSS ANLFN (U)
    (PROG (X)
     (SETQ X (QCRFA U 1)) (SETQ U (QCRF U 2))
     (COND
      ((PAIRP U) (FOREACH Z IN U DO (ANREMFLAG X Z)))
      (T (ANREMFLAG X U)) ) ) ) )))

(SETQ GOFN!* 'DOCREF)

(DE LIN!_CNT!_MACRO () (SETQ LI!_NUM!* (XADD1 LI!_NUM!*)) NIL)

(DE PG!_CNT!_MACRO ()
 (SETQ PG!_NUM!* (XADD1 PG!_NUM!*))
 (SETQ LI!_NUM!* 1)
 NIL)

(SETSYNTAX !$EOL!$ 'SPLICE 'LIN!_CNT!_MACRO)

(KNOWNCONSTANTS !$FF!$ TAB BLANK)       % JEA.

(SETSYNTAX !$FF!$ 'SPLICE 'PG!_CNT!_MACRO)

(SETSYNTAX !$FF!$ 'IGNORE NIL)

(SETSYNTAX !$EOL!$ 'IGNORE NIL)

(NOTLOADTIME (SETQ !*COMP NIL))   % JEA

%### RCREF.SL end
