%### BIGGER.SL

% This file contains the predicates BIGGKERN and BIGGTERM that is used
% to order products and sums. 

(ENTRYPOINTS BIGGER BIGGKERN BIGGTERM SMLESSP)
 
(LOCALFUNCTIONS IXBIGGTERM BIGGTRM BIGGOP BIGGID1 BIGGWG GETOPW)

(SETLOCALGLOBALS ((XX!$ (NCONS NIL))) ((YY!$ (NCONS NIL))))

(DE BIGGER (X Y) (COND
% X and Y are Sheep-expressions that are compared for equality and
% order. Returns NIL if they are the same, INSERT if they are in order
% and GOON otherwise.
  ((AND (SNUMP X) (SNUMP Y)) (BIGGSNRT X Y))
  ((EQCAR X 'PLUS) (COND
    ((EQCAR Y 'PLUS) (BIGGPL (CDR X) (CDR Y))) % X and Y are sums
    (T (BIGGPL (CDR X) (RPLACA YY!$ Y))) )) % X is sum, Y is single term
  ((EQCAR Y 'PLUS) (BIGGPL (RPLACA XX!$ X) (CDR Y))) % X is term, Y sum
  (T (BIGGTRM X Y)) ))                   % X and Y are terms

(DE BIGGPL (X Y) (SLET (A)
% X and Y are sums i.e. lists of terms. Empty lists are allowed.
% Compare terms till not equal is found or the lists are ended.
  (WHILE (AND (OR X Y) (NULL (SETQ A
     (BIGGTRM (COND (X (CAR X)) (T 0)) (COND (Y (CAR Y)) (T 0))) )))
   (UNPUSH X)
   (UNPUSH Y) )
  A))

(DE BIGGTRM (X Y)
% X and Y are terms. A term is a coefficient followed by a list of
% factors.
 (SLET ((XC 1) (YC 1))
  (COND
   ((SNUMP X) (SETQ XC X) (SETQ X NIL))
   ((NOT (EQCAR X 'TIMES)) (SETQ X (RPLACA XX!$ X))) 
   ((SNUMP (CAR (SETQ X (CDR X)))) (SETQ XC (CAR X)) (UNPUSH X)) )
  (COND
   ((SNUMP Y) (SETQ YC Y) (SETQ Y NIL))
   ((NOT (EQCAR Y 'TIMES)) (SETQ Y (RPLACA YY!$ Y))) 
   ((SNUMP (CAR (SETQ Y (CDR Y)))) (SETQ YC (CAR Y)) (UNPUSH Y)) )
  (COND ((OR (AND X (NOT (ZEROP YC))) (AND Y (NOT (ZEROP XC)))) (COND
          ((EQ (SETQ X (BIGGTERM X Y)) 'INSERT) (SETQ YC 0))
          (X (SETQ XC 0)) )))
  (BIGGSNRT XC YC) ) )

(DE BIGGTERM (X Y) (COND
  (ORDPLMAIN 
   (PROG1 (IXBIGGTERM (SETQ X (REVERSIP X)) (SETQ Y (REVERSIP Y)) 'GOON)
    (REVERSIP X) (REVERSIP Y) ) )
  (T (IXBIGGTERM X Y 'INSERT)) ))

(DE IXBIGGTERM (X Y VL)
% X and Y are lists of factors that are compared for equality and order.
% Returns NIL if they are the same, INSERT if they are in order and GOON
% otherwise.
 (PROG (XE YE XB YB BB)
L  (COND
    ((NULL X) (COND
      (Y (SETQ XE 0))
      (T (RETURN NIL)) ))
    ((EQCAR (SETQ XB (CAR X)) 'EXPT)
     (SETQ XE (CADDR XB)) (SETQ XB (CADR XB)) )
    ((EQCAR XB 'EXP) (SETQ XE (CADR XB)) (SETQ XB '(EXP)))
    (T (SETQ XE 1)) )
   (COND
    ((NULL Y) (SETQ YE 0))
    ((EQCAR (SETQ YB (CAR Y)) 'EXPT)
     (SETQ YE (CADDR YB)) (SETQ YB (CADR YB)) )
    ((EQCAR YB 'EXP) (SETQ YE (CADR YB)) (SETQ YB '(EXP)))
    (T (SETQ YE 1)) )
   (COND
    ((NULL X) (SETQ BB YB) (UNPUSH Y))
    ((NULL Y) (SETQ BB XB) (UNPUSH X))
    ((PROGN (UNPUSH X) (UNPUSH Y) (EQ (SETQ BB (BIGGKERN XB YB)) VL))
     (SETQ BB XB) (SETQ YE 0) )
    (BB (SETQ BB YB) (SETQ XE 0))
    (T (SETQ BB XB)) )
   (COND ((SETQ XB (COND
            ((AND (EQ BB IMNT!*) (NOT IMAGFIRST)) (BIGGER YE XE))
            (T (BIGGER XE YE)) ))
          (RETURN XB) ))
   (GO L) ) )

(DE BIGGKERN (X Y) % This is the basic routine.
% X and Y are expressions kernels that are compared for equality and
% order. Returns NIL if they are the same, INSERT if they are in order
% and GOON otherwise.
% This is somewhat arbitrary but reasonably fast.
 (SLET (A)
  (COND 
   ((EQ X Y) NIL)                       % Equal.
   ((EQCAR X 'CONJ)                     % X is conjugate
    (COND
     ((EQCAR Y 'CONJ)                   % and so is Y
      (BIGGKERN (CADR X) (CADR Y)) )    % compare arg
     ((SETQ A (BIGGKERN (CADR X) Y)) A) % if X arg is not same as Y
     (T 'GOON) ))                       % compare else not in order
   ((EQCAR Y 'CONJ)
    (COND
     ((SETQ A (BIGGKERN X (CADR Y))) A)
     (T 'INSERT) ))
   ((SNUMP X)                           % X is number,
    (COND
     ((NOT (SNUMP Y)) 'INSERT)          % but Y is not! In order.
     (T (BIGGSNU Y X)) ))       % Order numbers with lowest first.
   ((SNUMP Y) 'GOON)            % Y is number but X wasn't. Not order
   ((ATOM X)                            % X is atom (id),
    (COND
     ((OR (EQ X IMNT!*) (NOT (ATOM Y)))
      'INSERT)                          % but Y is not. In order.
     ((EQ Y IMNT!*) 'GOON)
     (T (BIGGID1 X Y)) ))               % Both are ids. Compare ids.
   ((ATOM Y) 'GOON)                     % Y is id but X is not.
   ((SETQ A (BIGGOP (CAR X) (CAR Y))) A)% Compare function names
   ((AND (NOT NOORDEXP)                 % If NOORDEXP is off and there
     (SETQ A (GET (CAR X) 'BIGGFN)) )   %  is a special ordering
    (FUNCALL A (CDR X) (CDR Y)) )       %  function, use that
   (T (BIGLP (CDR X) (CDR Y))) )) )     %  else just compare elements.

(DE BIGLP (X Y)
 (SLET (A)
  (WHILE (AND X Y (NULL (SETQ A (BIGGKERN (CAR X) (CAR Y)))))
   (UNPUSH X) (UNPUSH Y) )
  (COND
   (A A)
   ((EQ X Y) NIL)                       % Both NIL. Equal.
   (Y 'INSERT)
   (T 'GOON) ) ))               % In order if Y is longer than X.

(XPUSH DEFDIFLIS!*!* '(BIGGFN . BIGGDIF))

(DE BIGGDIF (X Y)
 (OR (BIGGKERN (CAR X) (CAR Y)) (BIGGNDX (CDR X) (CDR Y))))

(DE BIGGNDX (X Y) (SLET (A)
  (WHILE (AND X Y (NOT (SETQ A (BIGGKERN (CAR X) (CAR Y)))))
   (UNPUSH X) (UNPUSH Y) )
  (WHILE (AND X Y) (UNPUSH X) (UNPUSH Y))
  (COND
   ((EQ X Y) A)
   (Y 'INSERT)
   (T 'GOON) ) ))

% Order forms first on indices, then on coefficient.
(DE FORM!-BIGG (X Y)
 (OR (BIGGKERN (CADR X) (CADR Y)) (BIGGNDX (CDDR X) (CDDR Y))
     (BIGGER (CAR X) (CAR Y)) ) )

(DC FACTOR BIGGFN (X Y)
 (OR
  (BIGGTERM (CDR X) (CDR Y))
  (BIGGER (CAR X) (CAR Y)) ) )

(DEFLIST '((QFORM FORM!-BIGG) (FORM FORM!-BIGG) (PLUS BIGGPL)) 'BIGGFN)

(DE BIGGOP (X Y)
 (COND          % Compare operators i.e. ids for equality and order.
  ((EQ X Y) NIL)                        % Equal.
  (NOOPWEIGHT (BIGGID1 X Y))            % Not equal. Compare order.
  (T (BIGGWG X Y)) ))

(DE BIGGWG (X Y)
 (SLET ((XW (GETOPW X)) (YW (GETOPW Y)))
  (COND
   ((IEQN XW YW) (BIGGID1 X Y))
   ((ILESSP XW YW) 'INSERT)
   (T 'GOON) ) ) )

(DE GETOPW (X) (OR (GET X 'OPWEIGHT) 0))

(DEFLIST '((EXP -20) (CONJ -10) (EXPT 2) (TIMES 4) (PLUS 6)) 'OPWEIGHT)

(XPUSH DEFDIFLIS!*!* '(OPWEIGHT . 20))

(DE BIGGID1 (X Y)                       % Compare two non-equal ids.
 (COND
  ((OR (NULL X) (AND Y (BIGGID2 X Y)))
   'INSERT)                     % NIL is ordered before other ids.
  (T 'GOON) ) )         % BIGGID2 is true if X and Y are in order.

(DE BIGGSN1 (X Y) (COND                 % Compare two lisp numbers.
  ((EQN X Y) NIL)
  ((GREATERP X Y) 'INSERT)
  (T 'GOON) ))

(DE SMLESSP (X Y) (EQ (BIGGER X Y) 'GOON))

(DE BIGGID2 (X Y) (COND         % True if ids X and Y are in order.
 (NOLEXORD (ORDERP X Y))                % Arbitrary (fast) order.
 (T (LEXP X Y)) ))                      % Lexical order.

%### BIGGER.SL end
