%### SHIMP2.SL

% Implementation specific code for Sheep, part 2, functions that have
% better be defined after loading the implementation independent code.
% Cambridge University Lisp version.

% This file was created by dividing shcmbl into two parts shimp1 and
% shimp2 to be loaded before and after the bulk of the Sheep code. JEA.

(SETGLOBALS RESIDEFUNCTIONS!*)

% Remove flagging made in the present file.
(NOTLOADTIME (REMFLAG '(BIGGID2 TSTPARSW TSTBIT IDVALUE) 'LOSE))

% Remove flagging made in curat.sl, flags should not be present in
% image. Functions defined in Culisp. JEA.
(REMFLAG '(SNUMP SATOM COPYL COPYA MKRATQ NUMG DENG MKRATN SRATIONALP
        SNUMQ SDENQ SDENP SNUM SFLOATP SFLOAT SADD1 SSUB1 SRECIP
        SPLUS STIMES SPLUS2 SDIFFERENCE SQUOTIENT STIMES2 SMINUSP
        SMINUS SABS SFEXPT SEXPT SFIX SLESSP SGREATERP
% SFRACTION
        IMBAS BIGGSNU BIGGSNRT)
      'LOSE)

% Not needed for Culisp. 
(REMFLAG '(RPLANUM RPLADEN CHKGCD NORM1 SPL2 ARITHP1 STI2 ARITHT1)
      'LOSE)

(SETQ RESIDEFUNCTIONS!* '(RESIDETENSORS))       % For MKSIDEFAP.

(DE RESIDETENSORS (TL) (SLET (X) (COND % Remove compile time tensor def
   ((NULL TL) (CONS TENALIAS!* (COPYT TENSORS)))    % for side module.
   (T (SETQ TENALIAS!* (CAAR TL))
      (SETQ X (SETDIFFQ TENSORS (SETQ TL (CDAR TL))))
      (FOREACH TN IN X DO (UNSET TN)
       (FOREACH Z IN '(HELP TNDEFIL LOSE) DO (REMPROP TN Z)) )
      (SETQ TENSORS TL)
      X) )))

%### SHIMP2.SL end
