%### PRTL.SL

(COMPILETIME (FLAG '(PRTLFFN PRTLOP) 'COMPILE))

(SETLOCALGLOBALS BUF!$ LINP!$ LBRK!$ LPLU!$ LATM!$ PARCN!$)

(SETFLUIDS PRTLFARG!$ CLN!$ TEXMODE)

(ENTRYPOINTS PRTL PRTLF2)

(LOCALFUNCTIONS PINBFA DOPOUTBUF SORTINCAR
 IPRTLF2 PINBFX PRTLINI POUTBUF)

(DE PRTL (PXP) 
 (PRTLINI)
 (COND
  (!*FPRT (FPRTL1 PXP) (PRIN2 REDEOL!*))
  (T (PRTL1 PXP)) )
 (POUTBUF LINP!$) )

(DE PRTLF2 (ST ARGS) (PLET (!*FPRT)
 (PRTLINI)
 (IPRTLF2 ST ARGS)
 (POUTBUF LINP!$) ))

(DE IPRTLF2 (ST PRTLFARG!$)
 (SLET ((A (EXPLODEC ST)))              % JEA
  (WHILE A
   (COND
    ((NOT (EQ (CAR A) '!%)) (PINBFX (CAR A)))
    ((EQ (CAR (UNPUSH A)) '!%) (PINBF (CAR A) NIL))
    ((NULL (SETQ ST (GET (CAR A) 'PRTLFFN)))
     (ERRORFT 510 "Unknown PRTLF code '%w'" (CAR A)) )
    (T (FUNCALL ST)) )
   (UNPUSH A) ) ) )

(DE PINBFX (X) (SLET (FN) (COND
   ((SETQ FN (GET X 'PRTLOP)) (FUNCALL FN X NIL))
   (T (PINBF X NIL)) )))

(DE PRTLFARG () (COND
  ((NULL PRTLFARG!$) (ERRORFT 511 "Missing PRTLF argument"))
  (T (POP PRTLFARG!$)) ))

%:e     In a call to PRTLF (also e.g. ERRORF and WARNINGF) give as
%:e     an argument a string that may contain a percent (%) followed
%:e     by any of the following characters in order to insert 
%:e     the following:
%:e     For: Substitute in:
%:e      %n  New line
%:e      %b  Break-point. Break preferred here if line is too long.
%:e      %u  Up one line
%:e      %d  Down one line
%:e     The following functions will require an extra argument each to
%:e     the call to PRTLF:
%:e      %v  Variable
%:e      %w  Write as formula
%:e      %p  simplest Print
%:e      %e  Evaluate
%:e

(DC !n PRTLFFN () (PNEWLN!.PRTLOP NIL NIL))

(DC !b PRTLFFN () (BREAK!.PRTLOP NIL NIL))

(DC !u PRTLFFN () (UP!.PRTLOP NIL NIL))

(DC !d PRTLFFN () (DOWN!.PRTLOP NIL NIL))

(DC !v PRTLFFN () (PRTL1 (PRTLFARG)))

(DC !w PRTLFFN () (PRTL1 (VALUC (PRTLFARG))))

(DC !p PRTLFFN ()
 (PRTL1 (VALU (COND
    (PSUBS (SUBL1 (COPYL (PRTLFARG)) PSUP))
    (T (COPYL (PRTLFARG))) ))) )

(DC !e PRTLFFN () (EVAL (PRTLFARG)))

(DE PRTLINI ()
 (SLET ((A (LINELENGTH NIL)) (B BUF!$) (C (LENGTH BUF!$)))
  (QTRPRI)
  (REPEATS (MIN A C) (RPLACA (CAR B) NIL) (UNPUSH B))
  (COND
   (B (RPLACD B NIL))
   (T (REPEATS (IDIFFERENCE A C) (XPUSH B (NCONS NIL)))
      (SETQ BUF!$ (NCONC BUF!$ B)) ) )
  (SETQ PARCN!$ PARDEEP!*)
  (SETQ CLN!$ 0)
  (SETQ LINP!$ BUF!$)
  (SETQ LBRK!$ (SETQ LPLU!$ (SETQ LATM!$ NIL))) ) )

(DE PRTL1 (PXP) (COND 
  ((NULL PXP) NIL)
  ((PAIRP PXP) (PRTL2 (CAR PXP) (CDR PXP)))
  (T (PRTL2 PXP NIL)) ))

(DE PRTL2 (PXP PXR) (SLET (FN) (COND
  ((PAIRP PXP) (PRTL2 (CAR PXP) (CDR PXP)) (PRTL1 PXR))
  ((NULL PXP) (PRTL1 PXR))
  ((SETQ FN (IGET PXP 'PRTLOP)) (FUNCALL FN PXP PXR))
  (T (COND ((AND (IZEROP CLN!$) (NOT (EQ LINP!$ BUF!$)))
            (SETQ LATM!$ LINP!$) ))
     (PINBFA PXP) (PRTL1 PXR) ) )))

(PUT UP 'PRTLOP 'UP!.PRTLOP)
(PUT DOWN 'PRTLOP 'DOWN!.PRTLOP)
(PUT BREAK 'PRTLOP 'BREAK!.PRTLOP)
(PUT PNEWLN 'PRTLOP 'PNEWLN!.PRTLOP)

(DE UP!.PRTLOP (DUMMY PXR) (IDECR CLN!$) (PRTL1 PXR))

(DE DOWN!.PRTLOP (DUMMY PXR) (IINCR CLN!$) (PRTL1 PXR))

(DE BREAK!.PRTLOP (DUMMY PXR)
 (COND ((NOT (EQ LINP!$ BUF!$))
        (SETQ LPLU!$ (SETQ LATM!$ NIL)) (SETQ LBRK!$ LINP!$) ))
 (SETQ CLN!$ 0)
 (PRTL1 PXR) )

(DE PNEWLN!.PRTLOP (DUMMY PXR)
 (COND
  ((EQ BUF!$ LINP!$) (TERPRI))
  (T (POUTBUF LINP!$) (SETQ LINP!$ BUF!$)
     (SETQ LBRK!$ (SETQ LPLU!$ (SETQ LATM!$ NIL))) ) )
 (PRTL1 PXR) )

(XDEFLIST PRTLOP (!+ PINPLU) (!- PINPLU))

(DE PINPLU (PXP PXR)
 (COND
  ((IZEROP CLN!$)
   (COND ((ILESSP PARCN!$ 1) (PINBF '!  NIL)))
   (COND 
    ((EQ LINP!$ BUF!$) NIL)
    ((NULL LPLU!$) (SETQ LPLU!$ (LIST (CONS PARCN!$ LINP!$))))
    (T (SLET ((A LPLU!$))
        (WHILE
         (AND (CDR A) (IGREATERP PARCN!$ (CAAR A)))
         (UNPUSH A) )
        (COND
         ((IGREATERP PARCN!$ (CAAR A))
          (RPLACD A (LIST (CONS PARCN!$ LINP!$))))
         (T (RPLACD A NIL) (RPLAD (CAR A) PARCN!$ LINP!$)) ) )) ) %LH
   (SETQ LATM!$ NIL) ) )
 (PINBF PXP NIL)
 (PRTL1 PXR) )

(DC !) PRTLOP (DUMMY PXR)
 (COND ((IZEROP CLN!$) (IDECR PARCN!$)))
 (PINBF '!) NIL) (PRTL1 PXR) )

(DC !( PRTLOP (DUMMY PXR)
 (COND ((NOT (EQ LINP!$ BUF!$)) (SETQ LATM!$ LINP!$)))
 (COND ((IZEROP CLN!$) (IINCR PARCN!$)))
 (PINBF '!( NIL) (PRTL1 PXR) )

(DE FPRTL1 (PXP) (COND
  ((PAIRP PXP) (FPRTL1 (CAR PXP)) (FPRTL1 (CDR PXP)))
  (PXP (FTRPRI 32) (PRIN2 PXP)) ))    % Bugfix. JEA

(DE FTRPRI (X) 
 (COND ((ILESSP (IDIFFERENCE (LINELENGTH NIL) (POSN)) X) (TERPRI))) )

(DE PINBFA (PXP) (FOREACH X IN (EXPLODEC PXP) DO (PINBF X NIL)))

% LINP!$ = Line buffer Pointer into BUF!$ index,
%        = ... (1 . a) ... or ... ((1 . a) (2 . b)) ... Multiple row
%          or (1 a b ...)               Multiple character Overwrite
(DE PINBF (CHR SW) (SLET ((CLN (OR SW CLN!$)) A)
  (COND
   ((OR (NULL CHR) (EQ CHR '! )) NIL)
   ((NULL (CAR (SETQ A (CAR LINP!$)))) (RPLAD A CLN CHR))       % LH
   ((PAIRP (CAR A))
    (RPLACA LINP!$ (SORTINCAR A CLN CHR)) )     % Multiple row index
%  ((EQN (CAR A) CLN) (PRTLOWERWRERR))  % Previously forbidden, now ok:
   ((EQN (CAR A) CLN)           % Multiple character on this position:
    (MKLNCONC1 A CHR) )         % extend to (1 a b c)
   ((ILESSP (CAR A) CLN) (RPLACA LINP!$ (LIST A (CONS CLN CHR))))
   (T (RPLACA LINP!$ (LIST (CONS CLN CHR) A))) )
  (COND ((NOT (OR SW (UNPUSH LINP!$))) (DOPOUTBUF))) ))

(DE MKLNCONC1 (L X) (COND    %:b As NCONC1 but may MaKe L a List first
  ((PAIRP (CDR L))                 % (1 a b) Already before
        (NCONC1 L X) )             % (1 a b c)  -extend
  (T    (RPLACD L                  % (1.a)   Just one character before
         (LIST (CDR L) X) )) ))    % (1 a b)    -rebuild as list.

(DE SORTINCAR (L N X) (COND
  ((ILESSP N (CAAR L)) (CONS (CONS N X) L))
% ((EQN N (CAAR L)) (PRTLOWERWRERR))      % Forbidden before, now ok:
  ((EQN (CAAR L) N)               % Multiple character on this position
   (MKLNCONC1 (CAR L) X) )        % extend to e.g. (1 a b c)
  ((CDR L) (RPLACD L (SORTINCAR (CDR L) N X)))
  (T       (RPLACD L (LIST (CONS N X)))) ))

%(DE PRTLOWERWRERR () (ERRORFT 512 "Overwrite error in PRTL"))

(DE POUTBUF (BUFEND)
 (COND
  (!*FPRT (TERPRI))
  ((NOT (EQ BUFEND BUF!$))
   (SLET ((A BUF!$) (PMAX 0) (PMIN 0) B C D)
    (UNTIL (EQ (UNPUSH A) BUFEND)
     (COND 
      ((PAIRP (SETQ B (CAAR A)))
       (COND ((ILESSP (SETQ B (CAR B)) PMAX) (SETQ PMAX B)))
       (COND ((IGREATERP (SETQ B (CAAR (LASTPAIR (CAR A)))) PMIN)
              (SETQ PMIN B) )) )
      ((NULL B) NIL)
      ((ILESSP B PMAX) (SETQ PMAX B))
      ((IGREATERP B PMIN) (SETQ PMIN B)) ) )
    (COND
     ((AND (OR FITIN (NOT (OR (STDOUTP) NOOFIT)))
       (NOT (IGREATERP LNP!* (IPLUS (IDIFFERENCE (LPOSN) PMAX) PMIN))) )
      (EJECT) ) )
    (FORL N (PMAX PMIN)
     (TERPRI)
     (SETQ A BUF!$) 
     (SETQ C NIL)
     (UNTIL (EQ A BUFEND)
      (COND ((IEQN N (COND
               ((PAIRP (SETQ B (CAAR A))) (CAR B))
               (T B) ))
             (SETQ C A) ))
      (UNPUSH A) )
     (COND (C
            (UNPUSH C)
            (SETQ A BUF!$) 
            (UNTIL (EQ (UNPUSH A) C) 
             (COND
              ((PAIRP (CAR (SETQ B (CAR A))))
               (SETQ D B)
               (SETQ B (CAR B)) )
              (T (SETQ D NIL)) )
             (COND
              ((IEQN N (CAR B))
               (RPLACA B NIL)
              %(COND (D (RPLACA A (COND ((CDR D)) (T B)))))
               (COND (D (RPLACA A (OR (CDR D) B)))) %LH
               (COND
                ((PAIRP (UNPUSH B))
                 (UNTIL (NULL (UNPUSH B)) (PRINC (CAR B))) )
                (T (PRINC B)) ) )
              (T (PRINC '! )) ) ) )) )
    (OR TEXMODE (TERPRI)) ) ) ))

% Default altered and new switches added. JEA.
(NEWSWITCHES
 (ENDPLUS "Print + at end of line if formula is to be continued")
 (ENDSIGN "Print sign at end of line if formula is to be continued"))

(DE DOPOUTBUF ()
 (SLET (A PLSW PLPARCN MSW)
  (SLET ((BUFEND
          (COND 
           (LBRK!$ LBRK!$)
           (LPLU!$ (SETQ PLSW (CDAR LPLU!$)))
           (LATM!$ LATM!$) )))
   (POUTBUF
    (COND
     (PLSW
      (SETQ PLPARCN (CAAR BUFEND))      % Bugfix. JEA
      (COND
       ((AND (OR ENDPLUS ENDSIGN) (NOT TEXMODE))
        %:LH No sign at line end for TEXMODE
        (COND
         ((AND (EQ (CDAR BUFEND) '!-) ENDPLUS)
          (SETQ MSW (RPLACD (CAR BUFEND) '!+)) ) )
        (CDR BUFEND) )
       (T BUFEND) ) )
     (T BUFEND) ) )
   (COND
    (LBRK!$ (SETQ LBRK!$ NIL))
    (LPLU!$ (UNPUSH LPLU!$))
    (LATM!$ (SETQ LATM!$ NIL)))
   (SETQ LINP!$ BUF!$)
   (COND (BUFEND
          (SETQ A BUF!$)
          (WHILE (NOT (EQ BUFEND (CDR A))) (UNPUSH A))
          (RPLACD A NIL)
          (COND (PLSW (RPLACA (CAR BUFEND) PLPARCN)))   % Bugfix. JEA
          (COND (MSW (RPLACD (CAR BUFEND) '!-)))
          (SETQ BUF!$ (NCONC BUFEND BUF!$)) )) ) ) )

(XDEFLIST PRTLOP
 (PRTLCHOVER APPLY) (PRTLCHUNDER APPLY) (PRTLCHREL APPLY) )

(DE PRTLCHOVER (CH X) (PRTLCHREL CH -1 X))
 
(DE PRTLCHUNDER (CH X) (PRTLCHREL CH 1 X))
 
(DE PRTLCHREL (CH N X)
 (SETQ N (IPLUS N CLN!$))
 (FOREACH Y IN (EXPLODEC X) DO (PINBF CH N) (PINBF Y NIL)) )

%### PRTL.SL end
