%### SSIMP.SL

% Sheep Simplification functions. Module formerly called SIMP.

(NEWSWITCHES
 (FACOUT "(EXPERIMENTAL) Factor out lowest common factor")
 (FACIN  "(EXPERIMENTAL) Multiply back factor") )

(SETLOCALGLOBALS
 ((XX!$S (NCONS NIL))) ((YY!$S (NCONS NIL))) ((ZZ!$S (NCONS NIL))) )

(SETFLUIDS FACLIS!$)

% SSIMP, Sheep simplification. Formerly called SIMP.
(DE SSIMP (SXP) (COND (NOSIMP SXP) (T (SIMPE (SIMP1 SXP)))))

% This SIMPE used to be buggy, actual bug in subl1.shp. Would e.g.
% not do RIE for melnic.nul (where MSUBS is used). Seem to be ok
% after fixing bug in SUBL2L. JEA.
(DE SIMPE (SXP) (PROGN
  (COND (SUBS (SETQ SXP (SUBL1 SXP SUBS))))
  (COND (POTSIM (SETQ SXP (SIMP2 SXP))))
  (COND (ESUBS (SETQ SXP (SUBL1 SXP ESUP))))
  (COND (MSUBS (SETQ SXP (SUBL1 SXP MSUP))))
  SXP))

% Test version, circumvented bug mentioned above.
(COMMENT
(DE SIMPE (SXP) (PROGN
  (COND (SUBS (SETQ SXP (SUBL1 SXP SUBS))))
  (COND (POTSIM (SETQ SXP (SIMP2 SXP))))
  (COND (ESUBS (SETQ SXP (SUBL1 SXP ESUP))))
% (COND (MSUBS (SETQ SXP (SUBL1 SXP MSUP))))
  (COND (MSUBS
         (SLET ((MCU SUBMTIMES!*))
          (UNTIL (OR (NOT !*!*SUBSTW) (IZEROP (IDECR MCU)))
           (SETQ SXP (SUBL1 SXP MSUL)) ) ) ))
  SXP)) )

(COMMENT
(DE SIMPE (SXP) (PROGN
  (COND (FACOUT (SETQ SXP (OUTFAC SXP))))
  (COND (SUBS (SETQ SXP (SUBL1 SXP SUBS))))
  (COND (POTSIM (SETQ SXP (SIMP2 SXP))))
  (COND (ESUBS (SETQ SXP (SUBL1 SXP ESUL))))
  (COND ((AND FACIN (EQCAR SXP 'FACTOR))
         (SETQ SXP (SMTIMES2 (CADR SXP) (CADDR SXP))) ))
  (COND (MSUBS
         (SLET ((MCU SUBMTIMES!*))
          (UNTIL (OR (NOT !*!*SUBSTW) (IZEROP (IDECR MCU)))
           (SETQ SXP (SUBL1 SXP MSUL)) ) ) ))
  SXP)) )

(DE SIMP1 (SXP) (XED (ZERM SXP)))

(DE XED (SXP) (SLET ((A SXP) B) (COND 
   ((SATOM SXP) SXP)
   ((EQ (CAR SXP) 'PLUS)
    (FOREACH X IN (CDR SXP) REPLACE (XED X))
    (SMPLUSL SXP) )
   ((EQ (CAR SXP) 'TIMES)
    (WHILE (AND (UNPUSH A) (NOT (AZEROP (SETQ B (XED (CAR A))))))
     (RPLACA A B) )
    (COND
     (A 0)
     (T (SMTIMESL SXP)) ) )
   ((SETQ B (IGET (CAR SXP) 'SHSMPFN)) (FUNCALL B SXP))
   (T SXP) )))

(DE ZERM (SXP) (COND 
  ((SATOM SXP) SXP)
  ((EQ (CAR SXP) 'PLUS)
   (FOREACH X IN (CDR SXP) REPLACE (ZERM X))
   (RID0RT SXP) )
  ((NOT (EQ (CAR SXP) 'TIMES)) SXP)
  ((AMEMQ 0 (CDR SXP)) 0)
  (T (SLET ((A SXP) B)
      (WHILE (AND (UNPUSH A) (NOT (AZEROP (SETQ B (ZERM (CAR A))))))
       (RPLACA A B) )
      (COND
       (A 0)
       (T (RIDRT SXP 1)) ) )) ))

(DE RIDRT (SXP MASK) 
 (COND 
  ((NULL (CDR (DELQIP MASK SXP))) MASK)
  ((CDDR SXP) SXP)
  (T (CADR SXP)) ) )

(DE RID0RT (SXP) (RIDRT SXP 0))

(DE OUTFAC (SXP) (PROG (FACLIS!$ OFAC TMP)
  (COND
   ((EQCAR SXP 'FACTOR) (SETQ OFAC SXP) (SETQ SXP (CADDR SXP)))
   ((NOT (EQCAR SXP 'PLUS)) (RETURN SXP)) )
  (SETQ FACLIS!$ (NCONS NIL))
  (FOREACH X IN (CDR SXP) DO (CHKFACL (COND
     ((NOT (EQCAR X 'TIMES)) (RPLACA XX!$S X))
     ((SNUMP (CADR X)) (CDDR X))
     (T (CDR X)) )))
  (FOREACH X IN (CDR FACLIS!$) REPLACE
   (FOREACH Y IN (CDR X) REPLACE (COND
     ((AZEROP (CAR Y)) 0)
     ((NULL (CDR Y)) (CAR Y))
     ((AND (AONEP (CAR Y)) (NULL (CDR (SETQ Y (CDR Y)))))
      (COPYL (CAR Y)) )
     (T (CONS 'TIMES (COPYA Y))) ))
   (COND
    ((NULL (SETQ TMP (DELQIP 0 (CDR X)))) 1)
    ((CDR TMP) (CONS 'EXPT (RPLACD X (NCONS (CONS 'PLUS TMP)))))
    ((AONEP (CAR TMP)) (COPYL (CAR X)))
    (T (CONS 'EXPT (RPLACD X TMP))) ) )
  (DELQIP 1 FACLIS!$)
  (RETURN (COND
    ((NULL (CDR FACLIS!$)) (OR OFAC SXP))
    (T (COND
        ((CDDR FACLIS!$) (RPLACA FACLIS!$ 'TIMES))
        (T (SETQ FACLIS!$ (CADR FACLIS!$))) )
       (SETQ SXP (SMTIMES2 (SMEXPT (COPYL FACLIS!$) -1) SXP))
       (COND
        (OFAC (RPLACA (CDDR OFAC) SXP)
              (RPLACA (CDR OFAC) (SMTIMES2 (CADR OFAC) FACLIS!$))
              OFAC)
        (T (LIST 'FACTOR FACLIS!$ SXP)) ) ) )) ))
 
(DE CHKFACL (TERM) (SLET ((YY FACLIS!$) XE Y SW)
  (FOREACH XB IN TERM DO
   (COND
    ((EQCAR XB 'EXP) (SETQ XE (CADR XB)) (SETQ XB '(EXP)))
    ((EQCAR XB 'EXPT) (SETQ XE (CADDR XB)) (SETQ XB (CADR XB)) )
    (T (SETQ XE 1)) )
   (COND
    ((EQCAR XE 'PLUS) (SETQ XE (CDR XE)))
    (T (SETQ XE (RPLACA YY!$S XE))) )
   (WHILE
    (AND (SETQ Y (CDR YY)) (EQ (SETQ SW (BIGGKERN XB (CAAR Y))) 'GOON))
    (SETQ YY Y) )
   (COND
    ((OR (NULL Y) SW) (RPLACD YY (CONS
       (CONS XB (FOREACH Z IN XE COLLECT (COND
          ((SNUMP Z) (NCONS Z))
          ((NOT (EQCAR Z 'TIMES)) (LIST 1 Z))
          ((SNUMP (CADR Z)) (CONS (CADR Z) (CDDR Z)))
          (T (CONS 1 (CDR Z))) )))
       Y))
     (UNPUSH YY) )
    (T (FOREACH Z IN XE DO (CHKFCEXP (CAR Y) Z))) ) ) ))
    
(DE CHKFCEXP (YE Z) (SLET ((ZN 1) Y SW)
  (COND
   ((SNUMP Z) (SETQ ZN Z) (SETQ Z NIL))
   ((NOT (EQCAR Z 'TIMES)) (SETQ Z (RPLACA ZZ!$S Z)))
   ((SNUMP (CADR Z)) (SETQ ZN (CADR Z)) (SETQ Z (CDDR Z)))
   (T (SETQ Z (CDR Z))) )
  (WHILE
   (AND (SETQ Y (CDR YE)) (EQ (SETQ SW (BIGGTERM Z (CDAR Y))) 'GOON))
   (COND ((SLESSP 0 (CAAR Y)) (RPLACA (CAR Y) 0)))
   (SETQ YE Y) )
  (COND
   ((OR (NULL Y) SW)
    (COND ((EQ Z ZZ!$S) (SETQ Z (NCONS (CAR ZZ!$S)))))
    (RPLACD YE (CONS (CONS ZN Z) Y))
    (UNPUSH YE) )
   ((SLESSP ZN (CAAR Y)) (RPLACA (CAR Y) ZN)) ) ))

%### SSIMP.SL end
