%### XRANK.SL

(SETFLUIDS XRANK!$ UINDXL!$ !$UINDL)

(LOCALFUNCTIONS XRANK1 XRANKNOSYM MNOSYMP XRANK1AT UPDRNK SYMSPECERR)

(DEFLIST '((NOSYM 0) (SYM 1) (ASYM 2) (HSYM 3)) 'ISYMTYP)

(DEFLIST 
 '((D (NOSYM 1)) (S (SYM 2)) (A (ASYM 2)) (H (HSYM 2))
   (R (SYM (ASYM 2) (ASYM 2))))
 'LSYMTYP)

(DS SYMTYP (X Y) (PUT 'X 'SYMTYP 'Y))

(FLAG '(SYMTYP) 'EVAL)

(DE XRANK (LIML INDXL!*)
 (SLET (!$UINDL UINDXL!$ (XRANK!$ 0) A B)
  (COND ((EQ LIML 'SCL) (SETQ LIML NIL)))
  (COND
   (LIML (SETQ LIML (XRANKNOSYM (LIST LIML))))
   (INDXL!* (SETQ LIML (XRANKNOSYM (LIST (LENGTH INDXL!*))))) )
  (COND (INDXL!* (SETQ XRANK!$ (LENGTH INDXL!*))))
  (COND ((AND (PAIRP !$UINDL) (NOT (EQ INDXL!* !$UINDL)))
         (SETQ A (IDIFFERENCE (LENGTH INDXL!*) (LENGTH !$UINDL)))
         (COND                  % Missing A indices in the beginning.
          ((FIXP LIML) (SETQ LIML (LIST 'NOSYM (IPLUS LIML A))))
          ((NOT (EQCAR LIML 'NOSYM)) (SETQ LIML (LIST 'NOSYM A LIML)))
          ((FIXP (CADR LIML)) (RPLACA (CDR LIML) (IPLUS A (CADR LIML))))
          (T (RPLACD LIML (CONS A (CDR LIML)))) )))
  (COND (UINDXL!$
         (SETQ A (LENGTH UINDXL!$)) % Missing A indices at the end.
         (COND
          ((FIXP LIML) (SETQ LIML (LIST 'NOSYM (IPLUS LIML A))))
          ((NOT (EQCAR LIML 'NOSYM)) (SETQ LIML (LIST 'NOSYM LIML A)))
          ((FIXP (CAR (SETQ B (LASTPAIR LIML))))
           (RPLACA B (IPLUS A (CAR B))) )
          (T (RPLACD B (LIST A))) ) ))
  (CONS XRANK!$ LIML) ) )

(DE XRANK1 (LIML) 
 (COND 
  ((IDP LIML) (XRANK1 (XRANK1AT LIML)))
  ((FIXP LIML)
   (COND (INDXL!*                       % No INDXL!* means don't check.
          (COND
           ((NULL !$UINDL) (SETQ !$UINDL T) (SETQ UINDXL!$ INDXL!*)) )
          (COND
           ((LESSP (LENGTH UINDXL!$) LIML)
            (ERRORFT 536
    "Index list %r gives smaller rank than the symmetry specification"
                    INDXL!*) )
           (T (SETQ UINDXL!$ (CNDR UINDXL!$ LIML))) ) ))
   (SETQ XRANK!$ (PLUS XRANK!$ LIML))
   LIML)
  ((NOT (PAIRP LIML)) (SYMSPECERR LIML))
  ((EQ (CAR LIML) 'DIM)
   (LIST 'DIM (CADR LIML) (XRANKNOSYM (CDDR LIML))) )
  ((EQ (CAR LIML) 'NOSYM) (XRANKNOSYM (CDR LIML)))
  ((NOT (IGET (CAR LIML) 'ISYMTYP)) (SYMSPECERR LIML))
  ((CDDR LIML)
   (FOREACH X IN (CDR LIML) REPLACE (COND
     ((MNOSYMP (SETQ X (XRANK1 X))) X)
     (T (LIST 'NOSYM X)) ))
   LIML)
  ((MNOSYMP (CAR (RPLACA (CDR LIML) (XRANK1 (CADR LIML)))))
   (SYMSPECERR LIML) )
  (T LIML) ) )

(DE XRANKNOSYM (LIML)
 (SLET ((A (LIST 'NOSYM)) (B A))
  (FOREACH X IN LIML DO
   (SETQ X (COND
     ((EQCAR (SETQ X (XRANK1 X)) 'NOSYM) (CDR X))
     (T (LIST X)) ))
   (COND ((AND (NUMBERP (CAR X)) (NUMBERP (CAR A)))
          (RPLACA A (IPLUS (CAR A) (CAR X)))
          (UNPUSH X) ))
   (RPLACD A X)
   (SETQ A (LASTPAIR A)) )
  (COND 
   ((OR (CDDR B) (NOT (MNOSYMP (CADR B)))) B)
   (T (CADR B)) ) ) )

(DE MNOSYMP (X) (OR (AONEP X) (PAIRP X)))

(DE XRANK1AT (LIML)
 (SLET ((A (MEMQ LIML INDXL!*)) B C D)
  (COND
   (A
    (COND
     ((NOT !$UINDL) (SETQ !$UINDL (SETQ UINDXL!$ A)))
     ((NOT (EQCAR LIML UINDXL!$)) (SYMSPECERR LIML)) )
    1)
   ((SETQ D (IGET LIML 'SYMTYP)) D)
   (T (FOREACH X IN (EXPLODE LIML) DO (COND
        ((DIGIT X) (XPUSH B X))
        (T (COND (B (UPDRNK B C LIML) (SETQ B NIL)))
           (COND ((NULL (SETQ C (GET X 'LSYMTYP))) (SYMSPECERR LIML)))
           (XPUSH A (SETQ C (COPY C)))
           (SETQ C (COND
             ((EQCAR C 'DIM) (CDADDR C))
             (T (CDR C)) )) ) ))
      (COND (B (UPDRNK B C LIML)))
      (CONS 'NOSYM (REVERSIP A)) ) )))

(DE UPDRNK (B C LIML)
 (COND ((NOT (AND C (FIXP (CAR C)))) (SYMSPECERR LIML)))
 (RPLACA C (MAKEINT (REVERSIP B) 10)) )

(DE SYMSPECERR (LIML)
 (ERRORFT 537 "Incorrect symmetry specification %r" LIML) )

%### XRANK.SL end
