%### EXFN1.SL =======================================================
%
%       EXFN1.SL
%       --------
%
%       Copyright (c) 1991 by Jan E. Aman, Institute of Theoretical
%       Physics, University of Stockholm, Vanadisvagen 9,
%       S-113 46  Stockholm, Sweden.
%
%       This file contains some changes to EXFN1I.SL that adapts it to
%       Common Lisp.
%
%====================================================================

(SETQ !!MACEXPD NIL)

% Use the following command to force the use of Sheep macro expansion.
% (SETQ !!MACEXPD T)

% Defined as in exfn1i, defined here as it is needed for bootstrap.
(DM IFP (BODY)
 (CONS 'IF (CDR BODY)))

% (COPYD 'MACEXPD 'MACROEXPAND)
(IFP (NOT (GETD 'MACEXPD))
 (PUTD 'MACEXPD 'EXPR (CDR (GETD 'MACROEXPAND))) )

%(IFP (NOT (GETD 'WARNINGFT))
% (EVAL (PROGN
%   (DM WARNINGFT (U)
%    (LIST 'WARNINGFTPRI (CADR U) (CADDR U) (CONS 'LIST (CDDDR U))) )
%   (DE WARNINGFTPRI (PR ST AR) (PRINT (CONS PR (CONS ST AR))))
%   NIL )) )

(GLOBAL '(PSLPA1FN PA1))

% Called PA1FN in PSL version 3.2 and 3.2A, called PASS!-1!-FUNCTION
% in PSL version 3.4. Test can be used only if compiler is loaded.
(SETQ PSLPA1FN (IFP (GET 'COND 'PA1FN) 'PA1FN 'PASS!-1!-FUNCTION))

% Called !&PA1 in PSL version 3.2 and 3.2A, probably what is
% called RECURSIVE!-PASS!-1 in PSL version 3.4.
% Test can be used only if compiler is loaded.
(SETQ PA1 (IFP (GET 'COND 'PA1FN) '!&PA1 'RECURSIVE!-PASS!-1))

(DE CMPA1 (X VBLS) (PROG (Y)
  (SETQ Y (APPLY (GET (CAR X) 'COMPILERMACRO) (LIST X)))
  (COND
   ((EQUAL Y X)
    (REMPROP (CAR X) PSLPA1FN)
    (SETQ Y  (APPLY PA1 (LIST Y VBLS)))
    (PUT (CAR X) PSLPA1FN 'CMPA1) )
   (T
    (SETQ Y (APPLY PA1 (LIST Y VBLS))) ) )
  (RETURN Y) ))

%(COPYD 'MOVD 'COPYD)

%(MOVD 'ASCII 'INT2ID)

% Redefinition of DE and DM to make it call PUTD as it should in Standard
% Lisp. The purpouse is to make it look for the LOSE flag. JEA
(DM DE (U)
 (LIST 'PUTD (LIST 'QUOTE (CADR U)) '(QUOTE EXPR)
  (LIST 'QUOTE (CONS 'LAMBDA (CONS (CADDR U) (CDDDR U)))) ) )

(DM DM (U)
 (LIST 'PUTD (LIST 'QUOTE (CADR U)) '(QUOTE MACRO)
  (LIST 'QUOTE (CONS 'LAMBDA (CONS (CADDR U) (CDDDR U)))) ) )

(FLAG '(XCOND) 'LOSE)                   % Not needed.
%(FLAG '(MKQUOTE EQCAR ATSOC REVERSIP NCONS XCONS)
%      'LOSE)                           % Defined in Bare PSL.
(FLAG '(FUNCALL BOUNDP) 'LOSE)          % Defined in Common Lisp.
(IFP !!MACEXPD NIL
 (FLAG
  '(MACEXPD MACEXPDL1 MACEXPDL MACEXPDCOND MACEXPDPRG)
%      MACEXPD1
  'LOSE) )
(FLAG '(CMMACRO
%       IFP PUTD ERRORFT DFEXPR
        LOCALFUNCTIONS DECLAREFEXPR)    % Dirty fix.
%       ADDHLP
%       MOVD
 'LOSE)                                 % Defined in this file.

(INCLUDE "../exfn1i.sl")

(REMFLAG '(XCOND) 'LOSE)                % Not needed.
%(REMFLAG '(MKQUOTE EQCAR ATSOC REVERSIP NCONS XCONS)
%         'LOSE)                        % Defined in Bare PSL.
(REMFLAG '(FUNCALL BOUNDP) 'LOSE)       % Defined in Common Lisp.
(IFP !!MACEXPD NIL
 (REMFLAG
  '(MACEXPD MACEXPDL1 MACEXPDL MACEXPDCOND MACEXPDPRG)
%      MACEXPD1
  'LOSE) )
(REMFLAG '(CMMACRO
%       IFP PUTD ERRORFT DFEXPR
        LOCALFUNCTIONS DECLAREFEXPR)    % Dirty fix.
%       ADDHLP
%       MOVD
 'LOSE)                                 % Defined in this file.

%(IFP !!MACEXPD NIL
% (REMPROPL '(COND LAMBDA PROG QUOTE GO) 'MACEXPDFN) )
% COND, LAMBDA and PROG have got a MACROEXPAND!-FUNC in PSL,
% QUOTE and GO haven't got any.

(DMACRO CMMACRO (FN ARGS !&REST BODY)
  (LIST 'CPROGN
    (LIST 'DPUT FN PSLPA1FN 'CMPA1)
    (!$MACFEX FN ARGS BODY 'COMPILERMACRO) ))

% Must have one arg that is bound to list of args.
(FLAG '(COMPILERMACRO) 'FNARY)

% COMPILERMACROs have better be compiled.
(NOTLOADTIME (FLAG '(COMPILERMACRO) 'COMPILE))

(FLAG '(COMPILERMACRO) 'MACROARG)       % First arg is function name.

(DMACRO DFEXPR (FN ARGS !&REST BODY)
  (SLET ((EXPR!-NAME (CONCATID FN '!-EXPR))
         (MFEX (!$MACFEX FN ARGS BODY 'FEXPR)) )
    (LIST 'CPROGN
      (!$MACFEX FN '(!&REST X)
         (NCONS (LIST 'LIST (MKQUOTE EXPR!-NAME) '(MKQUOTE X)))
         'MACRO)
      (LIST 'COND
        (LIST (LIST 'NOT (LIST 'FLAGP (MKQUOTE FN) ''LOSE))
          (LIST (CAR MFEX) (MKQUOTE EXPR!-NAME) ''EXPR (CADDDR MFEX)) )))))

(DMACRO LOCALFUNCTIONS (!&REST L)  %:LH accumulate functions to remob
  (LENGTH (SETQ LOCALFUNCTIONS!* (UNIONQ LOCALFUNCTIONS!* L))) ) % JEA

(DMACRO DECLAREFEXPR (!&REST L)
 (FOREACH X IN L DO (PUT X 'CFNTYPE '(FEXPR))) )

% This is for the HELP in module HELP of PSL. Not complete.
%(DE ADDHLP (HLPLIS FN HLP)
%  (SLET ((EVHLPLIS (EVAL HLPLIS)))
%    (COND
%      ((AND HLPLIS (NOT (MEMQ FN EVHLPLIS)))
%       (SET HLPLIS (NCONC EVHLPLIS (LIST FN))) ))
%    (COND
%     ((STRINGP HLP) (PUT FN 'HELPSTRING HLP))
%     (HLP (PUT FN 'HELPFUNCTION HLP)) ) ) )

(DMACRO TRA (!&REST L) (CONS 'TRACE L))
(DMACRO UNTRA (!&REST L) (CONS 'UNTRACE L))

(DMACRO PRETTYPRINT (!&REST L) (CONS 'PPRINT L))

(SETQ !*PRINT-LENGTH!* NIL)
(SETQ !*PRINT-LEVEL!* 10)

% It is important to define GRIND very early.
(DE GRIND (AT!&)
 (PROG (PR!&)
  (TERPRI)
% (MLOAD 'PP)   % Needed only if pp.b is not found in pl:
  (COND
   ((NOT (IDP AT!&)) (ERRORFT 437 "%p is not an identifier" AT!&))
   ((SETQ PR!& (GETD AT!&))
    (PRIN2 "FnDef: ") (TERPRI) (PRETTYPRINT PR!&) ))
  (COND
   ((BOUNDP AT!&)
    (PRIN2 "Value: ") (TERPRI) (PRETTYPRINT (EVAL AT!&)) ))
  (TERPRI) (PRIN2 "Plist of ") (PRIN2 AT!&)
  (COND
   ((NOT (SETQ PR!& (SYMBOL!-PLIST AT!&)))
    (PRIN2 " is empty") (TERPRI) (TERPRI) )
   (T (PRIN2 " :") (TERPRI)
    (FOREACH PA!& IN (SYMBOL!-PLIST AT!&) DO 
     (COND
      ((NOT (PAIRP PA!&))
       (PRIN1 AT!&) (PRIN2 " flagged ") (PRIN1 PA!&) (TERPRI) )
      ((NOT (MEMQ (CAR PA!&) '(!*LAMBDALINK TYPE)))
       (PRETTYPRINT PA!&) ) ) ) ) ) ))

%### EXFN1.SL end
