%### EXINT.SL =======================================================
%
%       EXINT.SL
%       --------
%
%       Copyright (c) 1992 by Jan E. Aman, Institute of Theoretical
%       Physics, University of Stockholm, Vanadisvagen 9,
%       S-113 46  Stockholm, Sweden
%
%       This file contains some changes to EXINTI.SL that adapts it to
%       Codemist Standard Lisp (CSL).
%
%====================================================================

(FLAG '(PROG1) 'LOSE)             % Defined in CSL.
% Defined in the present file.
(FLAG
 '(REEVALFORM ERRSET MAPRPLC MAPRPL REPEATS WHILE UNTIL XCASE)
 'LOSE)

(INCLUDE "../exinti.sl")

(REMFLAG
 '(REEVALFORM ERRSET MAPRPLC MAPRPL REPEATS WHILE UNTIL XCASE)
 'LOSE)

(DMACRO REEVALFORM (!&REST L) (MKERRFORM L))

(DMACRO ERRSET (BODY SW) (SLET ((N (GENSYM)))
  (LIST 'PLET (LIST (LIST '!*ERRMSG SW))
   (LIST 'SLET
    (LIST (LIST N (LIST 'ERRORSET (MKERRFORM BODY)
                        (LIST 'AND '!*ERRDEBUG '!*ERRMSG)
                        (LIST 'AND '!*ERRDEBUG '!*BACKTRACE) )))
    (CONSA 'COND
     (LIST (LIST 'AEQN N 739) '(ERROR 739 EMSG!*))
     (NCONC1
      (COND
       ((NULL SW) NIL)
       (T (LIST (LIST
            (LIST 'AND '!*ERRMSG (LIST 'ATOM N))
             (LIST 'ERRORSET
              (LIST 'LIST '(QUOTE ERROR)
                           (LIST 'MKQUOTE N) '(QUOTE EMSG!*) )
              '!*ERRMSG '!*BACKTRACE) ))) )
      (LIST 'T N) ) ) ) ) ))

(DMACRO ERRSET (BODY SW) (LIST
  (LIST 'LAMBDA '(!*ERRMSG SFER!&)
   (LIST 'UNBINDSFSTKS 'SFER!&
    (LIST 'ERRORSET (MKERRFORM BODY) '!*ERRMSG
     '(AND !*ERRMSG !*BACKTRACE) ) ) )
  SW '(CAPTURESFSTKS) ))

(DMACRO MAPRPLC (L FN) (MAPR!$FN L FN T))

(DMACRO MAPRPL (L FN) (MAPR!$FN L FN NIL))

(DMACRO REPEATS (C !&REST BODY) (SLET ((A (GENSYM)))
  (LIST 'PROG (LIST A)
      (LIST 'SETQ A C)
 'LAB (LIST 'COND (LIST (LIST 'XMINUSP (LIST 'XDECR A)) '(RETURN NIL)))
      (CONS 'PROGN BODY)
      '(GO LAB) ) ))

(DMACRO WHILE (TST !&REST BODY)
 (CONSA
  'PROG '()
   '(GO LAB2)
   'LAB1
   (APPEND BODY
    (LIST 'LAB2 (LIST 'COND (LIST TST '(GO LAB1)))) ) ) )

(DMACRO UNTIL (TST !&REST BODY)
 (CONSA 'PROG '()
  'LAB
  (APPEND1 BODY
   (COND
     (TST (LIST 'COND (LIST (LIST 'NOT TST) '(GO LAB))))
     (T '(GO LAB)) )) ) )

% XCASE is called as XCASE(X,Z,Y(0),Y(1),...,Y(n)).
% If the value of X is an integer in the range 0:n then Y(X) is
% evaluated, otherwise Z is evaluated.
% The interpreted version is as follows:
%(MACRO XCASE (CS D !&REST L)
% (PLET ((A (EVAL CS)))
%  (COND
%   ((AND (FIXP  A) (SETQ A (CNDR L A))) (CAR A))
%   (T D) ) ) )
% The following definition of XCASE will work, but it is much better
% if the compiler knows how to handle XCASE and produces a jump-table.
(DMACRO XCASE (CS D !&REST L) (SLET ((N -1) SW TMP)
  (COND ((NOEVAGAINP CS) (SETQ SW CS) (SETQ CS 'XCASE!*!$ARG)))
  (SETQ TMP (CONS 'COND
    (NCONC1
     (FOREACH X IN L COLLECT
      (LIST (LIST 'AEQN CS (SETQ N (XADD1 N))) X) )
     (LIST 'T D) ) ))
  (COND
   (SW (LIST 'PROGN (LIST 'SETQ CS SW) TMP))
   (T TMP) ) ))

(FLAG
 '(REEVALFORM ERRSET MAPRPLC MAPRPL REPEATS WHILE UNTIL XCASE)
 'LOSE)

(INCLUDE "../excomi.sl")

% Defined in the present file.
(REMFLAG
 '(REEVALFORM ERRSET MAPRPLC MAPRPL REPEATS WHILE UNTIL XCASE)
 'LOSE)
(REMFLAG '(PROG1) 'LOSE)          % Defined in CSL.

%### EXINT.SL end
