%### INCLDE.SL ======================================================
%
%       INCLDE.SL
%       ---------
%
%       Copyright (c) 1992 by Jan E. Aman, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden
%
%       This file defines a temporary version of INCLUDE that is
%       needed for bootstrapping.
%
%====================================================================

(FLUID '(!*IPRN !*ECHO))

(SETQ !*IPRN T)         % INCLUDE normally prints out.

% This definition of INCLUDE is temporary, to be used in bootstrapping.
% See LOAD.SL for the final definition.

(DM INCLUDE (U) (LIST 'IINCLUDE (LIST 'QUOTE (CDR U))))

(DE IINCLUDE (U)
 (PROG (OLDCH Y X W)
  (SETQ U (CAR U))
  (SETQ OLDCH (RDS (OPEN U 'INPUT)))
  (TERPRI) (PRINC "Including file: ") (PRINC U) (TERPRI)
NEXTRD
  (SETQ Y (READ))
  (COND
   ((EQ Y !$EOF!$)
    (CLOSE (RDS OLDCH))
    (TERPRI) (PRINC U) (PRINC " done include") (TERPRI)
    (RETURN "Finished loading") )
   ((NOT (PAIRP (SETQ X (ERRORSET Y T))))
    (COND ((NOT !*ECHO) (PRINT Y)))
    (ERROR 440 "Error return") )
   (!*IPRN (PRINT (CAR X))) )
  (GO NEXTRD) ))

%### INCLDE.SL end
