%### EXFN1.SL =======================================================
%
%       EXFN1.SL
%       --------
%
%       Copyright (c) 1993 - 2011 by Jan E. Aman,
%       Department of Physics, Stockholm University,
%       SE-106 91  Stockholm, Sweden.
%
%       This file contains some changes to EXFN1I.SL that adapts it to
%       Codemist Standard Lisp (CSL).
%
%====================================================================

(FLUID '(HLPLIS!* !*NOCHECK))   % Declared fluid in exfn1i.sl as well.
%(FLUID '(UNSET!_VAR)) We have better not.

% Defined as in exfn1i, defined here as it is needed for bootstrap.
(DM IFP (U!&)
 (COND
  ((EVAL (CADR U!&)) (CADDR U!&))
  ((CDDDR U!&) (CADDDR U!&)) ))

% This is for Atari only, check of function calls to costly.
(IFP (GETD 'EDIT) (SETQ !*NOCHECK T))

% DMACRO defined after include of exfn1i.sl.

(FLAG '(COMPILERMACRO) 'MACROARG)

% Redefinition of DE and DM to make it call PUTD as it should in
% Standard Lisp. The purpose is to make it look for the LOSE flag. JEA
% CSL forbidds redefinition of DE and DM. JEA
%(DM DE (U)
% (LIST 'PUTD (LIST 'QUOTE (CADR U)) '(QUOTE EXPR)
%  (LIST 'QUOTE (CONS 'LAMBDA (CONS (CADDR U) (CDDDR U)))) ) )

%(DM DM (U)
% (LIST 'PUTD (LIST 'QUOTE (CADR U)) '(QUOTE MACRO)
%  (LIST 'QUOTE (CONS 'LAMBDA (CONS (CADDR U) (CDDDR U)))) ) )

% PUTC defined after include of exfn1i.sl.

% The following are defined in CSL.
(FLAG
 '(BOUNDP EQCAR ATSOC NCONS XCONS FUNCALL REVERSIP)
 'LOSE )

(FLAG '(XCOND DE) 'LOSE) % Not needed. IPUTC

(GLOBAL '(COMPFLGSTK!*))  % Fix 2010 JEA

% The following have been defined in this file.
(FLAG
 '(IFP
%  MACEXPD1 XPUSH ERRORFT DMACRO !$MACFEX MOVD
   FOLDCASE
%  CONCATID
   CMMACRO
%  DFEXPR                               % Dirty fix.
   PUTC         % Should be flagged lose but this will cause trouble.
   COMPILETIME DECLAREFEXPR)
 'LOSE )

(INCLUDE "../exfn1i.sl")

% The following are defined in CSL.
(REMFLAG
 '(BOUNDP EQCAR ATSOC NCONS XCONS FUNCALL REVERSIP)
 'LOSE )

(REMFLAG '(XCOND DE) 'LOSE)     % IPUTC

(REMFLAG
 '(IFP
%  MACEXPD1 XPUSH ERRORFT DMACRO !$MACFEX MOVD
   FOLDCASE
%  CONCATID
   CMMACRO
%  DFEXPR
   PUTC         % Should be flagged lose but this will cause trouble.
   COMPILETIME DECLAREFEXPR)
 'LOSE )

% Remove compiler information refering to the byggy version.
%(REMPROP 'BOUNDP 'S!:BUILTIN1)

% FOLDCASE(SW:boolean,[SXPR:form]):any
% Evaluate all SXPR while character folding status temporarily is set
% to SW.
(DS FOLDCASE (SW !&REST L) (PLET ((!*LOWER SW)) . L))

%(DE PUTD (X Y Z)
% (COND
%  ((FLAGP X 'LOSE) (WARNINGFT 36 "%p not defined - flagged LOSE" X) NIL)
%  (T (COND ((EQCAR Z 'FUNARG) (SETQ B (CONS 'LAMBDA (CDDR B)))))
%     (COND ((AND !*MSG (GETD X)) (WARNINGFT 37 "%p being redefined" X)))
%     (COND
%       ((EQ Y 'EXPR)
%          (SYMBOL!-SET!-DEFINITION X
%            (COND ((AND (NOT !*COMP) !*MACROEXPAND) (MACEXPD Z)) (T Z)))
%          (COND
%            ((AND !*COMP (GETD 'COMPILE)) (COMPILE (LIST A))) ) ) )
%       ((EQ Y 'MACRO)
%        (COND
%           ((PAIRP Z) (EVAL (LIST!* 'DM X (CDR Z))))
%           (T (ERRORFT 999 "Can't handle this case yet") )) )
%       (T (ERROR "Bad type ~S in putd" Y)) )
%     A) ) )
    
% In the future DMACRO will be used instead of DM to define MACROs.
% DMACRO allows some of the MacLisp &keywords in the parameter list.
% Furthermore DMACRO (or rather !$MACFEX) can be changed to suit
% different systems way of defining MACROs.
%(DM DMACRO (U)
%  (SLET ((EXPR!-NAME (CONCATID (CADR U) '!-EXPR)) MMAC)
%    (SETQ U (CDR U))
%    (SETQ MMAC (!$MACFEX (CAR U) (CADR U) (CDDR U) 'MACRO))
%    (LIST 'CPROGN
%%     (!$MACFEX (CAR U) '(!&REST X)
%%        (NCONS (LIST 'LIST (MKQUOTE EXPR!-NAME) (LIST 'MKQUOTE 'X)))
%%        'MACRO)
%      (LIST 'COND
%        (LIST (LIST 'NOT (LIST 'FLAGP (MKQUOTE (CAR U)) ''LOSE))
%              (LIST 'PUTD (MKQUOTE EXPR!-NAME) ''EXPR (CADDDR MMAC)) ))
%     MMAC
%       ) ))
% (NOTLOADTIME (FLAG '(MACRO) 'COMPILE)) Doesn't work.

% (MOVD 'ASCII 'CODE!-CHAR) % Does not work?

% In CSL 1.17 MAPCON and MAPCAN evaluates arguments from right to left.
% Fix for this problem:
(DEFLIST '((CONC XMAPCON)) 'ON)
(DEFLIST '((CONC XMAPCAN)) 'IN)
(DMACRO XMAPCON (L F) (LIST 'NCONCL (LIST 'MAPLIST L F)))
(DMACRO XMAPCAN (L F) (LIST 'NCONCL (LIST 'MAPCAR L F)))
(IFP (NOT (GETD 'NCONCL))
  (DE NCONCL (L) (COND (L (NCONC (CAR L) (NCONCL (CDR L)))))) )

(DMACRO CMMACRO (FN ARGS !&REST BODY)
  (!$MACFEX FN ARGS BODY 'COMPILERMACRO) )

% The standard EXPR version of PUTC works fine for the CSL interpreter
% and the compiler but FASLOUT will not understand anything but DE.
(DMACRO PUTC (FN TYP PROP)
 (COND
  ((ILOS!$PUT (I!$EV FN) (I!$EV TYP)) NIL)
  ((AND (I!$EV TYP) (FLAGP (CADR TYP) 'COMPILE) (I!$EV FN) (I!$EV PROP))
   (SLET
    ((NM (MKQUOTE (CONCATID
                   (COND ((QUOTEP FN) (CADR FN)) (T (GENSYM)))
                   PUTCHR!* (CADR TYP) ))))
    (LIST 'CPROGN
     (CONSA 'DE (CADR NM) (CDADR PROP))
     (LIST 'IPUTC FN TYP NM) ) ) )
  (T (LIST 'IPUTC FN TYP PROP)) ))

(FLAG '(PUTC) 'DFEXPAND)

(DE IPUTC (X Y Z)
 (COND ((NOT (ILOS!$PUT X Y))
        (PUT X Y (COND (!*MACROEXPAND (MACEXPD Z)) (T Z)))
        X)) )

% Must have one arg that is bound to list of args.
(FLAG '(COMPILERMACRO) 'FNARY)

% COMPILERMACROs have better be compiled.
(NOTLOADTIME (FLAG '(COMPILERMACRO) 'COMPILE))

%(DS DE (FN ARGS !&REST BODY)
%  (PUTD 'FN 'EXPR '(LAMBDA ARGS . BODY)))

(DMACRO DFEXPR (FN ARGS !&REST BODY)
  (SLET ((EXPR!-NAME (CONCATID FN '!-EXPR))
         (MFEX (!$MACFEX FN ARGS BODY 'FEXPR)) )
    (LIST 'CPROGN
      (!$MACFEX FN '(!&REST X)
         (NCONS (LIST 'LIST (MKQUOTE EXPR!-NAME) '(MKQUOTE X)))
         'MACRO)
      (LIST 'COND
        (LIST (LIST 'NOT (LIST 'FLAGP (MKQUOTE FN) ''LOSE))
          (LIST (CAR MFEX) (MKQUOTE EXPR!-NAME) ''EXPR (CADDDR MFEX))
           )))))

(DMACRO COMPILETIME (!&REST L)
 (COND ((OR !*COMP !*DEFN) (CONS 'PROGN L))) )

% A noop.
(DMACRO DECLAREFEXPR (!&REST L) NIL)

% Debugging tools:
(DMACRO TRSET (!&REST X)
  (LIST 'TRACESETQ (MKQUOTE X)))

% TR, UNTR and GRIND is by JEA.
% Have been renamed TR -> TRA, UNTR -> UNTRA.
(DMACRO TRA (!&REST X)
  (LIST 'TRACE (MKQUOTE X)))

(DMACRO UNTRA (!&REST X)
  (LIST 'UNTRACE (MKQUOTE X)))

% It is important to define GRIND very early.
(DE GRIND (AT!&)
  (PROG (PR!&)
    (TERPRI)
    (COND
      ((NOT (IDP AT!&))
         (ERRORFT 437 "%p is not an identifier" AT!&))
      ((SETQ PR!& (GETD AT!&))
         (PRIN2 "FnDef: ")
         (TERPRI)
         (PRETTYPRINT PR!&) ) )
    (COND
      ((BOUNDP AT!&)
         (PRIN2 "Value: ")
         (TERPRI)
         (PRETTYPRINT (EVAL AT!&))))
    (PRIN2 "Property list of ")
    (PRIN2 AT!&)
    (COND
      ((NOT (SETQ PR!& (PLIST AT!&)))
         (PRIN2 " is empty")
         (TERPRI)
         (TERPRI))
      (T
         (PRIN2 " :")
         (TERPRI)
         (FOREACH PA!& IN (PLIST AT!&) DO (PRETTYPRINT PA!&)) ))))

%### EXFN1.SL end
