%### CUBUGS.SL ======================================================
%
%       CUBUGS.SL
%       ----------
%
%       Copyright (c) 1984 by Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden and
%       Jan E. Aman, School of Mathematical Sciences, Queen Mary
%       College (U. of London), Mile End Road, London E1 4NS, UK.
%
%
%       This file fixes some problems in the current version of
%       Cambridge University Lisp.
%
%====================================================================

% To fix the problem with the new ON and OFF functions in version 1.06
% onwards (including at least 1.09).
% Note that just a REMD wouldn't do as the functions are defined to
% fast load the lisp compiler where the full definition of them is
% given, and the compiler will anyhow be used thereby defining them
% back to John's version. Also ON is used for other purposes as well.
% JEA.

% Remove ON and OFF, create new atoms with the same name and property
% list.
(FOREACH FN IN '(ON OFF) DO
 (PROG (PLIS)
  (SETQ PLIS (PLIST FN))
  (REMOB FN)
  (CLEARBUFF)
  (PACK FN)
  (SETQ FN (MKATOM))
  (FOREACH PRP IN (REVERSE PLIS) DO
   (COND
    ((PAIRP PRP) (PUT FN (CAR PRP) (CDR PRP)))
    (T (FLAG (NCONS FN)) PRP) ) ) ) )
%(REMOB 'OFF)
%(REMOB 'ON)
%(PUT 'ON 'DO 'MAP)
%(PUT 'ON 'COLLECT 'MAPLIST)
%(PUT 'ON 'CONC 'MAPCON)

% To allow control-C. A problem in Culisp 1.08 and 1.09 only (?). JEA.
(FLUID '(!*BREAK))
(SETQ !*BREAK T)

%### CUBUGS.SL end
