%### EXFN1.SL =======================================================
%
%       EXFN1.SL
%       --------
%
%       Copyright (c) 1984 by Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden and
%       Jan E. Aman, School of Mathematical Sciences, Queen Mary
%       College (U. of London), Mile End Road, London E1 4NS, UK.
%
%       This file contains some changes to EXFN1I.SL that adapts it to
%       Cambridge Lisp.
%
%====================================================================

(FLUID '(!$INERRSET !*ACN SPDCM!* MMACR!*))    % For Culisp only.
(FLUID '(HLPLIS!* !*NOCHECK))   % Declared fluid in exfn1i.sl as well.

% Bootstrapping of macro definition in Culisp.
%(COND
%  ((NOT (GETD 'DMM)) (SETQ DMM DM)) )  % For ACN Culisp.
(COND
  ((GETD 'DCM)
   (COND
    ((NOT
      (OR
       (EQUAL (GETD 'DCM) (GETD '!%DM))
       (EQUAL (GETD 'DCM) (GETD 'DM)) ))
    (SETQ !*ACN T) NIL) ) )             % For ACN Culisp.
  ((GETD '!%DM) (SETQ DCM !%DM))        % For Reduce (JPFF).
  ((GETD 'DM) (SETQ DCM DM)) )          % For JPFF Culisp.

% IFP(IFFORM:form,THENFORM:form,{ELSEFORM:form}):any
% IFP is used for conditional coding.
% IFFORM is evaluated at macro expansion time. If it is true then
% THENFORM is returned. If it is false then ELSEFORM (or if it is not
% present NIL) is returned.
%(DMM IFP U!&
% (COND
%  ((EVAL (CADR U!&)) (CADDR U!&))
%  ((CDDDR U!&) (CADDDR U!&)) ))
(DCM IFP U!&
 (COND
  ((EVAL (CAR U!&)) (CADR U!&))
  ((CDDR U!&) (CADDR U!&)) ))

% This is for Atari only, check of function calls to costly.
(IFP (GETD 'EDIT) (SETQ !*NOCHECK T))

%(IFP !*COMP (MODULE 'EXFNM0))  % Macro part 0 of this file.

%(DMM FUNCTIONS DUMMY NIL)
(DCM FUNCTIONS DUMMY NIL)

(IFP (NOT (GETD 'WARNINGFT))           % Needed for bootstrap
 (EVAL (PROGN
% WARNINGFT redefined to include warning message numbers not yet used
% but available for possible future use. Straight forward definition:
%(DS WARNINGFT (DUMMY ST !&REST AR) (MSGOUT ST "*** " (LIST . AR)))% JEA
% Safer definition accepting also calls without warning numbers:
   (DCM WARNINGFT U
    (PROGN
     (SETQ U (CDR U))
     (COND ((AND U (NUMBERP (CAR U))) (SETQ U (CDR U)))) % JEA.
     (LIST 'MSGOUT "*** " (LIST 'QUOTE (CAR U)) (CONS 'LIST (CDR U))) ))
   (COND ((NOT (GETD 'MSGOUT))
          (DE MSGOUT (PR ST AR)
              (PROGN (PRINC PR) (PRINT (CONS ST AR)) NIL ) ) ))
   NIL )) )

%(DMM FUNCALL U
% (COND ((AND !$INERRSET (IDP (CADR U))) (!$ERRFORM (CADR U))))
% (CDR U))
(DCM FUNCALL U
 (COND ((AND !$INERRSET (IDP (CAR U))) (!$ERRFORM (CAR U))))
 U)

% Function type name of for macro getting argument without function
% name and with spread arguments (The original Culisp style definition).
(SETQ SPDCM!*
 (IFP !*ACN
  'CMACRO       % ACN
  'MACRO ) )    % JPFF

% Function type name of for macro getting argument with function
% name. Note: JPFF MMACRO is spread while ACN MACRO is nospread.
(SETQ MMACR!*
 (IFP !*ACN
  'MACRO        % ACN
  'MMACRO ) )   % JPFF

(IFP !*ACN (FLAG '(MACRO FEXPR) 'FNARY))

% MACEXPD1(SXPR:any):any
% The top level of SXPR is macro expanded if it is a macro form.
(DE MACEXPD1 (X)
 (PROG (A)
  (RETURN
   (COND
    ((OR (NOT (PAIRP X)) (PAIRP (CAR X))) X)
    ((AND !*COMP (SETQ A (GET (CAR X) 'COMPILERMACRO))) (FUNCALL A X))
    ((NOT (SETQ A (GETD (CAR X)))) X)
    ((EQ (CAR A) SPDCM!*) (APPLY (CDR A) (CDR X)))
    ((EQ (CAR A) MMACR!*) (APPLY (CDR A) X))
    (T X) ) ) ) )

% (XPUSH id any) pushes "any" onto the list that must be value of
% "id". "any" will be new beginning of the list. The value of XPUSH
% is not defined. XPUSH must be defined here as it is used in the
% general macro defining function MACFEX.
%(DMM XPUSH U
%  (LIST 'SETQ (CADR U) (LIST 'CONS (CADDR U) (CADR U))))
(DCM XPUSH U
  (LIST 'SETQ (CAR U) (LIST 'CONS (CADR U) (CAR U))))

(IFP
  (NOT (GETD 'ERRORFT))                 % Needed for bootstrap
  (EVAL
    (PROGN
%     (DMM ERRORFT U
%       (LIST 'XERRORFT3 (CADR U) (CADDR U) (CONS 'LIST (CDDDR U))))
      (DM ERRORFT U
        (LIST 'XERRORFT3 (CAR U) (CADR U) (CONS 'LIST (CDDR U))))
      NIL )) )

(IFP !*COMP (MODULE 'EXFNM1))   % Macro part 1 of this file.

% In the future DMACRO will be used instead of DM to define MACROs.
% DMACRO allows some of the MacLisp &keywords in the parameter list.
% Furthermore DMACRO (or rather !$MACFEX) can be changed to suit
% different systems way of defining MACROs.
%(DMM DMACRO U
%  (!$MACFEX (CADR U) (CADDR U) (CDDDR U) SPDCM!*))
(DCM DMACRO U
  (!$MACFEX (CAR U) (CADR U) (CDDR U) SPDCM!*))

% Function types.
(FLAG '(EXPR FEXPR) 'ISAFUNCTION)
(FLAG (LIST SPDCM!* MMACR!*) 'ISAFUNCTION)

% First arg is function name.
(FLAG (LIST MMACR!*) 'MACROARG)
(FLAG '(COMPILERMACRO) 'MACROARG)

(SETQ REVERSIP REVERSEWOC)

(DE !$MACFEX (FN ARGS OBODY TYP)
 (PROG
   (DSARGS!*    % FLUID. Set inside DSSB to variables know to DSSB.
    PARGS       % Variable list for PROG
    BODY        % Will contain the function body.
    HLP         % Help string.
    HLPLIS      % Help list name.
    LARG        % Last parameter or the functions LAMBDA args.
    ARGCD       % NIL or expression that steps down the argument list.
    REST        % Switch. True if processed &REST argument.
    SEEN        % Last seen keyword.
    MACR        % Indicates MACRO without !&MACRO keyword, so extra CDR
                % needed.
    DSB         % True if &DS keyword.
    AL          % Lower limit on number of arguments or NIL if
                % no arguments.
    AU          % Upper limit on number of arguments or NIL if
                % no upper limit.
    ARG         % Current variable or keyword.
    VAL         % NIL or default value form for &OPTIONAL argument.
    L           % Used to step down parameter list.
    X)          % Help variable.
   (SETQ MACR (FLAGP TYP 'MACROARG))  % Do we need to remove macro name?
   (SETQ L ARGS)
% !&DS or !&MACRO only at the beginning of the parameter list.
% Remove them.
I  (COND ((EQCAR L '!&DS)       % Check for &DS on parameter list.
          (SETQ DSB T) (SETQ L (CDR L)) ))
   (COND ((EQCAR L '!&MACRO)    % Check for &MACRO on parameter list.
          (COND
           (MACR (SETQ MACR NIL))       % We do want the macro name.
           ((EQ TYP SPDCM!*)
            (SETQ TYP MMACR!*) )        % Change MACRO to MMACRO.
           (T (GO E)) )                 % Illegal if not a macro.
          (SETQ L (CDR L)) (GO I) )) % Go back and check for &DS again.
   (SETQ X L)   % L now points to parameter list with &DS and &MACRO
                % removed.
   (COND ((AND MACR (EQ TYP MMACR!*))   % If we don't want macro name,
          (SETQ TYP SPDCM!*) (SETQ MACR NIL) ))% change MMACRO to MACRO.
% First go through the parameter list to find the last argument (LARG)
%  and if variable nr of args.
R  (COND ((NULL X) (GO RE)))
   (SETQ ARG (CAR X))           % Look for keywords on parameter list.
   (COND
    ((MEMQ ARG '(!&OPTIONAL !&REST))    % Variable nr of args.
     (SETQ ARGCD T) )
    (T (SETQ LARG ARG)) )       % Not a keyword. Update last parameter.
   (SETQ X (CDR X))
   (GO R)
% Now see what we got.
% Are we doing a function with a fixed number of args, each bound to
% its parameter in a LAMBDA expression, or are are we doing an nary
% function with a single LAMBDA parameter that is bound to the list
% of arguments?
RE (COND                % Not variable nr of args or forced nary.
    ((NOT (OR ARGCD (FLAGP TYP 'FNARY)))
     (SETQ LARG NIL) )  % LARG will contain list of LAMBDA parameters.
    ((EQ TYP 'EXPR)     % An nary EXPR wouldn't be portable.
     (ERRORFT 400
      "%r is an EXPR, may not have variable nr of args" FN ) )
    (T (COND    % Nary, i.e. &OPTIONAL or &REST arg or forced nary.
        ((NULL LARG)
         (SETQ LARG (GENSYM)) ) % A forced nary with no args.
        ((PAIRP LARG)
         (SETQ LARG (CAR LARG)) ) )     % Optional arg with default.
% LARG has name of parameter that will be bound to the list of args.
       (SETQ ARGCD (LIST 'SETQ LARG (LIST 'CDR LARG))) ) )
% ARGCD steps down.
% Loop through the parameter list, processing the parameters.
A  (COND ((NULL L) (GO AE)))
   (SETQ ARG (CAR L))
   (COND
    ((MEMQ ARG '(!&OPTIONAL !&REST !&MACRO !&DS))       % Keyword.
     (SETQ SEEN ARG) )
    % It is not a keyword, must be a parameter.
    ((NOT ARGCD) (XPUSH LARG ARG))      % Ordinary lambda arg.
    (REST (GO E))                       % &REST out of order.
    ((NULL SEEN)                        % Ordinary arg
     (SETQ AL (COND                     % Update lower limit.
       (AL (SETQ X ARGCD) (ADD1 AL))    % Earlier arg. CDR to next arg.
       (T (SETQ X LARG) 1) ))           % First arg.
     (XPUSH BODY (LIST 'SETQ ARG (LIST 'CAR X)))
     (XPUSH PARGS ARG) )
    ((EQ SEEN '!&OPTIONAL)              % Optional arg
     (SETQ AU (COND                     % Update upper limit.
       (AU                              % Earlier optional args.
        (SETQ X (LIST 'AND LARG ARGCD)) %  CDR to next arg if LARG
        (ADD1 AU) )                     % not NIL.
       (AL                              % Earlier ordinary args.
        (SETQ X ARGCD)                  %  CDR to next arg.
        (ADD1 AL) )
       (T (SETQ X LARG) 1) ))   % First arg. Don't need CDR first.
     (COND ((SETQ VAL (AND (PAIRP ARG) (CDR ARG))) % Default value?
            (SETQ ARG (CAR ARG))        % Yes. This is the parameter.
            (COND
             ((CDR VAL)                 % supplied-p parameter ?
              (XPUSH PARGS (CADR VAL)) % Yes. Put it in parameter list.
              (SETQ X (LIST 'SETQ (CADR VAL) X)) )) % Change predicate.
            (SETQ VAL (CAR VAL)) ))     % This is the default value.
     (XPUSH BODY (LIST 'SETQ ARG        % Set value of parameter
       (LIST 'COND
        (LIST X (LIST 'CAR LARG))       % if got arg, use it
        (LIST 'T VAL) ) ) )             % else use default.
     (XPUSH PARGS ARG) )
    ((EQ SEEN '!&REST) (COND            % REST parameter.
        (AU (XPUSH BODY                 % Optional arg before. Test if
             (LIST 'COND (LIST LARG ARGCD)) ))% possible to CDR to next.
        (AL (XPUSH BODY ARGCD)) )   % Ordinary arg before. CDR to next.
       (XPUSH PARGS (SETQ REST ARG))
       (SETQ AU NIL) )                  % No upper limit.
    (T (GO E)) )    % Must be !&DS or !&MACRO. They should not be here.
   (SETQ L (CDR L))
   (GO A)
% Get help information if there is any.
   (COND ((AND HLPLIS!* (CDR OBODY) (COND
            ((STRINGP (CAR OBODY)) (SETQ HLP (CAR OBODY)))
            ((EQCAR (CAR OBODY) 'HELP)
             (SETQ HLPLIS (CAR (SETQ HLP (CDAR OBODY))))
             (SETQ HLP (CADR HLP))
             T ) ))
          (SETQ OBODY (CDR OBODY)) ))
% Set DSARGS!* to point to list of all variables. DSARGS!* is used in
% DSSB below.
AE (COND
    ((NOT ARGCD)                        % Fixed nr of args.
     (COND (DSB (SETQ DSARGS!* (APPEND LARG PARGS)))) )
    ((EQCAR PARGS LARG)
     (COND (DSB (SETQ DSARGS!* PARGS)))
        % Remove the LAMBDA arg from the PROG args.
     (SETQ PARGS (CDR PARGS)) )
    (DSB (SETQ DSARGS!* (CONS LARG PARGS))) )
   (COND (DSB (SETQ OBODY (LIST (DSSB (MKPROGN OBODY))))))
B  (COND (OBODY
          (XPUSH BODY (CAR OBODY))
          (SETQ OBODY (CDR OBODY)) (GO B) ))
% If PROG, end with RETURN.
   (COND ((AND PARGS BODY)
          (RPLACA BODY (LIST 'RETURN (CAR BODY)))))
   (SETQ BODY (REVERSIP BODY))
   (SETQ FN (MKQUOTE FN))
% Check arguments.
   (COND ((AND ARGCD (NOT !*NOCHECK))   % If nary and !*NOCHECK
          (COND                         % off, check nr of args
           ((NOT (OR REST AU))          % Fixed nr of args.
            (XPUSH BODY (LIST 'FCHKARG1 LARG (OR AL 0) FN)) )
           ((OR AL AU)          % Upper limit or lower limit > 0.
            (XPUSH BODY (LIST 'FCHKARG LARG AL AU FN)) ) )))
% If necessary skip first argument.
   (COND ((AND MACR (OR (CDR BODY) (CAR BODY))) % Do we need a CDR
          (XPUSH BODY ARGCD) )) % first to skip the function name?
% Return a PUTD or PUTC expression.
   (SETQ BODY (LIST
      (COND
       ((FLAGP TYP 'ISAFUNCTION) 'PUTD)
       (T 'PUTC) )                       % Not function.
      FN
      (MKQUOTE TYP)
      (MKQUOTE (LIST 'LAMBDA
        (COND
         ((AND ARGCD (NOT (FLAGP TYP 'ISAFUNCTION))) % Nary. ???
          (NCONS LARG) )
         ((PAIRP LARG) (REVERSIP LARG))
         ((NULL LARG) 'DUMMY)
         (T LARG) )
        (COND
         (PARGS (CONS 'PROG (CONS (REVERSIP PARGS) BODY)))
         ((CDR BODY) (CONS 'PROGN BODY))
         (T (CAR BODY)) ) )) ))
   (RETURN (COND
     (HLP (LIST 'CPROGN
           (LIST 'ADDHLP (MKQUOTE (OR HLPLIS HLPLIS!*)) FN HLP)
           BODY ))
     (T BODY) ))
% Error return.
E  (ERRORFT 401 "%r illegal parameter list" ARGS) ) )

% Add the keyword REPLACE to FOREACH.
(DEFLIST '((IN MAPRPLC) (ON MAPRPL)) 'REPLACE)

% The version in exfn1i.sl will not work for moving compiled
% functions - bad function for putd.
(DE MOVD (X Y) (COND
  ((NULL (GETD Y)) (ERRORFT 408 "Function %r is not defined" Y))
  (T (SET X (EVAL Y)) X) ))

(IFP !*COMP (MODULE 'EXFN1I))   % End of EXFNM1; Macro part.

% The following are defined in Cambridge Lisp.
(FLAG
 '(COMMENT BOUNDP MKQUOTE EQCAR ATSOC NCONS XCONS FOREACH)
 'LOSE )

% QUOTEP gone in the 12jun85 version.

(FLAG '(XCOND IPUTC CONCATIDHELP) 'LOSE)           % Not needed.

% The following have been defined in this file.
(FLAG
 '(IFP FUNCTIONS WARNINGFT FUNCALL MACEXPD1 XPUSH ERRORFT DMACRO
   REVERSIP !$MACFEX CMMACRO
   MOVD CONCATID COMPILETIME DECLAREFEXPR DE)
 'LOSE )
(IFP (NOT (GETD 'EDIT))                 % For Orion, not for Atari
 (FLAG '(RPLAD) 'LOSE) )
(IFP (BOUNDP '!*!l!o!w!e!r) (FLAG '(FOLDCASE) 'LOSE))

% PUTC

(INCLUDE "../exfn1i.sl")

%(REMPROP 'DO 'ON)                      % The MAP functions are on
%(REMPROP 'DO 'IN)                      % property list of ON and IN
%(REMPROP 'COLLECT 'ON)                 % instead of on DO, COLLECT
%(REMPROP 'COLLECT 'IN)                 % CONC and REPLACE.
%(REMPROP 'CONC 'ON)
%(REMPROP 'CONC 'IN)
%(REMPROP 'REPLACE 'ON)
%(REMPROP 'REPLACE 'IN)

% The following are defined in Cambridge Lisp.
(REMFLAG
 '(COMMENT BOUNDP MKQUOTE EQCAR ATSOC NCONS XCONS FOREACH)
 'LOSE )

% QUOTEP gone in the 12jun85 version.

(REMFLAG '(XCOND IPUTC CONCATIDHELP) 'LOSE)

(REMFLAG
 '(IFP FUNCTIONS WARNINGFT FUNCALL MACEXPD1 XPUSH ERRORFT DMACRO
   REVERSIP !$MACFEX CMMACRO
   MOVD CONCATID COMPILETIME DECLAREFEXPR DE)
 'LOSE )
(IFP (NOT (GETD 'EDIT))                 % For Orion, not for Atari
 (REMFLAG '(RPLAD) 'LOSE) )
(IFP (BOUNDP '!*!l!o!w!e!r) (REMFLAG '(FOLDCASE) 'LOSE))

(MOVD 'PRIN1 'PRIN)

(MOVD 'PRIN2 'PRINC)

(IFP (NOT (GETD 'EDIT))                 % For Orion, not for Atari
 (DS RPLAD (L A D) (RPLACA (RPLACD L D) A)) )   %:b

(DMACRO CMMACRO (FN ARGS !&REST BODY)
  (!$MACFEX FN ARGS BODY 'COMPILERMACRO) )

% Must have one arg that is bound to list of args.
(FLAG '(COMPILERMACRO) 'FNARY)

% COMPILERMACROs have better be compiled.
(NOTLOADTIME (FLAG '(COMPILERMACRO) 'COMPILE))
(DS DE (FN ARGS !&REST BODY)
  (PUTD 'FN 'EXPR '(LAMBDA ARGS . BODY)))

% FOLDCASE(SW:boolean,[SXPR:form]):any
% Evaluate all SXPR while character folding status temporarily is set
% to SW.
(IFP (BOUNDP '!*!l!o!w!e!r)
 (DS FOLDCASE (SW !&REST L) (PLET ((!*LOWER SW)) . L)) )

(DMACRO CONCATID (!&REST L)
 (CONSA 'PROGN
  '(CLEARBUFF)
  (NCONC1 (FOREACH X IN L COLLECT (LIST 'PACK X)) '(MKATOM)) ) )

(DMACRO COMPILETIME (!&REST L)
 (COND ((OR !*COMP !*DEFN) (CONS 'PROGN L))) )

(DFEXPR DECLAREFEXPR (!&REST L)
 (FOREACH X IN L DO (COND ((NOT (FNP X)) (DECLARE (LIST X))))) )

(IFP !*COMP (MODULE 'EX1GR))    % Module for Grind.

% Debugging tools:
(DMACRO TRSET (!&REST X)
  (LIST 'TRACESETQ (MKQUOTE X)))

% TR, UNTR and GRIND is by JEA.
% Have been renamed TR -> TRA, UNTR -> UNTRA.
(DMACRO TRA (!&REST X)
  (LIST 'TRACE (MKQUOTE X)))

(DMACRO UNTRA (!&REST X)
  (LIST 'UNTRACE (MKQUOTE X)))

% It is important to define GRIND very early.
(DE GRIND (AT!&)
  (PROG (PR!&)
    (TERPRI)
    (COND
      ((NOT (IDP AT!&))
         (ERRORFT 437 "%p is not an identifier" AT!&))
      ((AND (BOUNDP AT!&) (IDP (EVAL AT!&)))
         (PRIN2 "Value: ")
         (TERPRI)
         (PRETTYPRINT (EVAL AT!&))
         (COND
           ((SETQ PR!& (GETD AT!&))
              (PRIN2 "Indirect function definition: ")
              (TERPRI)
              (PRETTYPRINT PR!&))))
      ((SETQ PR!& (GETD AT!&))
         (PRIN2 "FnDef: ")
         (TERPRI)
         (PRETTYPRINT PR!&))
      ((BOUNDP AT!&)
         (PRIN2 "Value: ")
         (TERPRI)
         (PRETTYPRINT (EVAL AT!&))))
    (PRIN2 "Property list of ")
    (PRIN2 AT!&)
    (COND
      ((NOT (SETQ PR!& (PLIST AT!&)))
         (PRIN2 " is empty")
         (TERPRI)
         (TERPRI))
      (T
         (PRIN2 " :")
         (TERPRI)
         (FOREACH PA!& IN (PLIST AT!&) DO (PRETTYPRINT PA!&))))))

(IFP !*COMP (MODULE))           % End of modules.

%### EXFN1.SL end
