%### EXFN2.SL =======================================================
%
%       EXFN2.SL
%       --------
%
%       Copyright (c) 1984 by Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden and
%       Jan E. Aman, School of Mathematical Sciences, Queen Mary
%       College (U. of London), Mile End Road, London E1 4NS, UK.
%
%       This file contains some changes to EXFN2I.SL that adapts it to
%       Cambridge Lisp.
%
%====================================================================

(SETFLUIDS PG!_NUM!* LI!_NUM!* PROMPT!* PRINTVALUE!* !*LOWER
 !*TTYECHO !*INT !*IPRN MODULNAM!* LOADMSGTAB!* NOSAVE)

(SETGLOBALS
 ((TAB!*        TAB))           % Tab.
 TOPDIR!*
 INITPROMPT!*
 !!COMMANDLINE
 (SAVEDO!*
  (LOADARG!* HERE HERELIST !*INT CLOC!*         % FIL!*
   ARGV!* CURRENTDIR!*) ) )

(USEDFLAGS COMPILE)

(NOTLOADTIME (FLAG '(INITLINEFN) 'COMPILE))

(SAMEDEF XPLUS IPLUS)

(SAMEDEF XTIMES ITIMES)

(SAMEDEF XADD1 IADD1)

(SAMEDEF XSUB1 ISUB1)

(SAMEDEF XMINUS IMINUS)

(SAMEDEF XDIFFERENCE IDIFFERENCE)

(SAMEDEF XQUOTIENT IQUOTIENT)

(SAMEDEF XREMAINDER IREMAINDER)

(SAMEDEF XEQN EQ)

(SAMEDEF XLESSP ILESSP)

(SAMEDEF XGREATERP IGREATERP)

(SAMEDEF XMINUSP IMINUSP)

(SAMEDEF XZEROP IZEROP)

(SAMEDEF XIPLUS IPLUS)

(SAMEDEF XITIMES ITIMES)

(SAMEDEF XIADD1 IADD1)

(SAMEDEF XISUB1 ISUB1)

(SAMEDEF XIMINUS IMINUS)

(SAMEDEF XIDIFFERENCE IDIFFERENCE)

(SAMEDEF XIQUOTIENT IQUOTIENT)

(SAMEDEF XIREMAINDER IREMAINDER)

(SAMEDEF XIEQN EQ)

(SAMEDEF XILESSP ILESSP)

(SAMEDEF XIGREATERP IGREATERP)

(SAMEDEF XIMINUSP IMINUSP)

(SAMEDEF XIZEROP IZEROP)

(SAMEDEF XAMEMQ MEMQ)

(SAMEDEF XAATSOC ATSOC)

(SAMEDEF AMEMQ MEMQ)

(SAMEDEF AATSOC ATSOC)

(SAMEDEF AEQN EQ)

(SAMEDEF IEQN EQ)

% RPLACW,PLIST defined in Cambridge Lisp.

(DS FOREACHID (X !&REST L) (FOREACH X IN (OBLIST) DO . L))  % JEA

% GETFN, FNP defined in EXFN2I.SL. Is there an improvement???

(DE GETFNTYPE (X)
 (COND
  ((NOT (SETQ X (GETD X))) NIL)
  ((MEMQ (SETQ X (CAR X)) '(EXPR SUBR)) 'EXPR)
  ((MEMQ X '(FEXPR FSUBR)) 'FEXPR)
  (T X) ) )

(DE EXPRP (X)
 (AND (SETQ X (GETD X)) (OR (EQ (CAR X) 'SUBR) (EQ (CAR X) 'EXPR))) )

(DE FEXPRP (X)
 (AND (SETQ X (GETD X)) (OR (EQ (CAR X) 'FSUBR) (EQ (CAR X) 'FEXPR))) )

(DE MACROP (X)
 (AND (SETQ X (GETD X)) (OR (EQ (CAR X) 'MACRO) (EQ (CAR X) 'MMACRO))) )

(DS FEXPRCALL (FN ARGS) (EVAL (CONS FN ARGS)))
% APPLY on a FEXPR doesn't compile ok in Culisp.

% This definition of INTERNP is not completely correct:
% Calling INTERNP has the side effect of interning the argument.
% It can't be done better as there is no way in Cambridge Lisp to
% make an uninterned id without first interning it.
(DE INTERNP (X) (EQ X (PROGN (CLEARBUFF) (PACK X NIL) (MKATOM))))

% There doesn't seem to be an INTERN function in Cambridge Lisp.
(DE INTERN (X)
 (SLET (Y)
  (CLEARBUFF)
  (PACK X NIL)
  (SETQ Y (MKATOM))
  (COND ((AND (NULL (PLIST  Y)) (IDP X)) (SETPLIST Y (PLIST X))))
  Y) )

(DE CONCATIDL (L) (MAKEID L T))

(DE MAKEID (X DUMMY)
 (CLEARBUFF)
 (FOREACH Z IN X DO (PACK Z NIL))
 (MKATOM) )

(DE MAKESTR (X)
 (CLEARBUFF)
 (FOREACH Z IN X DO (PACK Z NIL))
 (MKSTRING) )

% ORDERP defined in Cambridge Lisp.

(SAMEDEF LEXP ORDERP)

% Standard input in Culisp is sysin, not nil.
(DE STDINP () (SLET ((A (RDS NIL))) (RDS A) (EQ 'SYSIN A)))

% Standard output in Culisp is sysprint, not nil.
(DE STDOUTP () (SLET ((A (WRS NIL))) (WRS A) (EQ 'SYSPRINT A)))

% UNREADCH not defined.

(DE SKIPWHITE ()
 (WHILE
  (MEMQ (TYIPEEK)
   (GVALUE (LIST (INTERNALCODE BLANK) (INTERNALCODE TAB!*)
                 (INTERNALCODE !$EOL!$) (INTERNALCODE !$FF!$) )) )
  (TYI) ) )

(MOVD 'PRIN2T 'PRINTC)
% (SAMEDEF PRIN2T PRINTC)

% TTAB and SPACES are already defined in Cambridge Lisp.

(DS BELL () (TYO 7))

(DE PGLINE () (CONS PG!_NUM!* LI!_NUM!*))

% Cambridge Lisp LINELENGTH have got it one step wrong,
% (CULINELENGTH n) means you can write only (n-1) characters per line.
(COND ((NOT (GETD 'CULINELENGTH)) (MOVD 'CULINELENGTH 'LINELENGTH)))

(DE LINELENGTH (N)
 (SUB1 (CULINELENGTH (COND ((NUMBERP N) (ADD1 N)) (T N)))) )

(IFP !*COMP (MODULE 'EXFN2I))   %:LH  exfn2i.sl, SLISPTOP

% This can be done this way only in some versions of Cambridge Lisp,
% for definition suitable for other versions see oldcode.sl.
(DE ULCASE (X SW) (CLEARBUFF) (PACK X (COND (SW 1) (T -1))) (MKATOM))

% This is used for Atari:
(IFP
 (LESSP (SYSTYPE 'LISPVERS) 0.96)
 (CPROGN
  (IFP (NOT (GETD 'I!$OPEN)) (SETQ I!$OPEN OPEN))

% Use of STRTOID ensures that OPEN will not be given string (Illegal).
  (DE OPEN (X Y) (I!$OPEN (COND ((STRINGP X) (STRTOID X)) (T X)) Y))

  (DE STRTOID (STRING) (CLEARBUFF) (PACK STRING NIL) (MKATOM))
  ) )   % End of IFP

% FILEIN(FIL:file,[ARG:form]):any
% Evaluates ARGs with input switched to file FIL.
(DS FILEIN (X !&REST L) (SLET ((PG!_NUM!* 1) (LI!_NUM!* 1))
  (PROG1 (CHANIN (CAR (XPUSH FILESTK!* (OPEN X 'INPUT))) . L)
   (CLOSE (POP FILESTK!*)) ) ))

(COMMENT
(DE SETPROMPTER (STR) (PROG1 INITPROMPT!*
  (SETQ PROMPT!* (SETQ INITPROMPT!* STR)) ))

(DE SETVPROMPTER (STR) (PROG1 INITVPROMPT!*
  (SETQ VALUE!* (SETQ INITVPROMPT!* STR)) ))
)

(DE RESTOREPROMPT NIL (PROGN
  (SETQ PROMPT!* INITPROMPT!*)
% (SETQ VALUE!* INITVPROMPT!*)
  NIL ))

(DE SETPROMPTER (STR) (PROG1 PROMPT!* (SETQ PROMPT!* STR)))

% Don't print any value prompt (Version 1feb85 and later only):
(SETQ PRINTVALUE!* 'NOOP)

(DE NOOP NIL NIL)

(DS PROMPTER (PRM !&REST L) (SLET ((PROMPT!* PRM)) . L))

(DE PROMPT () (COND ((TTYINP) (EPRIN2 PROMPT!*))))

% SETFOLDCASE(SW:boolean):boolean
% Sets character folding status and returns old value. If character
% folding is true, then upper and lower case characters are folded
% into one character set, upper or lower depending on system. Which
% it is can be seen in SHPCASEUP!*. 
(IFP (BOUNDP '!*!l!o!w!e!r)
 (DE SETFOLDCASE (SW) (PROG1 !*LOWER (SETQ !*LOWER SW))) )

(IFP (BOUNDP '!*!l!o!w!e!r)
 (DE READCHCASE () (SLET ((A (READCH))) (COND
   ((AND !*LOWER (LITER A)) (ULCASE A NIL))
   (T A) )))
 (DE READCHCASE () (SLET ((A (READCH))) (COND
   ((AND !*RAISE (LITER A)) (ULCASE A T))
   (T A) ))) )

% SETGCMESSAGE(SW:boolean):boolean
% Sets gcmessage status and returns old value. If gcmessage is true,
% then on most systems a message is printed when a garbage collection
% occurs.
(DE SETGCMESSAGE (SW) (NOT (EQ 0 (VERBOS (COND (SW 1) (T 0))))))

(SETGLOBALS GCMSGSTK!*)
(COND ((NOT (MEMQ 'GCMSGSTK!* SFSTKS!*)) % No PUSHQ defined so do it
       (SETQ SFSTKS!* (CONS 'GCMSGSTK!* SFSTKS!*)) ))   % this way.
(DEFLIST '((GCMSGSTK!* VERBOS)) 'SFSTKFN)
(FLAG '(GCMSGSTK!*) 'LASTONLY)

% GCMESSAGE(SW:boolean,[SXPR:form]):any
% Evaluate all SXPR while gcmessage status temporarily is set to SW.
(DS GCMESSAGE (SW !&REST L)
 (XPUSH GCMSGSTK!* (VERBOS (COND (SW 1) (T 0))))
 (PROG1 (PROGN . L) (VERBOS (POP GCMSGSTK!*))) )

(DE I!$PRNEVL (PRNEVL!$X PRESW!$ POSTV!$)
 (COND (PRESW!$ (TERPRI)))
 (SETQ PRNEVL!$X (EVAL PRNEVL!$X))
 (COND ((NOT (AND POSTV!$ (EQ PRNEVL!$X POSTV!$)))
        (QTRPRI) (PRIN1 PRNEVL!$X) (TERPRI) ))
 PRNEVL!$X)

% Changed to call from THROW to !*THROW in order to allow Rsheep to
% use this file without trouble. JEA
(DE RESET () (!*THROW NIL NIL))

(IFP (NOT !*RSHEEP) (DE QUIT () (STOP 0)))

(IFP (NOT !*RSHEEP) (SAMEDEF BYE QUIT))

% TIME defined in Cambridge Lisp,
% however, GCTIME is already excluded.

% The following functions are defined in Cambridge Lisp.
(FLAG '(GCD EVENP
        IPLUS ITIMES IADD1 ISUB1 IMINUS IDIFFERENCE IQUOTIENT
        IREMAINDER ILESSP IGREATERP IMINUSP IZEROP
        RPLACW COPY EXPLODEC SPACES TTAB)
      'LOSE)
% Defined in some (late) versions of Culisp:
(IFP (GETD 'FILEP) (FLAG '(FILEP) 'LOSE))

% The following functions are defined in the present file.
(FLAG '(XPLUS XTIMES XADD1 XSUB1 XMINUS XDIFFERENCE XQUOTIENT
        XREMAINDER XEQN XLESSP XGREATERP XMINUSP XZEROP
        XIPLUS XITIMES XIADD1 XISUB1 XIMINUS XIDIFFERENCE XIQUOTIENT
        XIREMAINDER XIEQN XILESSP XIGREATERP XIMINUSP XIZEROP
        XAMEMQ XAATSOC
        AMEMQ AATSOC AEQN
        IEQN
        GETFNTYPE EXPRP MACROP FEXPRP FEXPRCALL
        INTERNP ULCASE CONCATIDL MAKEID MAKESTR
        STDINP STDOUTP
        SKIPWHITE PRIN2T IOCHAN
        PGLINE FILEIN
        SETPROMPTER SETVPROMPTER RESTOREPROMPT PROMPTER PROMPT
        READCHCASE SETGCMESSAGE GCMESSAGE I!$PRNEVL
        QUIT RESET DATETIME SHPDEBUG)
      'LOSE)
(IFP (BOUNDP '!*!l!o!w!e!r) (FLAG '(SETFOLDCASE) 'LOSE))

% The following functions are not needed.
(FLAG '(GCD1 EXPLODECHELP) 'LOSE)

(INCLUDE "../exfn2i.sl")

(REMFLAG '(GCD1 EXPLODECHELP) 'LOSE)

(REMFLAG '(XPLUS XTIMES XADD1 XSUB1 XMINUS XDIFFERENCE XQUOTIENT
        XREMAINDER XEQN XLESSP XGREATERP XMINUSP XZEROP
        XIPLUS XITIMES XIADD1 XISUB1 XIMINUS XIDIFFERENCE XIQUOTIENT
        XIREMAINDER XIEQN XILESSP XIGREATERP XIMINUSP XIZEROP
        XAMEMQ XAATSOC
        AMEMQ AATSOC AEQN
        IEQN
        GETFNTYPE EXPRP MACROP FEXPRP FEXPRCALL
        INTERNP ULCASE CONCATIDL MAKEID MAKESTR
        STDINP STDOUTP
        SKIPWHITE PRIN2T IOCHAN
        PGLINE FILEIN
        SETPROMPTER SETVPROMPTER RESTOREPROMPT PROMPTER PROMPT
        READCHCASE SETGCMESSAGE GCMESSAGE I!$PRNEVL
        QUIT RESET DATETIME SHPDEBUG)
      'LOSE)
(IFP (BOUNDP '!*!l!o!w!e!r) (REMFLAG '(SETFOLDCASE) 'LOSE))

(REMFLAG '(GCD EVENP
        IPLUS ITIMES IADD1 ISUB1 IMINUS IDIFFERENCE IQUOTIENT IREMAINDER
        ILESSP IGREATERP IMINUSP IZEROP
        RPLACW COPY EXPLODEC SPACES TTAB FILEP)
      'LOSE)

% Operating system uses lower case for commands, file names etc.
(SETCONSTANTS (!*OSCASEUP NIL))

(IFP (BOUNDP '!*!l!o!w!e!r)
 (SETCONSTANTS
  (!*ILISPCASEUP NIL)
  (!*SHPCASEUP NIL) ) )

% Suppress compiler timings or messages.
(IFP (BOUNDP '!*NOTIME) (SETQ !*NOTIME T) (SETQ !*PWRDS NIL))

(DE SLISPTOP ()
 (QTRPRI)
 (TERPRI)
 (PROMPT)
% Reset reader if it just had an eof.
 (IFP (FNP 'CLEAR!-EOF!-STATUS) (CLEAR!-EOF!-STATUS))
 (SLET ((S!- (SLET ((!*ECHO !*TTYECHO)) (ERRSETT (READ)))))
  (COND
   ((AND (PAIRP S!-) (NOT (EQ (SETQ S!- (CAR S!-)) !$EOF!$)))
    (DFEVAL S!- T) )
   ((NOT (EQ S!- !$EOF!$)) NIL)
   (!*INT (TERPRI) (BELL))
   (T (BYE)) ) ) )

% Error recovery bug in old Culisp versions (Used for Atari):
(IFP (LESSP 1.05 (SYSTYPE 'LISPVERS))
% Variables that must be reset. Extend list as appropriate.
 (SETFLUIDS (RESET!* (!*ECHO NOMSG))) )

(DE NEWLISPTOP () (PROG (!*ERRMSG STK!&VL)
 (UNTIL NIL
  (IFP (BOUNDP 'RESET!*)
   (FOREACH VR IN RESET!* DO (STNIL VR)) )
  (RESTOREPROMPT)
  (SETQ STK!&VL (CAPTURESFSTKS))
  (COND
   ((OR (NULL !*BACKTRACE) (AZEROP !*BACKTRACE)) (SETQ !*BACKTRACE 1)) )
  (ERRORSET '(CATCH NIL (XSLISPTOP)) (SETQ !*ERRMSG !*BACKTRACE))
  (PRINCL "Returning to top level")
  (TERPRI)
  (UNBINDSFSTKS NIL STK!&VL) ) ))

% Preparation for bugfix for Culisp version 1.08 and 1.09 only (?). JEA.
(IFP
 (MEMBER (SYSTYPE 'LISPVERS) '(1.08 1.09))
 (SETFLUIDS !*BREAK) )

(DE EXTRAINIT ()
 (PROGN
  (CAR!-NIL!-LEGAL NIL)
  (IFP
   (MEMBER (SYSTYPE 'LISPVERS) '(1.08 1.09))
   (SETQ !*BREAK T) ) ) )

(IFP (EQ (SYSTYPE 'MACHINE) 'ATARI)
 (SETQ !!COMMANDLINE NIL)  % No command line interpreter yet on Atari
 (SETQ !!COMMANDLINE T) )

(IFP !!COMMANDLINE (CPROGN

(SETFLUIDS DUMPDIR IMAGEDIR CORESIZE)

% Initialise !*INT to NIL if BACKGROUNDP or QBT is true. JEA.
(IFP (FNP 'BACKGROUNDP) (NOTLOADTIME
  (DS SETBATCH (QBT) (NOT (OR QBT (BACKGROUNDP)))) ))

(SETGLOBALS ARGV!*)

(DE INITCOMMANDLINE ()
% Bugfix for Culisp version 1.08 and 1.09 only (?). JEA.
 (IFORL X ((ARGV -1) 1 -1) (XPUSH ARGV!* (ARGV X)))
 ARGV!*)

(DS NEXTONCOMLIN () (SLET ((AAAA ARGV!*))
   (COND (AAAA (SETQ ARGV!* (CDR ARGV!*))))
   AAAA ))

(DE SEXPRFROMCOM ()
 (SLET ((A (CHKERARGV)) B)
  (WHILE
   (AND (NOT (PAIRP (SETQ B (ERRSET (REREADSTRING A) NIL))))
    (SETQ B (NEXTONCOMLIN)) )
   (SETQ A (CONCATID A " " B)) )
  (COND
   (B (CAR B))
   (T (REREADSTRING A)) ) ) )

(DE REREADSTRING (X) (COMPRESS (EXPLODEC X)))

% Culisp switch -I to specify directory for Lisp image.
% Example '/usr/hlh/lisp -I /users/sheep/shp/sheep'.
(DC !I INITLINEFN ()
 (SETQ TOPDIR!* (PREFIXOF (SETQ IMAGEDIR (CHKERARGV)))) NIL)

% Culisp switch -D to specify dump directory.
% Example '/usr/hlh/lisp -I /usr/hlh/image -D /users/sheep/shp/slisp'.
(DC !D INITLINEFN () (SETQ DUMPDIR (CHKERARGV)) NIL)

% Culisp switch -S for memory size, e.g. add ' -S 3M' (note spacing)
% to your command line to get 3 Megabytes.
(DC !S INITLINEFN () (SETQ CORESIZE (CHKERARGV)) NIL)

(DC !Q INITLINEFN () NIL)       % Start quietly.

(DC !T INITLINEFN () NIL)       % Unsets traps, for system debugging.

(DC !O INITLINEFN () NIL)       % To enable Culisp options (see manual).
% Note: Unfortunately you have to stand some complaints from sheep as
% you say e.g. 'sheep -ON1' as sheep would interpret N1 as further
% switches while Culisp require that argument N1 follows O with no
% space in between. JEA

%(DC !M INITLINEFN () NIL)      % Was this one used in old Culisps? JEA

(IFP (FNP 'BACKGROUNDP) (FLAG '(SETBATCH) 'LOSE))
(FLAG
 '(INITCOMMANDLINE NEXTONCOMLIN SEXPRFROMCOM)
 'LOSE)  % These have been defined in the present file.
))                              % End of IFP !!COMMANDLINE

(FLAG
 '(SLISPTOP NEWLISPTOP EXTRAINIT)
 'LOSE)  % These have been defined in the present file.

(INCLUDE "../slini.sl")

(REMFLAG
 '(SLISPTOP NEWLISPTOP EXTRAINIT SETBATCH
   INITCOMMANDLINE NEXTONCOMLIN SEXPRFROMCOM)
 'LOSE)  % These have been defined in the present file.

(DE DATETIME () (BLDMSG "%w  %w" (DATE) (TIMEOFDAY)))

(IFP !*COMP (MODULE 'EXFN3))    %:LH  SAVERUN, SHPDEBUG

% X!& and its value will be left as garbage in the saved image.
(DFEXPR SAVERUN (X!&)
 (SETQ !*ERRMSG (SETQ !*IPRN T))
 (FOREACH Y IN SFSTKS!* DO (STNIL Y))
 (FOREACH Y IN SAVEDO!* DO (COND ((PAIRP Y) (EVAL Y)) (T (STNIL Y))))
 (SETQ MODULNAM!* 'UNKNOWN)
 (SETQ LOADMSGTAB!* 0) 
 (SETQ PG!_NUM!* 1)
 (SETQ LI!_NUM!* 1)
 (EXCISE NIL)
 (COND (X!& (COND ((NOT (FILEP (SETQ X!& (SETCASE X!&))))
                   (SYSTEM (BLDMSG "mkdir %w" X!&)) ))
            (DUMPFILE X!&) ))
 (COND
  ((AND (BOUNDP 'NOSAVE) NOSAVE)
   (PRIN2T "Ready to be saved") )
  (T (PRIN2T "About to save")
     (PRESERVE 'SLISPINIT) )) )

% SHPDEBUG(SW:boolean or number):Number
(DE SHPDEBUG (X)
 (PROG1 !*SHPDEBUG
  (COND
   ((NULL X) (SETQ X 1))
   ((NOT (NUMBERP X)) (SETQ X 5)) )
  (BACKGAG (SETQ !*SHPDEBUG (SETQ !*ERRMSG (SETQ !*BACKTRACE X))))
  (COND
   ((AZEROP X) (VERBOS X) (SETQ !*MSG (SETQ !*LOADMSG NIL)))
   ((IGREATERP X 1)
    (VERBOS (COND ((IGREATERP X 5) X) (T 1)))
    (SETQ !*MSG (SETQ !*LOADMSG T)) ) ) ) )

%### EXFN2.SL end
