%### INCLDE.SL ======================================================
%
%       INCLDE.SL
%       ---------
%
%       Copyright (c) 1984 by Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden and
%       Jan E. Aman, School of Mathematical Sciences, Queen Mary
%       College (U. of London), Mile End Road, London E1 4NS, UK.
%
%       This file defines a temporary version of INCLUDE that is
%       needed for bootstrapping.
%
%====================================================================

(FLUID '(CURRENTDIR!* !*IPRN !*ECHO))

(SETQ !*IPRN T)         % INCLUDE normally prints out.

% This definition of INCLUDE is temporary, to be used in bootstrapping.
% See LOAD.SL for the final definition.

% This crude way to define a macro may hopefully work in all versions
% of Culisp.
(APPLY
 (CDR
  (OR
   (GETD 'DCM)                  % For ACN Culisp.
   (GETD '!%DM)                 % For JPFF Reduce.
   (GETD 'DM) ) )               % For JPFF Culisp.
 '(INCLUDE U (LIST 'IINCLUDE (LIST 'QUOTE U))) )
% (DCM INCLUDE U (LIST 'IINCLUDE (LIST 'QUOTE U)))
% (DMM INCLUDE U (LIST 'IINCLUDE (LIST 'QUOTE (CDR U))))

(DE IINCLUDE (U)
 (PROG (OLDCH Y X W)
  (COND
   (CURRENTDIR!*
    (COND
     ((AND                                              % Back up one
       (EQCAR (SETQ Y (EXPLODEC (CAR U))) '!.)          % directory
       (EQCAR (CDR Y) '!.)                              % level, but
       (EQCAR (CDDR Y) '!/) )                           % only one.
      (SETQ U (SETQ X (EXPLODEC CURRENTDIR!*)))
      (PROG NIL
NEXT   (COND
        ((AND
          (SETQ U (OR (MEMQ '!\ (CDR U)) (MEMQ '!/ (CDR U))))
          (CDR U) )
         (SETQ W U)
         (GO NEXT) ) ) )
      (RPLACD W (CDDDR Y))
      (SETQ Y X) ) )
    (CLEARBUFF)
    (PROG NIL
BACK (COND (Y (PACK (CAR Y) NIL) (SETQ Y (CDR Y)) (GO BACK))) )
    (SETQ U (MKATOM)) )
   (T (SETQ U (CAR U))) )
  (SETQ OLDCH (RDS (OPEN U 'INPUT)))
% (SETQ OLDCH (RDS (OPEN (STRTOID U) 'INPUT)))
  (TERPRI) (PRINC "Including file: ") (PRINC U) (TERPRI)
NEXTRD
  (SETQ Y (READ))
  (COND
   ((EQ Y !$EOF!$)
    (CLOSE (RDS OLDCH))
    (TERPRI) (PRINC U) (PRINC " done include") (TERPRI)
    (RETURN "Finished loading") )
   ((NOT (PAIRP (SETQ X (ERRORSET Y T))))
    (COND ((NOT !*ECHO) (PRINT Y)))
    (ERROR 440 "Error return") )
   (!*IPRN (PRINT (CAR X))) )
  (GO NEXTRD) ))

% Bug in Culisp: (PACK ... T) gives upper case, not lower.
% Bugs in PACK finally fixed 13 Dec 1984.
% New definition April 1985 Last arg:
% NIL                           unchanged
% !*RAISE or pos. integer       force upper case
% !*lower or neg. integer       force lower case
%(DE STRTOID (STRING)
% (PROGN (CLEARBUFF) (PACK STRING NIL) (MKATOM)))

%### INCLDE.SL end
