%### MKSL.SL ========================================================
%
%       MKSL.SL
%       -------
%
%       Copyright (c) 1984 by Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden and
%       Jan E. Aman, School of Mathematical Sciences, Queen Mary
%       College (U. of London), Mile End Road, London E1 4NS, UK.
%
%
%       This file contains the commands executed in Cambridge
%       University Lisp to build a compiled Sheep Lisp.
%
%====================================================================

(SETQ !*RAISE NIL)

(SETQ !*COMP NIL)

(COND ((NOT (GETD 'INCLUDE)) (RDF 'ldint!.sl)))

(COND ((NOT (GETD '!$ERRFORM)) (INCLUDE "excom.sl")))

(SETQ !*COMP T)

(INCLUDE "exfn1.sl")

(MODULE 'EXSLMC)  (INCLUDE "excom.sl")  (ENDMODULE)

(INCLUDE "exint.sl")

(MODULE 'EXFN2)   (INCLUDE "exfn2.sl")  (ENDMODULE)

(MODULE 'PRINTF)  (INCLUDE "printf.sl") (ENDMODULE)

(MODULE 'LOAD)    (INCLUDE "load.sl")   (ENDMODULE)

(IFP            %:Atari skip luxury
 (NOT (AND (EQ 'ATARI (SYSTYPE 'MACHINE)) (LESSP (SYSTYPE 'MEMORY) 2)))
 (CPROGN (MODULE 'NEWNAM) (INCLUDE "../newnam.sl") (ENDMODULE)) )

% Original version:
%(MODULE 'SMODUL) (INCLUDE "smodul.sl") (ENDMODULE)
% New version:
(MODULE 'SIDMOD)  (INCLUDE "sidmod.sl") (ENDMODULE)

(SETQ !*COMP NIL)

(FOREACH FN IN LOCALFUNCTIONS!* DO
 (COND ((CODEP (GETFN FN)) (REMOB FN))) )       % Remove from oblist.
(SETQ LOCALFUNCTIONS!* NIL)             % Release list storage.

(SETQ DATE!* (DATETIME))

(SAVERUN NIL)

%### MKSL.SL end
