%### SIDMOD.SL ======================================================
%
%       SIDMOD.SL
%       ---------
%
%       Copyright (c) 1988 by Jan E. Aman and Inge Frick, Institute of
%       Theoretical Physics, University of Stockholm, Vanadisvagen 9,
%       S-113 46  Stockholm, Sweden.
%
%       This file contains code to make side modules for the PSL
%       as well as the Culisp version of Sheep Lisp.
%
%====================================================================

% RESIDEFUNCTIONS!* is used only for Lisps where you wish to save and
% use the compiling image (i.e. for Culisp). It is set to the value
% (RESIDETENSORS) in Sheep.
(IFP (EQ 'CULISP (SYSTYPE 'LISPSYSTEM))
 (CPROGN
  (SETGLOBALS RESIDEFUNCTIONS!*)
  (SETFLUIDS SIDEFL!*) ))

% MKSIDEFAP will make a fast loading file (for functions to become
% available after a LOAD command only). Arguments are one or more
% source files, name will be determined from first specified file name.
(DS MKSIDEFAP (FL1 !&REST FLL) (XMKSIDEFAP 'FL1 'FLL))

(DE XMKSIDEFAP (FL1 FLL)
  (SLET (FIL!*)
    (IMKSIDEFAP (CADR (FILNAM FL1)) (CONS FL1 FLL)) ) )

% Obsolete.
(DS SIDEFAP (MN RS !&REST FLL) (RMKSIDEFAP 'MN 'FLL 'RS))

% IMKSIDEFAP is an expr version of MKSIDEFAP with module name and
% file list as arguments.
(IFP (GLOBALP 'RESIDEFUNCTIONS!*)
 (DE IMKSIDEFAP (MN FLL) (RMKSIDEFAP MN FLL RESIDEFUNCTIONS!*))
 (DE IMKSIDEFAP (MN FLL) (RMKSIDEFAP MN FLL NIL)) )

% RMKSIDEFAP is an expr version of MKSIDEFAP with module name,
% file list and reside functions as arguments.
(IFP (NOT (GLOBALP 'RESIDEFUNCTIONS!*))
 (DE RMKSIDEFAP (MODULNAM!* FLL RS)
  (PROGN
   (XPUSH MODULESTK!* NIL)
   (FASLOUT (SETCASE MODULNAM!*))
   (FOREACH FIL IN FLL DO
    (LOADX FIL MSEARCHLIS!*
     (DELETE FASLOUTEXT!* (DELETE 'PSEUDO!-FILE MEXTLIS!*))
     'N NIL ) )
   (FASLEND)
   (UNPUSH MODULESTK!*)
   MODULNAM!* ) )
 (CPROGN
% This is (e.g.) for Culisp:
  (DE RMKSIDEFAP (MODULNAM!* FLL RS)
   (SLET
    ((OST (FOREACH FN IN RS COLLECT (FUNCALL FN NIL)))
     (OML (COPYT MLIST!*))
     PFN
     SIDEFL!*
     A )
    (COND
     ((NOT (IDP MODULNAM!*))
      (ERRORFT 445 "Module name %p is not an identifier" MODULNAM!*) ) )
    (XPUSH COMPFLGSTK!* !*COMP)
    (SETQ !*COMP (OR !*COMP !*MODULCOMP))
    (XPUSH MODULESTK!* NIL)
    (FASLOUT MODULNAM!*)
    (SLET ((DFPRINT!* 'SIDE!-OUT) (!*DEFN T) (!*MSGTOFILE NIL))
     (FOREACH FIL IN FLL DO
      (LOADX FIL MSEARCHLIS!*
       (DELETE FASLOUTEXT!* (DELETE 'PSEUDO!-FILE MEXTLIS!*))
       'N NIL ) ) )
    (SETQ PFN (CONCATID MODULNAM!* PUTCHR!* 'PSEUDO!-FILEFN))
    (FLUID (LIST PFN))
    (XPUSH SIDEFL!* (LIST 'SETQ PFN (CONSA 'FASL MODULNAM!* PFN 0)))
    (PUTD PFN 'EXPR (LIST 'LAMBDA () (MKPROGN (REVERSIP SIDEFL!*))))
    (PUT MODULNAM!* 'PSEUDO!-FILEFN PFN)
    (FASLEND)
    (UNPUSH MODULESTK!*)
    (SETQ !*COMP (CAR COMPFLGSTK!*))
    (SETQ COMPFLGSTK!* (CDR COMPFLGSTK!*))
    (FOREACH FN IN RS COLLECT
     (PROGN (SETQ A (FUNCALL FN OST)) (UNPUSH OST) A))
    (SETQ MLIST!* OML)
    MODULNAM!* ) )

  (DE SIDE!-OUTS (X) (XPUSH SIDEFL!* X))

  (DE SIDE!-OUT (X) (SLET (A B C D) (COND
    ((NOT (PAIRP X)) (SIDE!-OUTS X))
    ((EQ (CAR X) 'CPROGN) (FOREACH Y IN (CDR X) DO (SIDE!-OUT Y)))
    ((AND (EQ (CAR X) 'PUTD)
          (EQCAR (SETQ A (CADR X)) 'QUOTE)
          (EQCAR (CAR (SETQ B (CDDR X))) 'QUOTE)
          (EQCAR (CADR B) 'QUOTE) )
     (SETQ D (CONCATID MODULNAM!* '!% (CADR A)))
     (SIDE!-OUTS (LIST 'MOVD A (MKQUOTE D)))
     (PUTD D (CADAR B) (CADADR B)) )
    ((AND (EQ (CAR X) 'PUTC)
          (EQCAR (SETQ A (CADR X)) 'QUOTE)
          (EQCAR (SETQ B (CADDR X)) 'QUOTE)
          (FLAGP (CADR B) 'COMPILE)       
          (EQCAR (SETQ C (CADDDR X)) 'QUOTE)
          (EQCAR (SETQ C (CADR C)) 'LAMBDA) )
     (SETQ D (CONCATID MODULNAM!* '!% (CADR A) PUTCHR!* (CADR B)))
     (PUTD D 'EXPR C)
     (SIDE!-OUTS (LIST 'PUT A B (MKQUOTE D))) )
    ((EQUAL X (SETQ A (MACEXPD1 X))) (SIDE!-OUTS X))
    (T (SIDE!-OUT A)) )))
  ) )

%### SIDMOD.SL end
