;### SLISP.L ========================================================
;
;       SLISP.L
;       -------
;
;       Copyright (c) 1982 by Inge Frick, Institute of Theoretical
;       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden.
;
;       This file defines some Sheep Lisp functions for the
;       interpreter. Compiler definitions are different. The rest of
;       the Sheep Lisp functions are defined in SLFUNS.L which is
;       loaded through an "include" in the present file.
;
;====================================================================

(declare (localf Baktrace))

(defun samedefX (newname oldname)
 (let ((fn (getd oldname)))
  (cond
   (fn (putd newname fn) newname)
   (t (print (list newname oldname 'undefined))) ) ) )

(putd 'samedef (getd 'samedefX))

(include "slfuns.l")


; Top Level

(defun SLISPTOP ()
; Defined in SLINI.SL
 (terpri)
 (cond ((and (status isatty) (null piport)) (patom "SL> ")))
 (let ((S- (errset (READ) nil)))
  (cond
   ((not (dtpr S-)))
   ((not (eq (setq S- (car S-)) $EOF$)) (terpri) (PRINT (EVAL S-)))
   ((not (status isatty)) (exit))
   (t (terpri) (tyo 7)) ) ) )

;### SLISP.L end
