%### LDINT.SL =======================================================
%
%       LDINT.SL
%       --------
%
%       Copyright (c) 1988 by Jan E. Aman and Inge Frick, Institute of
%       Theoretical Physics, University of Stockholm, Vanadisvagen 9,
%       S-113 46  Stockholm, Sweden.
%
%       This file contains the essential part of the commands executed
%       in Portable Standard Lisp (PSL) to build Sheep Lisp.
%
%====================================================================

(SETQ !*BREAK NIL)              % Don't use PSL break by default.

(SETQ !*PRINTLOADNAMES T)       % Message as PSL modules are loaded.

% NBIG (rather NBARITH) redefines them incorrectly.
% ZEROP buggy in PSL 3.4 20-Feb-90 (for sun4), FLOATLESSP and
% FLOATGREATERP in PSL 3.4 2-Feb-92 (for mips_dec). JEA.
(FLAG '(ZEROP FLOATLESSP FLOATGREATERP) 'LOSE)
(LOAD NBIG)                     % PSL bignums.

(SETQ !*USERMODE NIL)           % Allow redefinitions of functions.

(SETQ !*EOLINSTRINGOK T)        % Allow end of line in strings.

(DSKIN "inclde.sl")

(COND
 ((NOT (OR
        (GETD 'GETSTARTUPNAME)  % A test for Unix.
        (GETD 'MACHINENAME) ))  % A test for VMS PSL 3.2 (or earlier).
  (INCLUDE "dirfix.sl") ) )     % Load fix for VMS version before 3.2A.

(COND
 ((GETD 'GETSTARTUPNAME)        % Test for Unix-PSL. A bad test.
  (LOAD ADDR2ID) ))             % Provisional fix. Enables debugging.
                                % Should be done only for PSL 3.4?

(INCLUDE "exfn1.sl")

% Used for testing which system is running.
(SETQ !*RSHEEP NIL)

(INCLUDE "systyp.sl")
(INCLUDE "exint.sl")
(INCLUDE "exfn2.sl")
(INCLUDE "printf.sl")
(MOVD 'OINCLUDE 'INCLUDE)       % May be omitted when everything works.
(INCLUDE "load.sl")

% List of extensions searched for:
(SETQ MEXTLIS!* '(LAP B SL))
(DPUT SLLSPEXT SUBDRS SL)       % Extension for Sheep Lisp sources.
(DPUT SHPSRCEXT SUBDRS SHP)     % Source extension for Sheep.

(OINCLUDE "../newnam.sl")       % INCLUDE should also work here.

(SETPROMPTER "SL> ")

% Set up search list. MSEARCHLIS!* is reset in SSLISP.INI.
(SETQ MSEARCHLIS!* '(NIL HERELIST))
(ADDSUBDIRS (LIST TOPDIR!*)
 '("slsrc" "slbin") )
(ADDSUBDIRS NIL LISPLIBDIR!*)   % Lisp library directories.
(ADDSUBDIRS (LIST TOPDIR!*)
 '(NIL (("shpsrc" LISPSYS)) "shpsrc" (("slsrc" LISPSYS))) )

(SETQ MLIST!* OPTIONS!*)        % Keep information on PSL modules.

%### LDINT.SL end
