%### SYSTYP.SL ======================================================
%
%       SYSTYP.SL
%       --------
%
%       Copyright (c) 1988 by Jan E. Aman and Inge Frick, Institute of
%       Theoretical Physics, University of Stockholm, Vanadisvagen 9,
%       S-113 46  Stockholm, Sweden.
%
%       This file contains the SYSTYPE commands that tells which host
%       etc. that you have. Edit it appropriately for your site.
%
%====================================================================

% Most things will be figured out from PSL, Unix environment variables
% etc. The SITE defaults to VANADIS (Physics at Univ. of Stockholm)
% for VMS installations.

% Change SITE and operating system version etc. if different
% from that given below.

(IFP (AND (GETD 'GETENV) (GETENV "HOST"))
 (SETSYSTYPE 'NODE
  (COND ((NOT (EQUAL "" (GETENV "HOST"))) (GETENV "HOST"))) )
 (IFP (AND (GETD 'MACHINENAME) (EXPLODE2 (MACHINENAME)))
  (SETSYSTYPE 'NODE
   (INTERN (COMPRESS (EXPLODE2 (MACHINENAME)))) )
  (SETSYSTYPE 'NODE 'VAND) ) )          % Default node for VMS PSL 3.2.

% DOMAINNAME is to be defined in .shpmanrc (or here).
% Specify SITE if not clear from DOMAIN specification.
(IFP (AND (GETD 'GETENV) (GETENV "DOMAINNAME"))
 (SETSYSTYPE 'DOMAIN
  (COND
   ((NOT (EQUAL "" (GETENV "DOMAINNAME"))) (GETENV "DOMAINNAME")) ))
 (IFP (NOT (AND (GETD 'MACHINENAME) (EXPLODE2 (MACHINENAME))))
  (PROGN
   (SETSYSTYPE 'SITE 'VANADIS)          % Default site and domain for
   (SETSYSTYPE 'DOMAIN "physto.se") ) ) ) % VMS PSL 3.2.

(IFP (AND (GETD 'GETENV) (GETENV "MACHINE"))
 (PROG (MA)                             % Unix case.
  (SETQ MA (INTERN (COMPRESS (EXPLODE2 (GETENV "MACHINE")))))
  (COND
   ((EQ MA 'SUN4)
    (SETSYSTYPE 'MACHINE 'SUN)
    (SETSYSTYPE 'MACHINEVERS 4))
   ((EQ MA 'SUN)
    (SETSYSTYPE 'MACHINE 'SUN)
    (SETSYSTYPE 'MACHINEVERS 3))
   (T (SETSYSTYPE 'MACHINE MA))))
 (PROGN                                 % VMS case.
  (SETSYSTYPE 'MACHINE 'VAX)
  (IFP (GETD 'HARDWAREVERSION)
   (SETSYSTYPE 'MACHINEVERS (HARDWAREVERSION))
   (SETSYSTYPE 'MACHINEVERS 8530) ) ) ) % VAX-8530 default for 3.2.

(SETSYSTYPE 'LISPSYSTEM 'PSL)

(IFP (GETD 'GETSTARTUPNAME)
 (PROGN
  (SETSYSTYPE 'OS 'UNIX)
  (SETSYSTYPE 'OSTYPE 'BSD)
  (SETSYSTYPE 'OSVERS 4.3)
  (SETSYSTYPE 'LISPVERS 3.4) )
 (PROGN
  (SETSYSTYPE 'OS 'VMS)
  (IFP (GETD 'SOFTWAREVERSION)
   (SETSYSTYPE 'OSVERS (COMPRESS (CDR (EXPLODE2 (SOFTWAREVERSION)))))
   (SETSYSTYPE 'OSVERS 5.1) )
  (IFP (GETD 'MACHINENAME)
   (SETSYSTYPE 'LISPVERS '!3!.2A)
   (SETSYSTYPE 'LISPVERS '!3!.2) ) ) )

%### SYSTYP.SL end
