%*** STENE6.MAN ****** New text in edition 6 of manual **********************
*                                                                           *
*              Update up to the nov 1986 STENSOR manual (ed 6)              *
*                                                                           *
*  Major part of the extra material that edition 6 from nov  86	(for 2.26)  *
*               contains, as compared to edition 5 from july 86	(for 2.25)  *
*									    *
*                             Nov 1986                                      *
*                                                                           *
*                          Lars  Hornfeldt                                  *
*                                                                           *
*****************************************************************************



1  ^<<INTRODUCTION:  A SAMPLE SESSION^>>

The computer interaction is to the left,
with all user input underlined:        	Comments indented to the right:

Username: ^<_kilroy^>_                        First login, giving your username
Password: ^<_washere^>_                       and some secret word (will not be seen).

 ....   After loginmessages, you are left talking to the operating system,which
        signals its readiness with a "@$" or "@%" as prompter. Then you could do:

@$ ^<_TYPE STSD:VMS.HLP^>_             -for an introduction to VMS operating system,
@% ^<_cat @$stsd/unix.hlp^>_            -or this for the corresponding unix-help.

TYPE/cat are simple commands, returning with the VMS/unix-prompter afterwards.
Other symbols, like "STENSOR" or "EMACS" start up complicated programs with
their own continuing user dialogue. Emacs is an editor, see STSD:EMACS.HLP.

@$ ^<_STENSOR^>_	Now start up stensor (use O/NSTENSOR for old/new version)
                Whereby you get a greeting message telling version number etc:

STENSOR 2.25 (on Sheep 48) welcomes you (15 Nov 1986)
                In computer algebra systems you assign formulae to symbols for
                later reference.  In STENSOR this assigning function is called
                ^<<PDEF^>> (for "Put DEFinition").  Formulae may in STENSOR be
                nonscalar - contain tensors with letters as indices - and the
                system knows eg that a repeated index means summation.  After
                the STENSOR prompter, let us now Put a DEFinition on C.  Use
                parens around PDEF and argument:

STS> ^<_(PDEF C)^>_   This tells the system to read a formula.  In next line
                it asks with "=".  After it, we type in matrices A times B:

=^<_<A K L> <B L M> @$^>_      Each object with indices should be surrounded by
                "<" and ">".  End the formula with dollar.  Since L is repeated,
                it is understood to be a contraction index in this formula,
                representing summation (as in matrix multiplication).
.E
C   = A  B      The system confirms that the formula was accepted by writing
 km    kl lm    out the DEFinition nicely, with K and M as free indices!

                Formulas are mainly used in two ways:
                EDEF    Evaluates an indicial formula, giving a new.
                TCOMP   Generates a program for computing the components.
                The chapter on SPLITTING describes an hybrid of these.

                The Riemann tensor can be defined by:  ("A34" declares antisym.
STS> ^<_(PDEF RIE1 R A34)^>_          -in indices 3 and 4, "R" = abbreviation)

=^<_<GAMU J K ^[M ,^[L> + <GAMU I K ^[M><GAMU J I ^[L> @$^>_

 j          j           i      j
R     =  GAM        +GAM    GAM
  klm        k^[m,l^]      k^[m    il^]

                                                                          Page 2



                (GAMU had previously an abbreviation GAM, symmetry S23,
                and an index up - causing RIE1 have the same index up.
                    Covariant differentiation is indicated with ";" -

   a        a        a        a                 - thus this formula:
BIA      = R       +R       +R
    bcde     bcd;e    bde;c    bec;d            -could be inserted as:

STS> ^<_(PDEF BIA)   <RIE1  A  B  (C  (D  ;(E> @$^>_
                -Where "(" cause cyclic permutation, see "DOPERM".
.P
    ^<<EDEF^>> evaluates a definition, simplifies and writes.  By calling it
    we can now show that this cyclic sum BIA is zero (the Bianchi identity).
    The effect of evaluation on a covariant differentiation is to replace it
    with ordinary differentiation plus proper contractions with the Christoffel
    symbol GAMU.  BIA then gives initially 15 terms, that combine to 9 due to...
.E
STS> ^<_(EDEF BIA)^>_          ...index symmetries. Then EDEF starts its own
15/9 TERMS BIA  Action? ^<_W^>_       dialogue (try "?"). W requests W-riteout:
   a          a        a        a        i      a     i      a     (four
BIA      =  -R       +R       -R       -R    GAM    +R    GAM    -  more
    bcde       bce,d    bde,c    bdc,e    bce    di    bde    ci    terms)
.P
               The system here introduced the dummy symbol "i", after first
               checking that it didn@'t already occur.  The contravariant
               character of the 1:st RIE1-index was used.  This expression is
               now the new definition of BIA.

BIA Action?  ^<_E^>_  We then ask EDEF for E-valuation again (?  for menu).
               Thereby each occurence of RIE1 is replaced with its definition,
               but with correct free indices inserted, and with j as dummy since
               i already was in use.  The result then comes:

42/0 TERMS Became zero!         -Using the symmetries of GAMU and multiple
               derivatives, and by renaming dummies, EDEF finally found that all
               resulting 42 terms in BIA cancelled as they should!
    EDEF is clever; also try (LOAD "IDENTR.DEF") or (LOAD "SMRING.DEF").

A definition was above inserted for RIE1.  With the command:
"(^<<TCOMP^>> RIE1)"   -the DEF of RIE1 is analyzed and a program
corresponding to it is generated (that performs the differentiations of GAMU and
summations over i).  TCOMP also declares "SHEEP-arrays" corresponding to the
ranks and symmetries of GAMU and RIE1 for the storing of their components.
If there are algebraic expressions for the individual GAMU-components, the
TCOMP-generated program directly computes the individual components of RIE1 (and
other TCOMPed objects) upon the SHEEP command "(MAKE RIE1)".
                See further the respective chapters on PDEF, EDEF and TCOMP.


                                Finally EXIT from STENSOR by keeping the...
STS> ^<_@^Y^>_	...control-key down and push Y.  (@^Z in unix).
@$ ^<_logout^>_	Tell the operating system you want to end the session.

                                                                          Page 3


2  ^<<TENSOR ALIAS, PACKAGE^>>

The same set of objects can often be computed in different formalisms.  Then you
might have two (or more) alternative DEF-files for these same set of objects.
Typical of this is in relativity, where objects RIE, RIC etc can be computed in
a coordinate basis (file CORD.DEF) or in a moving frame (eg file GFRAME.DEF).
The RIE object for instance, will then have differing definition, and
components, in CORD and GFRAME.  To avoid collision if both files are loaded,
their internal names of RIE are different, RIEC (in Cord) and RIEF (in gFrame).
The user may use these internal names, but he may also use RIE and have the
system translate by means of an aliaslist, TENALIAS!* global ^[nil^].  If its
value is (...(RIE RIEF) ...) then the input RIE is interpreted as RIEF in:
        -formula input, like:    <RIE A B C D><GUU A C>@$     -and in:
        -all commands, like:    (PDEF RIE), (TCOMP RIE) and (MAKE RIE)
        (but not pure lispcommands).

Formulas/commands in a file being loaded are not excepted from translation.  At
the start of CORD and GFRAME.DEF, a TENALIAS!* is set up, so the PDEF commands
use names without any F/C.  Then the same input line in CORD and GFRAME:
(PDEF RIE) <GAM..    is interpreted differently due to translation, eg as:
(PDEF RIEF)<GAMF..    -in GFRAME.
Thus when typing (MAKE RIE), the formalism used for the computation depends on
the current TENALIAS* value.

TCOMPOUT puts in the BLF-file also the current value of TENALIAS*, so it is
restored when loading the BLF-file also into pure SHEEP.  If you load both
BLF-files, the resulting TENALIAS*-value comes from the file last loaded.



2.1  QUOTING CHARACTER

The translation can be escaped by either:
-referring to the internal name:  (MAKE RIEC) or (PDEF RIEC) <GAMC ..., or
-preceding the name with a single quote:  "@'".  This latter works in both
commands and formulae, but only in STENSOR, eg (PDEF @'RIE) <@'GAM ...



2.2  PACKAGE SYMBOL (STENSOR ONLY)

You need not construct the TENALIAS* yourself; Example:  by (SETQ PACKAGE @'F) at
start of GFRAME.DEF, an F would be appended on each new tensorname henceforth,
and also the TENALIAS* being built up.  Objects that you want untranslated,
would then however need a @' eg @'GDD.

The strategy is to minimize explicit names in your DEF-files; then a file
defining eg the RIE square could be equally well loaded into CORD as GFRAME.  By
using .  and  in PDEF you need not explicitely name the metric either.

                                                                          Page 4


3  ^<<ADDITIONAL COMMANDS IN BLF-FILES^>>

TCOMPOUT puts the current value of POSTBLF!* ^[global^] at end of each BLF-file it
creates.  This is for communicating extra commands/information from the DEF file
to the BLF file.
If your DEF file has:    (SETQ POSTBLF!* @'(PRINC "Copyright Kilroy"))   -then
TCOMPOUT puts this (PRINC.. ) at the end of the blf-file, so whenever later
loaded, the blf-file will each time end by executing that PRINT command.
This is used for arbitrary extra setup commands.  Often you want the command
executed already when the DEF-file is loaded too; then enclose with eval there:
        (EVAL (SETQ POSTBLF!* @'(PRINC "Copyright Kilroy")))
                See CORD and GFRAME.DEF for examples.

PREBLF!* ^[nil^] list of function names.  At the beginning of the BLF-file,
    TCOMPOUT puts the definitions of all functions named in this list.  Add to
    it, to have TCOMPOUT save also your private functions if any.




(REMFIRST n tno tnc) Removes 1:st n tensorial factors in all tno-terms and puts
    result on tnc as definition.  As COPYDEF, but for the removal.  Which
    indices are free and dummy is reanalyzed, so tnc gets proper rank.

    Use ORDER+SDEF to have those objects desired to be removed, moved leftmost,
    before calling REMFIRST.

    NOTES:
    The first n factors MUST be identical in each of the terms, inclusive of
    their indices (user responsibility).
    NO diff-factors like <GDD A B ,C> are removed - only SIMPLE tensors!

    If (a)symmetric contracted objects were removed, you might consider to take
    the (a)symmetric part of the resulting copyobject tnc.

ORDNUMG global ^[T^] order nbrs growing.

ORDSUM global ^[nil^] -ORDER affect sum ordering (v.  2.26).



4  SUPER SUBSTITUTION LIST

-Or "SUP" for short, is a list of symbols, each being an ordinary substitution
list, "SUL".  Thus a "SUP" is a list of "SUL"s.  Initially there are three

                                                                         Page 5


SUPs, one for each situation, namely TSUP, SSUP and WSUP.  These have initially
values (TSUL), (SSUL) and (WSUL), but they may be extended to contain any
number of ordinary substitution lists.  Then for that situation, all the
enlisted substitution lists would be checked for, in that particular order.

(SETSUP sup sul1 sul2..) Set SUPer substitution list sup to consist of the
    individual substitution lists sul1 sul2...

    Example:  After (NEWISUL SUL1)...  and ..SUL2 to introduce two new Indicial
    substitution lists, then:
                         (SETSUP TSUP TSUL SUL1 SUL2 TSUL)
    -causes SUPerlist TSUP to be (TSUL SUL1 SUL2 TSUL), which means that normal
    TSULs are first searched for, then SUL1 and 2, and finally TSUL again
    (which might now succeed).  Thus the SUPerlists are means for easifying the
    administration of large amounts of substitutions; You organize the
    substitutions in groups, in their individual SULs, and can then easily
    activate/deactivate them, and put them in desired order, with SETSUP.

SETSUBPERM switch ^[on^] -cause SETSUB call DOPERM on mask/replacement.

(WORDER t1 t2..) -Write order (nbr/commutativity) of tensors/objects.  This
    function displays for each object both its ordering-number (set by ORDER),
    and its commutativity-properties if any.  Handy form:  (WORDER ALL) etc.
    Sample output:  (...  (t1 510) (t2 (520 NEVERCOMMUTEBUT tsra tsrb)) ...)
    -means that (ORDER 500 t1 t2) and (NEVERCOMMUTEBUT (t2) tsra tsrb) have
    been done.  Change by reissueing these, or inhibit them altogether by means
    of two functions:

(REMORDER t1 t2..) Remove ordernumbers of t1,t2,..  Then t1,..  will
    subsequently regain its internal ordering as of before the ORDER-command.
    Note 1:  As side effect, this inhibits any previous NONCOMMUTE in that it
             excludes t1..  from a NONCOMMUTE family of identical ordernumbers.
    Note 2:  Avoid this on diff-operators, or commuting objects with higher
             order may confusingly (though correct) occur on its RIGHT side.

(COMMUTE t1 t2..) Let commute -ie remove any NEVERCOMMUTE-declarations of
    t1,t2..  ie inhibit any NEVERCOMMUTE-command previously done on t1,..
    If no such had been done, then COMMUTE has no effect.
       Declarations of other objects are not inhibited, eg if:
    (NEVERCOMMUTE tsra tsrb..) -was previously done (or -BUT or DIFFOPERATOR),
    then t1 etc will after:  (COMMUTE t1..) still of course NOT commute with
    these special objects tsra...  (due to *THEIR* NEVERCOMMUTE-ativity).  To
    force such commutation, do also:  (COMMUTEWITH (tsra...) t1 t2..), or use:
    (ALWAYSCOMMUTE t1 t2..).



    5  ^<<TRIG^>>

Hyperbolic functions are SINH,COSH,TANH,COTH,SECH,CSCH.  (W)TRIG understands
    these, and exploits the sumrelation COSH(X)@^2 - SINH(X)@^2 = 1 analogous to
    the trigonometric relation.  All switches affect hyperbolic simplification
    exactly as trigonometric, even if not explicitely stated below.

                                                                         Page 6


SECCSC switch ^[on^] -use SEC and CSC (and SECH,CSCH) for negative powers of COS
    resp SIN, to compress output.  All six trig-functions (and hyperbolics) are
    always allowed at input.  To compactify the results, all six are normally
    also selected from at output.  Since SEC/CSC are not known to eg REDUCE
    however, sometimes you must avoid them in output through (OFF SECCSC).

TRIGHARDRPT ^[4^] -maximum number of passes that TRIG does - limit for practical
    reasons.  You might increase it, or reissue TRIG-commands.

(WTRIGLOOP) read/eval-tester.  Input :XS for 1-cos@^2, :XC for 1-sin@^2 etc.

SINCOSKEEP switch ^[off^] -Keep SINCOS internally.  Technical:  sin(x)@^p cos(x)@^q
    is internally represented as the more compact (SINCOS X P Q) by TRIG, which
    normally translates back when done.  By (ON SINCOSKEEP) the SINCOS is kept,
    saving space and time.  Drawback:  Little immediate SHEEP-simplification
    occur when multiplying such SINCOS-expressions; most reduction is then
    postponed to the TRIG-step.



6  ^<<COMMANDS FOR ORDINARY SHEEP-SUBSTITUTIONS^>>

-that can be called from naked SHEEP after (LOAD "SELFLD.STS"):

(SETSUBFOR sulis x a1 a2..an) mask(x)@$ repl(x)@$ -Sets up n substitutions:
    mask(a1) into repl(a1),..., mask(an) into repl(an), ie the single
    substitution pair provided (mask,repl) is duplicated with x being a1...an.
    Example:  (SETSUBFOR ESUL X A B C D) SIN(X)@^2@$ 1-COS(X)@^2@$   -sets up four
    substitutions:  SIN(A)@^2 into 1-COS(A)@^2,....and SIN(D)@^2 into 1-COS(D)@^2

  Variable list:  If a1...an are omitted, then the variables as declared by
    VARS are used instead.  Eg after (VARS A B C D) the above could be done as:
    (SETSUBFOR ESUL X) SIN(X)@^2@$ 1-COS(X)@^2@$   Sulis and x may NOT be omitted.

  In-symbol-change:  When duplicating the single mask(x)/repl(x)-pair, the
    x-character is replaced with a1...an also INSIDE SYMBOLS - this is for easy
    introduction of new "kernels" to save working space.
    Example:  (SETSUBFOR ESUL X A B C) X@^(1/2)@$ SQRTX@$   -sets up substitutions
    A@^(1/2) into symbol SQRTA,..and C@^(1/2) into symbol SQRTC.
    Example 2:  (SETSUBFOR ESUL X H FI) COS(X)@^2@$ COSX2@$
    -sets up substitutions for:  COS(H)@^2 into COSH2 and COS(FI)@^2 into COSFI2.

  Diff-know-how:  When the replacement is a symbol (as SQRTC or SINFI2 in above
    examples), differentiation properties are set up (if missing) for each
    symbol by differentiating the template (ie C@^(1/2) etc) w.r.to all
    variables.  Thus SHEEP automatically knows how to differentiate any new
    kernel introduced.

  Warning:  Since "In-symbol-change" is done in mask/repl, use a rare character
    as 2:nd arg s.a.  X,Y or Z.  Else eg (SETSUBFOR ESUL I) SINI2 @$ 1-COSI2@$
     -would cause substitutions for SANA2, SBNB2,...
    In-symbol-change is inhibited if a MULTIcharacter 2:nd arg is used.
    Technical:  In-symbol-change is done on ALL symbols inside mask/repl at ANY

                                                                         Page 7


    lisp-depth, example:  (SETSUBFOR ESUL X) TAN(X)@^2 @$ SINX2/COSX2 @$  -where
    repl is not a symbol, but a deep lisp-structure in which eg symbol COSX2 is
    found and changed to COSA2 in one of the substitutions set up.
    However, "indicators", ie symbols occuring FIRST in lists, are excempted.

(INVSUBS sulis t1 t2..) -invert substitutions "sulis" on tensors t1,t2,...
    Does LSIMP on t1,t2...  with a temporary ESUL made by inverting sulis.
    The argument "sulis" should be either:
                1:  -a list of (mask repl)-pairs explicitely given, or
                2:  -a symbol which has a list as value.
    The explicit list eventually pointed at, may be, or not be, a proper
    substitution list, ie start or not start with "SUBS".
    Good for eg inverting a previous temporary kernelization, after that the
    work-space critical computations have been successfully performed.

(ESULON esul t1 t2..) LSIMP tensors t1 t2..  with esul as ESUL-list.

(INVSULDO sulis cmd1 cmd2..)  -as INVSUBS, but you specify the commands.  Eg
    (INVSULDO suli (MAKE tsr..))



7  ^<<WTERMS - WRITE NBR OF TERMS^>>

(WTERMS tsr) -Write the number of TERMS in each tensor component.
    Takes tensor-specifications as args (in same way as MAKE and other TENVALs)
        -and W-rites the number of TERMS that each tensor component contains,
        -or if just ONE term, indicates the type of term.
    Example: (WTERMS RIC FROM 0 2 TO 2 3) -might cause the following:
       -row-by-row output:         	-showing that the specific component contains:

       ((RIC 0 2) PLUS . 97)   	- *** a SUM of 97 TERMS ***  This is the usual.
                           	Let us suppose the remaining components did NOT
                           	contain sums. Then instead of PLUS, some other
                           	symbol is used,telling that the single term is:
       ((RIC 0 3) TIMES . 9)   	-a product of 9 factors, or only
       ((RIC 1 2) EXPT . 2)        	-an EXPonenTial, sin, cos etc(with n args), or
       ((RIC 1 3) 64)      	-simply an "atom": then entire value is shown
       ((RIC 2 3) 9 . 17)          	-also when value was a RATIONAL number(9/17)

    (ON NOZERO)         -excludes zero-components from being listed.

    Used to eg:
        -Obtain an instant overview of the computational COMPLEXITY.
        -Compare results,to find OPTIMAL combination of multiple SUBSTITUTIONS.
        -Forecast computability of the next object. The hard way to know,is to
                        waste cpu-days, just to finally find memory exhausted.
                        A "nogo" lets you know that further action is worthwile
                        eg economize by "kernalizing". See SETSUBFOR in SHPSUB.

(DOFOR x (v1 v2..) do1 do2..) Perform do1,do2..  for x = v1,v2..  Carries out
    commands do1,do2,...  with x everywhere replaced with v1.  Then again, but
    with x replaced with v2 etc.  The commands do1,do2,..  may be any commands,

                                                                         Page 8


    eg FEXPRs, since the x is substituted for in all the do-commands (binding
    of x would not work in fexprs).

    Example:  To compute, save and lose RIC row by row, type:
    (DOFOR x (0 TO 3) (MAKE RIC FROM x x TO x 3) (SAVETN x) (LOSE))
    -whereby files 0,1,2,3.SHO each will contain a row of the ricci-tensor.
    The LOSE at the end rids primary memory from the components just computed,
    so they do not infer on the working space for the next computations.
    In heavy computations this is often a must.
    DOFOR is often put around an IOMAKE, which does several operations on an
    individual component (x):
    (DOFOR x (0 TO 3)           @% Ie for X = 0,1,2,3
      (IOMAKE (PREFIX) (VEK x)  @% Get file VEK0.SHO (VEK1..) 
           (LOAD "SUBSTA.SUB")
           (PREFIX A) (VEK x)   @% Lsimp and save result as AVEK0.SHO
           (SETQ ESUL @'(SUBS))  @% Reset sublist for next eval of the IOMAKE.
      ))
    Note:For do-commands expecting formula input, formulas must be supplied
    AFTER the DOFOR-command, and in enough amount, each formula ended with @$.



8  ^<<IOMAKE - IN/OUTPUT MAKE^>>

(IOMAKE t1 ^[cmd^] t2..) -MAKE that does In/Output to files, and by itself
    intelligently combines MAKE,LOAD,SAVETN,OUTF,WRITE etc.
    Mostly for doing large computations, with IOMAKE-commands in a commandfile.
    When the commandfile is first run, IOMAKE does "MAKE" ie tensors are
    computed, but are in parallell saved on disk.  Eventually, a large job is
    normally stopped due to CPU-time or memory overflow, since it is difficult
    to know on forehand exactly what substitutions etc that are optimal.
    Except for such "tuning" of the commandfile, you then let it run again,
    unchanged.  This time, the same command (IOMAKE t1..) will not recompute
    t1, but find the previously computed result on disk, load it, and after
    negligible time reach the previously memoryblowing tensor t2, maybe succeed
    in computing it, but stopping on t3.  Then new adjustments and reruns from
    last position, but all the time the same commandfile suffice, since IOMAKE
    adjusts and exploits previous history.

    Intervened between tensor arguments, any commands may be given, eg turning
    ON/OFF switches.

NOLOAD -switch ^[off^] which if on cause IOMAKE to ignore previous results on
    disk, so recomputing in core, and (unless NOSAVE on), store anew on disk.
    Turn on NOLOAD (or delete the previous file) if recomputation is desired.
Other switches, most normally off:
SLEEP	Cause IOMAKE do nothing for args being tsr/value symbol
NOSAVE	No (SAVETN tsr tsr) after computed
NOLOAD	Dont try load before make
WOUT    	Write to tsr.LAM after make
MTERMS	WTERMS on tsr if just M-AKEd (not if loaded)
FTERMS	WTERMS output into a File tsr.WTE (default)
MTRIG	TRIG on tsr if just M-AKEd (not if loaded)

                                                                         Page 9


(PREFIX sym) Cause files to have names starting on "sym", so eg RIC is saved as
    "symRIC.SHO".  Reset by (PREFIX).  Sets PREFIX!*.
Sample use:
(PREFIX GDL)            @% Possibly setup string for filenames to start on.
(IOMAKE  (ON SLEEP) GUU GSGUU   (OFF SLEEP WOUT) GAM            @% Compute GAM
         (ON WOUT) RIEGS)               @% Cause WriteOUT when computing RIEGS
         RIE (LOAD SUBS) (PREFIX C)     @% Set new prefix since new subs
         RIE )          @% This 2:nd RIE cause LSIMP, and SAVE in file CRIE.*
The two RIE-versions are saved as RIE and CRIE to distinguish between them.  If
prefix un-changed, then do nothing at repeated RIEs.
Enclose interval specification in parens, eg (IOMAKE (RIC FROM 1 1 TO 2 3))
        -here file will be:  RICF11T23.SHO
