%*** STENEW.MAN ***  New documentation on new or old features in STENSOR ****
*                                                                           *
*            Addendum to the Nov 1986 STENSOR manual (ed. 6)                *
*            ===============================================		    *
*                                                                           *
*     Documentation that will be added/merged when forming manual ed. 7     *
*                                                                           *
*	  Any command/switch/strategy/context etc described below	    *
*	  might already have a manual treatment: check the index!	    *
*                                                                           *
*	      In that case the text here is not selfcontained, but	    *
*	  just supplementary to the manual text, covering only some	    *
*	  new option/argument/application. Thus it is best read in	    *
*	  conjunction with the corresponding text in the manual.	    *
*                                                                           *
*          Valid only for versions from 2.26  on VAX and ORION              *
*                                                                           *
*                           Lars   Hornfeldt                                *
*                              May    1987                                  *
*                                                                           *
*****************************************************************************

		This file is constantly being updated.
		Thus check the machine version now and then with the command:
more $stsd/stenew.man		-on unix

			In "more" you may search for a string, eg "xyz" by:
/xyz<cr>		Eg to search for next underlined headline in this file:
/======<cr>		-ie underlining eqsigns (then press <cr>=return-key)

			To find next occurence of the SAME string, exclude it:
/<cr>			-this would search for the NEXT underlining.

h			-gives further help (as stated in $stsd/unix.hlp)

			The ** MANUAL ** can be perused by:
more $stsd/stensr.man		-and then type eg:
/PMMM<cr>			-if you want info on that object.



SHEEP INTRODUCTION
==================
STENSOR: works with tensor DEFINITIONS,  -  ONE   for each tensor,by: (PDEF t1)
SHEEP:   works with tensor COMPONENTS;   -SEVERAL for each tensor,by: (MAKE t1)

Most SHEEP commands expect tensors as arguments, exemplified by t1 t2.. below.

(RPL  t0..) 		RePLace components. For basic input,eg (RPL GDD).
(MAKE t1 t2..)		Compute components (of successive objects).
			Uses PDEF-formula on t1.. as "recipy" for computation.
(WRITE t1 t2..)		Writes components. Err if not computed.
(WMAKE t1 t2..) 	First compute, then write.
			If already made, then just WRITEs.

(SETSUB ESUL) mask $ repl $	Setup subst:  mask => repl
(ON ESUBS)			Activate this kind of substitutions.

(LSIMP t1 t2..)		Simplify (eLements). Common way to make use of a new
			subs, on something already computed. Also used:
(REMAKE t1 t2..) 	LOSE (the t1 t2.. only), then MAKE them again.


SPLIT
=====
INTRODUCTION

A tensors DEFinition is enormously more compact than its explicit components
in the general case.

In general, try to do calculations as "symbolic" as possible. That is,

PDEF/EDEF	-Working with DEFs, 	  "indicially",		-is better than
RPL/MAKE	-Working with components, "componentwise",

	-since more compact!  This is an extremely important consideration.

The PDEF/EDEF should be used, as soon as all coordinates are treated on an
equal footing. Then the symbolic indices representing them, is enormously
more compact than explicit numeric indices, since:

1) You get fever formulas (one/many eg Rab contra R00,R01,..R33)
2) These formulae have each contraction represented as a single term,
	with a letter CONTRACTION INDEX (whereas the componentwise formula
	has EACH contraction expanded, ie of type:  00 + 11 + 22 + 33.
	For k contractions in d dimensions that expands to d^k terms!)

SPLIT - A HYBRID
However there is a hybrid situation, that only SOME coordinates are on an
equal footing. Then THESE should be handled symbolically, while the
different TYPES of coordinate directions are handled "componentwise":
One does a SPLIT of the total space into subspaces, eg 1+3 (time + space), or
2+2, or 4+7 (Kaluza Klein) etc.

STENSOR can do ANY split, and treat each subspace with symbolic indices.
...more,see also ch 6.


When splitting, please distinguish between the following three command-types:
zDEF	Work on definition.	PDEFs in input files is what we SPLIT, creating
	splitted (multiple) definitions, that then are manipulated by:

zSPLIT  where Z=E,S etc, is like "calling E/SDEF on EACH multiple definition".
	May specify individual such by eg: (ESPLIT tsr 0 1) (subspacemix 0/1).
	zSPLIT has same syntax as MAKE. They are related, but incompatible:

MAKE	For sheep-components, ie a special case of TOTALLY splitted formulae.
	If a BULF didn't exist, but a DEF, then MAKE tries to create one,
	by calling TCOMP on the DEF. That BULF would corrupt the SPLIT-
	mechanism, so dont use MAKE when you mean eg ESPLIT!

zSPLIT	is also best used in consecutive, hierarcic sequence, from bottom:
	Eg for CORD you can NOT say eg (ESPLIT RSCL) and expect this to be
	equivalent to: (ESPLIT GDD GUU GDF GAM GAMU RIE RIC RSCL) etc. You
	should instead say this explicit sequence, or more conveniently:
	(ESPLIT ALL IN CORD). Thus specify each object by name to form the
	proper sequence, or better, with the PDEFs in proper order in a file,
	the names are, after loading, referred in the same order by the simple
	construct:		(ESPLIT ALL IN file)

	Bottom up is not automatic as by MAKE, since it is NOT ALWAYS DESIRED.
	After an initial consecutive SPLIT, it can sometimes be advantageous
	to do ESPLIT top down for some objects (as with EDEF).


Splitting switches:
REMDELK	[on]	Remove DELK-prop. Dont want/need lose previous tsrs in Stensor.
		When MAKE, DELK-property cause "Lose pretsr" to save space.
		This property is often set up in library DEFs, initially
		intended for TCOMP/MAKE. REMDELK cause SPLIT (when applied to a
		DEF) to remove that DELK, since lose normally undesirable.

WSPLINI	[on]	Write,when doing SPLIT,the INItial formula

(DIM id)	If id is an identifier, it is also declared a constant under
		differentiation, ie DIM does: (FUNS (id)) and (SETDIFF id) 0$ .


EDEF EXTENSIONS
===============

EDEFRPTMAX [9] maximum passes by EEDEF on each object. This maximum is a
	safetycatch. If it is reached at any instance, EEDEF writes a warning
	(code comments available) and proceeds to next object.

(WEEDEF t1 t2..)  As EEDEF, but Writes. Also turns off EDEFASK locally. This
		might thus be the most convenient for some known standard
		evaluation, without turning off EDEFASK for later experiment.

(SSDEF t1 t2..) Repeat SDEF until t1-definition cease to decrease,then on t2,..
		EDEFASK is locally turned off. This is for full compression of
		a formula when complexity or substitutions might require more
		than one SDEF-pass. Repeats until two successive SDEFs gave
		the same number of terms.

(RDEF t1 t2..)	Rigorous simp for Repeated tsrs in the terms.
		This is the most Rigorous simplification, which might possibly
		be needed when the same tensor occurs as a repeated factor in
		some terms, and has index symmetries.
		(Calls SSDEF twice; first with RECRSI2 false,then locally true)


STERUN	- UNIX command to do large STENSOR computations in the background.
==========================================================================
SHPRUN and CLARUN are analogous to STERUN,so see description below, except that
for these the run-file should typically do: (LOAD metric) and (WMAKE RIC) etc.

"sterun run-file"	-simply starts a fresh STENSOR (loads any stensor.ini)
			then loads the file you say, the "run-file",
			and then exits. Logging whole session.

    "run-file"	For the above to be interesting, the run-file should engage not
		only input,but also computational commands.It's often advicable
		however, to separate these; -keep the input in an "input file",
		and let the "run-file" load the input,then do the computations.

	Example:		If your input (PDEFs etc) is in  BETA.DEF,
				then you could have a separate file:  BETA.RUN
				to do the computations, and run that with:

	sterun beta.run		% -Where the file BETA.RUN could eg look like:

	% BETA.RUN  This file loads BETA.DEF, computes, and writes results:
	(LOADEF BETA)		% Loads the BETA.DEF (note: *DEF*)
	(EEDEF Tsr1 Tsr2..)	% Then do whatever computational...
	...			% ...commands needed.
	...			%  Finally, Force OUT to a File,...
	(OUTF "BETA.WEF" (WDEF Tsr1 Tsr2..))	% ...-the results (see 2.7).
	% BETA.RUN end

			In last line, the (OUTF "BETA.WEF"..) "Forces OUTput"
			into the file "BETA.WEF". That name is only a
			suggestion, but a good one; The BETA tells that it
			comes from BETA.DEF, and WEF is a convention, to
			indicate that the file was made with WdEF, and to avoid
			collision with any existing beta.DEF -Since:

					**   WARNING:   **
				** OUTF OVERWRITES ANY EXISTING FILE!! **


			-and deletes its previous contents!! Thus dont write to
			input files like BETA.DEF or .RUN, or you would clobber
			them!  Instead make sure use BETA.WEF or some such
			unused name (or if .WEF was OUTFed to before, it is
			often desired to overwrite with the new version of the
			result)
		PANIC:: Have you overwritten, maybe your editor has created
			some backup file; #beta.def, beta.def~, beta.CKP etc.

		Separating input and commands is advicable, since often
		different computations are desired, that need the same input.
		You could thus later create a BETA.RUN2 etc that loads the
		same .DEF-input file, but then does other commands.
		Actually, PDEF input is multipurpose to a unusually high degree
		since DEFinitions have 3 totally different classes of usages:
			1) Call EDEF, to give new DEFinitions,
			2) Call TCOMP+MAKE to compute individual COMPONENTS,
			3) Call SPLIT and ESPLIT, for any hybrid of 1 and 2,
			   eg total split + DISK-BUCKETING, for 2) of any size!
		Thus eg STS/CORD.DEF and (G)FRAME.DEF is being used all 3 ways.



(TI cmd)	Much nicer printout, and many more switches, see TI.STS

(LOADEF file)	Loads file.DEF, ie looks for extension DEF. The purpose is to
		save the user from typing the extension (and thus the quotes).
		Also, loading is made fast/silent if EXPERT is on (see below).
		Stslib-files LOADEF's each other, so become silent for experts.
		Technical: DEF is not permanently on MEXTLIS* since sometimes
		you with LOAD want another type of file. LOAD/LOADEF provide
		explicit choice, yet convenience for the abundant DEF-files.

EXPERT switch [off] decrease verbosity, affecting eg:
	1) LOADEF to locally turn off WPDEF and on NOMSG (thus faster loading),
	2) various help/guide string-prompters shortened or removed,
	   especially in EDEFASK, TI/TIM and BR interaction and prompters.
	   For TI and BR, help/prompt-strings are set (non)verbose when loaded,
		according to if EXPERT was off(on) at that instance,
		ie when the selfloading TI and BR are called the FIRST time.


(REMTEN t1 t2 t3..) -Remove these as tensors in Sheep sense, ie strip from them
any array or associated properties (BULF TENARY TTYPE DIML YCOPY), plus those
in the list TENPROPERTIES.
This makes t1 t2.. unknown as far as component calculations are conserned.
If your STENSOR was built on some application package (eg CLASSI), it will
already at startup contain tensors, that might interfer (DEP-PREQ-wise)
with a new family of tensors you want to PDEF+TCOMP. Then first remove
those undesired, maybe by (REMTEN ALL).
While above removes SHEEP-properties, next two removes STENSOR properties:

(REMSYM t1 t2..) Remove symmetries of t1 t2..

(REMDEF t1 t2..) Remove DEFinitions of t1,t2.. Removes only the DEF-property.
There might be a backup ODEF retrieved by XDEF. There is also ALWAYS a backup
of the very FIRST input, retrieved by XXDEF. Neither of these have any meaning
except to (X)XDEF. Having done REMTEN,REMSYM,REMDEF thus makes a tensor
completely forgotten to both Sheep and Stensor, until you change your mind
and do XXDEF and TCOMP on it again.

ECONOMY [off] skip XXDEF-backup, ie PDEF, COPY- and TWINDEF do not create any
	ORGDEF that XXDEF can reinstall. Might squeeze through a large run.



(COPYDEF t1 t2 [m n p..])  Give T2 same DEF as T1, or if trailing numeric
	arguments are given, then only those T1-terms are used.
	Eg (COPYDEF t1 some 1 2 3 9)	-picks from t1 only first 3, and 9:th,
	and puts that as DEF on object "some".
 	   If selecting numbers are specified, no ODEF will be setup on t2
	(since it would probably be inconsistent with the selected DEF).

	   Returns the result of (DSTAT t2). As a side effect, being
	the "LASTENSOR" acted on, t2 becomes the default for further action,
	so used if next typing eg (EDEF).

(TWINDEF ...)	As COPYDEF, but codeshared.


DANGER WITH TENALIAS!*
Use internal names, or be aware of what TENALIAS!* you have (just type the
symbol to find out). Some Stensor images are built on Sheep-versions containing
specific application packages, and inherits TENALIAS!* -values from there.
If so, a warning message about "TENALIAS!* non-nil" is given at startup.
It is very easy to see what objects there are, by eg
(DSTAT ALL PRE tsr)	

ALIAS-inhibition (by using 'tsr) doesn't always succeed, translation may
	still occur, since many commands "translate several times".
	Additional '' then might work, one being stripped per evaluation.

BUCKETNAM list for composing bucket names. Initial value is:
		(BUCKETCHAR LASTENSOR BUCKETNR)
	meaning names will be BTSR1 BTSR2 ... but after eg:
	(SETQ BUCKETNAM '(LASTENSOR '!- BUCKETCHAR 'kt!: BUCKETNR))
	names will be:  TSR-Bkt:1 TSR-Bkt:2 ...

BUCKETOUTLIM global [-1] limit size for bucket to be written out.
	Thus default setting cause also 0-term buckets be put on disk.
	After eg (SETQ BUCKETOUTLIM 9) then 0-9 term buckets will be kept
	in core rather than written to file, despite BUCKETOUT being on.
	For decreasing the number of very small files.
	Note: To save the work (overnight etc) you must in this case eventually
		use SAVDEF to get these specific buckets written to disk,
		and next day after BUCKETINI also LOAD.

Switch FORGIVE is replaced by FORCEIT, and now affects many more situations:

FORCEIT switch [off] overrides safetycatches in various situations.
	Here we only list briefly some areas; see further each topic:
	"Free ix"  error:  <A A<+<B B<  (to give matrix)
	"bad rank" error:  Mask/substitute of differing ranks(eg MULT-object).
	PACKET-symbol: (if any) is put on *ALL* objects read.
	BUCKETOUT: force *OVERWRITE* of previous file,
			-not mergeing as is default under batch.
	Generally, try to turn this switch back off after use;
		-A gun is useful when hunting, but is better stored unloaded.

TCOMP
=====
SUM IN DENOMINATOR, EG AT MATRIX INVERSION
==========================================

When inverting a matrix (say GDD, having eg nice polynomial components), its
determinant (say GDET) will occur in the denominator (in the GUU (inverse)
components).  SHEEP lacks polynomial division, so it would not do anything
about this expression GDET in the denominator if it was a polynomial. The sum
would just explicitely occur in the denominator of each toplevel term. This
would take up a lot of space in both machine memory and on screen.


As a remedy to this, the GDET expression in the denominator is automatically
being kept as a symbol if it is a sum, rather than being replaced by its sum
value.

However, if some later object (say a vector RO) has some terms where 1/GDET
appear and some not, then some cancellation between these two categories of
terms might occur if you put them all on the same, common, denominator GDET.
That is done by introducing a new object that is the old (say RO) multiplied
by the denominator (say GDET).  So:

(PDEF DETRO)	<RO A>GDET $		-Defines DETRO by multiplying.
		Multiplying with "GDET" means the SYMBOL GDET only, while
		"<GDET>" would have meant the *VALUE* of GDET to be inserted.
		In this case, we wish to first multiply with the symbol.

(TCOMP DETRO)	Sets up array for components, and a technical program to
		compute them (according to the symbolic PDEF-recipy above).

(WMAKE DETRO)	Uses this,to make the components (and Write).
		This now has the GDET symbol in the NUMERATOR of SOME terms.
		Not being in the denominator any longer, we would now like
		its value be inserted. To do this afterwards in an existing
		expression, we use substitution:
(SETSUB ESUL)	Set "Elementary substitution (List)" to affect tensor-elements:
GDET $		-from this symbol (as any other formula this is ended with $)
:GDET $		-into the VALUE OF (:) that symbol (GDET has a computed value).

(ON ESUBS)	Switch to at all make ESUL-substitutions active.

(WLSIMP DETRO)	(Write and) simplify each eLement of DETRO - using the
		substitution, so remaining GDET in NUMERATOR of some terms
		will now be replaced, causing combination with other kind
		of terms.

WARNING:
TCOMPOUT may overwrite previous .blf-file (then saying "rewriting...").
	This also applies to SAVDEF etc, and is due to OUTF doing so.

(TCOMPOUTIN file t1 t2...) loads file if on disk, else creates it with
	TCOMPOUT. In both events the result is that the memory contains
	bulf-programs for tensors t1,t2... as if TCOMPed.
	Useful in library files, which when first time loaded will call TCOMP
	but then also create a file.BLF. Next time, this file will simply be
	loaded, which may save some time, output and core (loading of TCOMP 
	might not have been done, and TCOMP will then stay out).
	To force update of the .blf-file, delete it, or turn on:
FORCEIT switch [off] that here cause TCOMPOUTIN to write anew no matter what.
	Ie makes TCOMPOUTIN identical to TCOMPOUT.

(LTCOMP [T/NIL]) set up TCOMP for coming LISP-compilation of BLF/or not.
	(LTCOMP) show mode,arg T for L-compilation, arg NIL for interpretation.
	Simply sets all switches/loads files, as of Chapter 7.10 and 7.11 in
	manual. Initial state is as of (LTCOMP NIL).
	(LTCOMP T) plus (TCOMPOUT fil..)
	and then:	SLC fil.blf	and (FLOAD fil), or
	on culisp:	(SETQ !*COMP T) and (LOAD "fil.BLF")
	will then let (MAKE ..) run compiled code. Time saved ranges from .1 s
	for a single contraction, and upwards. The factorization (see 7.11),
	can cause large savings, but otherwise savings are moderate.



ADVICE ON STRATEGY:
==================

INPUT FILE ORGANIZATION
Input formulae are best stored in files. Containing PDEF-commands, use ext DEF.

In general, it is also advicable to avoid duplication of parts of input files:
     1) Later changes (oh yes, you'll change!) has to be repeated on each copy.
     2) Sooner or later you will forget to update one copy.
     3) Any reader will need to RE-READ each copy. You too, after x days.
	(Not knowing if any differences found are intentional or example of 2)
     4) In the long run, it takes space on disk and printout.

Instead, put common portions in separate files, example:

			% If two files A and B.DEF have this portion in common:
...
(DIFFOPERATOR DD)
(COMMUTEWITH (DD) DEL PHI)
(DECLT (PHI 2) (RIE (S A12 A34)) (RIC S12))
...
			% Then put it into another file eg INI.DEF, and replace
			% whole portion in A and B.DEF with the single line:
(LOADEF INI)
			% Now, you might notice that DEL is ALWAYSCOMMUTEing,
(COMMUTEWITH (DD) PHI)	% so you can delete DEL from this command in INI.DEF
(DECLT (PHI 2) (RIE R (S A12 A34)) (RIC R S12))	% -and give printoutnames R
			% for shorter printout. You do these changes only ONCE
			% in the file INI.DEF, but they will be used in TWO or
			% whatever files A.DEF, B.DEF,.. that does (LOADEF INI)
Include as much as possible in the INI.DEF.

Maybe there are other portions that are common with other files,
which you could move to INI2.DEF,.. etc or whatever more descriptive
name you choose. If these are on:
-a subdirectory "deeper", you load it by (LOADEF "deeper/INI2")
-an other subdirectory, say "beta" on the same level as the current,
 you must first go up "..", before down: (LOADEF "../beta/INI2")
(UNIX only)
LOADING is attempted from various directories; First the file you named is
	searched for in the CURRENT WORKING DIRECTORY, ie from where you were
	when you started STENSOR. If the file is not found there, then it is
	searched for on several other areas in turn, one of the earlier is the
	stslib area, the "STENSOR library", also pointed at with the logical
	symbol sts. Then stssrc and library and source of sheep etc. To see the
	full "searchpath" list, type MSEARCHLIS!* <return>.

	CURRENT DIRECTORY: If you are "alex" and want to mostly load files
	situated on your subdirectory "stswork", it is easiest if you set your
	"current (working) directory" or "default directory" to that. Just
	after login, you are situated at (your current directory is) "alex" and
	to move down to stswork you do: cd stswork (unix) or SET DEF STSWORK
	(VMS).  Then you start STENSOR, and can load any file on that directory
	calling them simply by name, eg: (LOAD "A.DEF") or (LOADEF A). However,
	STENSORs opinion of what is your current directory, is now fixed.
	
	OTHER DIRECTORY: Having loaded some files from "/users/alex/stswork",
	you might eventually need some file from another private directory.
	Then include directory path information, either "full" (absolute) or
	"relative" (under unix). Say we want d.sef from subdirectory "deep"
	down from current stswork:

	FULL PATH -specification: (LOAD "/users/alex/stswork/deep/d.sef")



	RELATIVE PATH of same file would simply be: (LOAD   "deep/d.sef")
		Since we are situated on stswork already, the latter needed
		only specify the extra subdirectory "deep" down from stswork.

	RELATIVE UP from current directory is indicated by two dots:  ".."
		In our case, relative up (from stswork) becomes "/users/alex".
		To load some ini.def from there, just do:  (LOADEF "../ini").
		From other subdirectories being on the same level as stswork,
		ie "sisterdirectories", the command would be identical;
		".." from any "alex-daughter" gives "/users/alex".

	    INI.DEF ON "RELATIVE UP" is the natural place for commands in
		common to several subdirectories.  Do not duplicate a command
		sequence xyz in several subdirectories.  Replace each duplicate
		with a single line (LOADEF "../INI), accessing the common xyz
		from a single INI.DEF on the higher directory.

	"SISTER DIRECTORY":  "../"	Up, then down:
		If we want a directory stswrk2 on the same level, a "sister"
		to stswork, then we must GO UP first, THEN down into stswrk2!
		In our case,  ".."   brings us to "/users/alex". 
		Then go down,	 "/"	(directory separating symbol),
		into directory     "stswrk2"	-or put together as
		relative path:  "../stswrk2"	-specification means:
		       "/users/alex/stswrk2"	-if given from current direc-
		tory:  "/users/alex/stswork"	(or some other "sisterdir").
		The load must of course include filename, and becomes eg:
		         (LOAD  "../stswrk2/ric.sef").

SUMMARY: Under unix, the following are equivalent path specifications, full and
	    relative, to load the same file   "/users/alex/stswork/ric.sef":
	    Full filespecification:	(LOAD "/users/alex/stswork/ric.sef")
	    Relative, from alex: 	(LOAD             "stswork/ric.sef")
	    Relative, from stswork: 	(LOAD                     "ric.sef")
	    Relative, from sister stsw2:       (LOAD   "../stswork/ric.sef")
		(".."  Two dots means "go up one directory from where you are")
	If your current working directory is: "/users/alex/stswrk2" ie a sister
	directory to stswork, you must first "go up one directory". This is
	indicated with two dots: ".." and brings you up to "alex" exactly as
	the unix command "cd .." means "go up one level". Then proceed as
	"Relative, from alex" above, except separating .. with a slash:
	"../stswork/ric.sef")


CASING of filenames:
===================
Unix has as standard filenames in lowercase, while VMS has them in upper case.

Now, we want STENSOR to behave and work in the SAME way in both unix and VMS.
Therefore the VMS convention of uppercase filenames is used. If then the OS
happened to be unix, that name is internally lowercased before read/write.

In that way, library files that are loading other files do so using uppercase
(and so should user files for portability!), and thus have identical contents
on both unix and VMS.  On unix, conversion to lowercase is then internally done
before loading (writing), to match that their actual name on disk is (should
become) in lower case.

This works fine as long as the USER ADHERES TO the LOWER CASE CONVENTION of
unix (or upper on VMS). For instance, if you use mixed casing on files or
directories, you can not refer to them in load commands!  This also applies to
directories: Suppose you are at "me" in unix, and want to load
/users/me/Beta/file.def, then (LOADEF "Beta/file") would translate to
beta/file, which is not found!!  Thus, better call it beta.
		


SUBSTITUTIONS
=============

SUBSTITUTION versus EVALUATION

These are the two basic operations:
EVALUATION replaces a SINGLE OBJECT (with any indices), everywhere,
			with a formula (its definition).
SUBSTITUTION replaces a STRUCTURE (eg product of objects, or contractions)
			with a formula (the substitute replacement).
	These differ in what they are searching for, replacing.
	Substitutions are replacing a structure, evaluation a single object.

	In this regard SUBSTITUTIONS are MORE GENERAL, since the structure
	substituted for, as a special case could be the very single object that
	evaluation is confined to.

	On the other hand, EVALUATION is more FLEXIBLE, allowing easy CHANGE of
	what is being plugged in,by calling prior EDEFing (SDEF/XDEF/XXDEF etc)
	on the object, and interactive selection (EDEFASK).
	Here the object name is used as a unique HANDLE on the replacement,
	which a structure can not serve as in the same way. Thus, the following

	RULE:	TO REPLACE A SINGLE OBJECT, USE EVALUATION
		(Ie (PDEF obj) formula $    and EDEF)

	EXEMPTION: (Each rule should have one)
	Evaluation is always affecting the internal structure.
	If replacement only is desired at OUTPUT, then use the special
	argument WSUL (Write substitution list), example:

		(SETSUB WSUL)  <PHI A I>$   <D A><Q I> $
	WSULs are done just prior to write out, without reordering, so
	here the WSUL also has the advantage of leaving the D and Q together,
	regardless of other factors (while otherwise, a surrounding
	<LPAREN> <RPAREN> -pair would have been required to ensure that).

	To be specific, suppose we are working on ANS (ie the DEF of ANS) and
	this contains the object TSR.
	Then the basic method to replace TSR with say T1 + T2 is:
		(PDEF TSR)  T1 + T2 $	    (We are suppressing indices here)
	and:	(EDEF ANS)	-will now plug in the TSR-definition in ANS
	The main thing EDEF does is EVALUATION of ANS, ie everywhere in ANS
	replacing occurences of TSR with its definition.


(SETNSUB [n] [sulist]) Repeat SETSUB n times, or until double dollar input.
	Eg (SETNSUB ESUL) A$ A2$ B$ B2$$    -sets two subspairs. $$ ends last.
	Or:(SETNSUB 2..) for compatibility with Sheep.
	The $$-ending is more convenient, allowing flexible addition of any
	number of extra pairs. Another example below.

(NEWISUL [n] sul [pred]) -make NEW Indicial SUBstitution List. Read n pairs.
	-To make active, you MUST also type eg (SETSUP TSUP tsul sul...)

	"sul" must be specified, being the name of the new substitution list.
	Optional "n" indicate how many subs-pairs that will follow (else 1).
	Optional "pred" is taken as predicate as usual.
	Given both pred and n, the same pred will apply to all substitutions.

	Technical: Initiates a substitution list (sets sul to (SUBS)).
		   Declares indicial subspair reading (puts sul on list ISUL).
		   At least DEL gets its SP-program also under "sul".
		   Give other SPs a second chance with a tsul at end of TSUP.


SETSUB AND INDEX SYMMETRIES
===========================
The freedom of index symmetries are NOT as yet taken into account at matching.
	Example:
	(SETSUB TSUL)		% Suppose RIE2 has its first two
	  <RIE2 I K J K>$	% indices up, and we form its trace,-then
	  <RICM I J>$		% that should be the Ricci(mixed)! (See CORD)
				% This substitution will match:
	<RIE2 A B C B>		% -etc, where the dummy B occur on the
				% 2:nd and 4:th positons as in the template,
				% but will NOT directly match eg:
	<RIE2 I K K J>		% -where the dummy occur on OTHER positions,
	(DECLT (RIE2 A12 A34))	% -even if (anti-)symmetry had been declared
				% before.

	SDEF in this context has two parts: substitute and order:
	Substitutions (TSUL) are first tried:
		-this fails on <RIE2 I K K J>.
	Then SDEF orders indices:
		Dummies has low priority when ordering, and trace-dummies
		even lower, so in this step in SDEF, the <RIE2 I K K J>
		example will be rearranged to:		-<RIE2 I K J K>.
	Now SDEF is normally done; with a failure - but what if called again?

	If SDEF is allowed to try the substitution again, it will now succeed!
	-Since our test example has been rearranged to	-<RIE2 I K J K>
	where the trace-dummy positions are as used in our template, it will
	now match, giving:  - <RICM I J>.

	To ensure IMMEDIATE matching, we could set FOUR substitutions:
	(SETNSUB)  <RIE2 I K J K>$   <RICM I J>$	% Our canonical,
		   <RIE2 I K K J>$  -<RICM I J>$	% our testexample,
		   <RIE2 K I J K>$  -<RICM I J>$	% and same,but swapping
		   <RIE2 K I K J>$   <RICM I J>$$	% 1:st indices (A12).
			% Note the ^^ MINUS on two of them, from ANTIsymmetry!
	Alternatively, one could set only the FIRST, and use SSDEF/repeat SDEF.

	While TRACE-dummies are guaranteed to be ordered last,ANY dummy is not:
	(SETSUB) <RIE2 I J K L><V L>$  ..$	% Dummy L here, will be ordered
		 <RIE2 A B C D><V C><W D>	% in 3:rd position (C), if 4:th
		%  position (D) is occupied by a dummy going to an object (W)
		% ordered more to the right than V (adjustable, see ORDER).
	With other contractions present, you may thus need to set substitutions
	for several versions of your non-trace contraction.


WILDCARDS are now: ?ANY, ?T, ?DIFFOPERATOR, ?PAREN, ?END.
=========
-where:
	?DIFFOPERATOR matches anything that has been declared with
		(DIFFOPERATOR..) or (S/ABIDIFFOPERATOR..),
	?PAREN matches LPAREN and RPAREN,
	?ANY matches any "normal" object, ie all not matched by the above two.
		If you want a substitution to refer to absolutely anything,
		you can complement an ?ANY substitution with the same with
		?ANY replaced with ?DIFFOPERATOR (and ?PAREN if desired).
		Or do:   (WILDCARD !?AANY T)	-and use that (Absolutely Any).

(DIFFOPERATOR ..) sets up a TSUL-property that spread over products.
When coming to successively set substitutions, it should thus only have one
operand, except for queued up diffops, (Op1 Op2 A) or (Op1 A) (Op1 B).
If you have set substitutions for all queued ops possibilities, you may then
set up substitutions for results of acting on individual objects, by omitting
the ?END-check.


The most secure is however to include the ?END-test, but remember that
?END means literally the end of a term. You might therefore like to complement
a substitution like:	<Diffop><..><?END>$	...$
with the case:		<Diffop><..><RPAREN>$	...<RPAREN>$

(PRSUBON t1 t2..)	PRint SUBs On tsrs. As PRSUB, but shows only those subs
		that have been put on t1,t2.. Only shows stensor substitutions;
		these are each put on individual objects (usually first factor
		in mask), so PRSUBON shows what subs t1.. has been given
		(usually the subs that have mask starting with t1..).

(GRSUBON t1 t2..)	As PRSUBON but GRinds the corresponding SP-programs,
			that actually carry out the substitutions PRSUBON show.
			Cfr REMSP.	%?

<MULT X>	Special object that cause its index/arg be multiplied on to the
		scalar coefficient of the term, and itself vanish (=1).
		Normally an index say K is renamed etc without affecting
		a coefficient K in the scalar part of the representation.
		Therefore, a particular substitution like <TSR K> ==> K <TN K>
		is wild on index K, but literal on coefficient K,
		so as on:	<TSR L>    the substitution gives:    K <TN L>
		In particular I has meaning of index inside, and imaginary
		unit outside tensors.
		The above in/out-side distinction is normally what is desired.

		In the special case, where the index really is desired to
		multiply on to the scalar part, indicate that with <MULT K>:
		(SETSUB TSUL)	<TSR K>$	<MULT @K><TN K>$
		(Where @ at one of the K-occurences avoids it being a dummy.
		If mask/substitute has differing rank, (ON FORCEIT) is useful.)

:	 Index prefix that calls the lisp reader, for operations on index.
	 Useful in substitutions. Example (Geroch, Held and Penrose formalism):
	    (ON FORCEIT)		% Override "bad rank" errors.
	    (DIFFOPERATOR THORN CODF)	% The "thorn" operator should
	    (SETSUB TSUL)		% have a substitution property
	     <THORN><ETA P Q>$		% that steps spin/boson weights:
	     (<CODF> -<MULT P><EP> -<MULT Q><EPB>) <ETA :(ADD1 P) :(ADD1 Q)> $
		-where THORN on ETA gives ETA-terms with increased numeric
		arguments. For ADD1 you may use also eg SUB1, :(PLUS P Q) or
		SHPLUS or SHTIMES if non-numeric arguments may be encountered.
		Note: Since lisp-reader is used, the : shields from all index-
		interpretation, ie not only as @ shielding from the index
		counter. Thus no indexprefixes may be used after : (but before
		is allowed).
		Thus the rank of above substitute is judged from P and Q in
		the MULT objects.


PFAFFI.DEF   Pfaffians. As GDELTA but each antisymmetrization turn to dito sym.
SDELTA.DEF	As PFAFFI but extending symms into total symmetrizations, so
		contains totally symmetrized products of deltas.
GAUBON.DEF	Gauss-Bonnet Invariants. Shows usage of GDELn and technique
		for LARGE computations.
		Outside STENSOR,only invariants INV1-3 has been done (by hand).
		This file automatically computes (on ORION) also INV4, INV5,
		(previously done by STENSOR on Lispmachine, see GR9, 1980)
		and now also invariant INV6 is computed (90 hours)!

<>EVAL TO TCOMP: par 7.5:
....spec subst from CHI to value :CHI, ie
(SETSUB ESUL) CHI $ formula $
		However, it is better to have the CHI-symbol as a "handle"
		to the formula, for eg setting up differentiation properties:


(RPL CHI)  Formula $		This first gives the CHI symbol a value.

(SETSUB ESUL) CHI $ :CHI $	-which then is referenced (:) in the
				substitution.






		HIERARCHY OF COMMUTATIVITY RESTRICTION COMMANDS

		---------------------------------------------------------------
ANTI	     /	DIFFOPERATOR,S/ABIDIFF.. As NEVER.. plus spreads over products
-COMMUTE    /	---------------------------------------------------------------
combines    |	NEVERCOMMUTE	unilateraly refuses to swap with anything else
with all    |	---------------------------------------------------------------
these,to   /	NEVERCOMMUTEBUT		initial excemptions, else as above.
give a	  <	COMMUTEWITH		additional  "
signchange \	---------------------------------------------------------------
*IF*	    |	NONCOMMUTE    (bi)  Mutual noncommutativity within a set only.
swapped     |	---------------------------------------------------------------
(bi-	    \	ALWAYSCOMMUTE (uni) Used on objects such as delta and epsilons.
 -lateral)   \			Overrides "NEVERCOMMUTE"-declared
-------------------------------------------------------------------------------
ELEMENTARY objects, with no STENSOR-properties, are already at input stored
in a different part of the term from those with, and given to Sheep to handle.
-------------------------------------------------------------------------------


(PUSHV atm1 val1 a2 v2..) is equivalent to SETQ, except for stacking old
	value(s) on a list under property PUSHV, which can be restored by POPV.
	The stack can have any length, ie PUSHV/POPV can be repeated or nested.
	Number of args must be even,   eg:	(PUSHV PERMULT NIL WSUBS NIL)
	Use: Eg a library file may set globals as above, then pop back at end
	of file with:	(POPV PERMULT WSUBS).

(BR [n] fn1 [m] fn2...)  Put BReak/trace on fn1,fn2..
	For debugging of lispcode. Sets up various combinations
	of break and trace depending on the chosen breaklevel (default 8)
	which can be changed (stickingly) by giving an optional integer
	argument (n,m above).
	When you are in any kind of break, you can type:
		?	-for help (situation dependent).
		Integer	-to signal to proceed from the break, and the integer
			  is also taken as new breaklevel for this function.
		ADD	-to add, as tracearg to this fn, the last expr typed.
		REM	-dito remove.
		Anything else	-is just evaluated,result then printed/grinded.

	BR is highly flexible, and the above is merely a short introduction.
	For the full syntax of BR and a multitude of related functions,
	switches and symbols, and for the meaning of the different breaklevels,
	see file:	SEBREA.HLP



		PART SPECIFIC TO CAMBRIDGE LISP
		===============================

control-C	Gives you the prompt "LISP Break:"  -to which "?" show the
		options, and T(-hrow) should in theory return you to top level.
		However,often this kills the lisp, saying "stack corrupted",
		so use control-C only to stop a running/busy lisp.
		If a lisp program is prompting for input, instead use:


(RESET)		Brings you back to toplevel. Especially looked for in formulas.
		Typing (RESET) in formula, is the
			*ONLY SAFE WAY TO QUIT FROM A FORMULA INPUT*
			-unless you complete it with a "$".
		(TENCAL) and (WTRIGLOOP), that loops for ever more formulae,are
		on VAX/Franz exited with control-G. In Cambridge Lisp (RESET).

"Segmentation error"	-When starting up, means other processes already take
			to much memory, to allow your lisp-process to start!
			-Can spuriously also occur after other errors;ignore.

GARBAGE COLLECTION:
Technical: Functions to affect GC/RECLAIM (large computations/small systems):
	Cambridge lisp under unix (all numbers in bytes):	

	(STORE!-USED)		Tell used/total memory, eg (889432 . 1048576)

	(EXPAND!-STORE nbr)   Total-store-expansion to be done at each RECLAIM.

	(VERBOS n)	n=1(0) for (no) messages, >1 for FASL activity info.


	(GCTRAP GC-Nbr)		If compiled, GCTRAP will be called after each
				GC, with arg being Nbr for that GC.
