


                               M  A  N  U  A  L

                                      for


           XXXX   XXXXXXXX  XXXXXX  XX     XX    XXXX     XXX    XXXXXX
          XX   X     XX     XX      XX     XX   XX   X   XX XX   XX   XX
         XX          XX     XX      XXX    XX  XX       XX   XX  XX   XX
          XX         XX     XX      XXXX   XX   XX      XX   XX  XX  XX
           XXX       XX     XXXX    XX XX  XX    XXX    XX   XX  XXXXX
             XX      XX     XX      XX  XX XX      XX   XX   XX  XX  XX
              XX     XX     XX      XX   XXXX       XX  XX   XX  XX   XX
         X   XX      XX     XX      XX    XXX  X   XX    XX XX   XX   XX
          XXXX       XX     XXXXXX  XX     XX   XXXX      XXX    XX   XX

                  -a System for  Indicial Tensor Calculus and

                   Automatic Generation of Tensor Algorithms


                            Author: Lars  Hornfeldt

                       Institute of Theoretical Physics
                            University of Stockholm
                                  Vanadisv. 9
                              S-113 46  Stockholm
                                    Sweden





                             Edition 6,  nov 1986


                               For Version 2.26
                                                                         Page 2


.E
                                   CONTENTS

        1       ~^<<INTRODUCTION: A SAMPLE SESSION~^>> . . . . . . . 5
        2       ~^<<NOTATIONAL CONVENTIONS:~^>>  . . . . . . . . . . 8


CHAPTER 1       TENSOR FORMULA IN/OUT-PUT

        1.1     ~^<<USE OF THIS CHAPTER~^>>  . . . . . . . . . . . 1-1
        1.2     ~^<<PDEF - PUT DEFINITION~^>>  . . . . . . . . . . 1-2
        1.2.1     SYNTAX OF THE FORMULA INPUT  . . . . . . . . . . 1-2
        1.2.2     INDEX-PREFIXES . . . . . . . . . . . . . . . . . 1-3
        1.2.3     SWITCHES TO PDEF . . . . . . . . . . . . . . . . 1-5
        1.3     ~^<<DECLT - DECLARE TENSOR PROPERTIES~^>>  . . . . 1-5
        1.4     ~^<<SAMPLE FILE: CORD.DEF~^>>  . . . . . . . . . . 1-7
        1.5     ~^<<INDEX SYMMETRIES~^>> . . . . . . . . . . . . . 1-8
        1.6     ~^<<WDEF - WRITE DEFINITION~^>>  . . . . . . . . . 1-9
        1.7     ~^<<PERMUTATION NOTATION~^>> . . . . . . . . . .  1-10


CHAPTER 2       MANIPULATION OF INDICIAL FORMULAS

        2.1     ~^<<REPRESENTATION OF AN INDICIAL FORMULA~^>>  . . 2-1
        2.2     ~^<<EDEF - EVALUATE DEFINITION~^>> . . . . . . . . 2-2
        2.3     ~^<<MORE ON EDEF PROCESSING STEPS~^>>  . . . . . . 2-2
        2.4     ~^<<REPEATED/RESTRICTED EDEF~^>> . . . . . . . . . 2-4
        2.5     ~^<<ORDINARY DIFFERENTIATION~^>> . . . . . . . . . 2-6
        2.6     ~^<<COVARIANT DIFFERENTIATION~^>>  . . . . . . . . 2-6
        2.7     ~^<<FILETYPES AND DISK IN/OUTPUT~^>> . . . . . . . 2-7
        2.8     ~^<<"ALL"-ARGUMENTS TO ZDEF-COMMANDS~^>> . . . . . 2-8
        2.9     ~^<<CREATE BACKUP~^>>  . . . . . . . . . . . . .  2-11
        2.10    ~^<<TECHNICAL ON EDEF~^>>  . . . . . . . . . . .  2-11


CHAPTER 3       SUBSTITUTIONS

        3.1     ~^<<OVERVIEW AND EXAMPLE~^>> . . . . . . . . . . . 3-1
        3.2     ~^<<MATCHING OF INDICES~^>>  . . . . . . . . . . . 3-3
        3.3     ~^<<MATCHING OF TENSOR NAMES~^>> . . . . . . . . . 3-3
        3.4     ~^<<WILDCARDS IN SUBSTITUTIONS~^>> . . . . . . . . 3-3
        3.5     ~^<<SUBSTITUTION WITH SIDECONDITION~^>>  . . . . . 3-5
        3.6     ~^<<ORDEROK FOR CONDITIONAL SUBSTITUTION~^>> . . . 3-5
        3.7     ~^<<SETSUB MAY PDEF AND SDEF~^>> . . . . . . . . . 3-6
        3.8     ~^<<SETSUB PROBLEM WITH @-CHARACTER~^>>  . . . . . 3-6
        3.9     ~^<<SPECIAL TENSORS~^>>  . . . . . . . . . . . . . 3-7
        3.10    ~^<<GENERALIZED KRONECKER DELTAS~^>> . . . . . . . 3-8
        3.11    ~^<<PFAFFIAN TENSORS~^>> . . . . . . . . . . . . . 3-9
        3.12    ~^<<LEVI-CIVITA SYMBOLS EPS3-9~^>> . . . . . . . . 3-9
        3.13    ~^<<DEL IS DECLARED BOTH SYMMETRIC AND MIXED~^>> . 3-9
        3.14    ~^<<SUPER SUBSTITUTION LIST~^>>  . . . . . . . .  3-10
                                                                Page 3


CHAPTER 4       OPERATOR ALGEBRA AND ORDERING

        4.1     ~^<<NON/ANTI-COMMUTATIVITY~^>> . . . . . . . . . . 4-1
        4.2     ~^<<DIFFERENTIAL OPERATORS~^>> . . . . . . . . . . 4-3
        4.3     ~^<<POISSON BRACKETS~^>> . . . . . . . . . . . . . 4-4
        4.4     ~^<<LEFT/RIGHT-PARENTHESIS OBJECTS~^>> . . . . . . 4-5
        4.5     ~^<<TECHNICAL REMARK~^>> . . . . . . . . . . . . . 4-6
        4.6     ~^<<ADVANCED SUBSTITUTION EXAMPLES~^>> . . . . . . 4-6
        4.6.1     VARIATION PRINCIPLES . . . . . . . . . . . . . . 4-7
        4.6.2     PARTIAL INTEGRATION  . . . . . . . . . . . . . . 4-7


CHAPTER 5       SPINOR AND SUPERGRAVITY FACILITIES

        5.1     ~^<<SPINOR AND SHORTNAME INPUT~^>> . . . . . . . . 5-1
        5.2     ~^<<COMPLEX CONJUGATION~^>>  . . . . . . . . . . . 5-2
        5.3     ~^<<SPINOR IDENTITIES~^>>  . . . . . . . . . . . . 5-4
        5.4     ~^<<SEDIT - STENSOR EDITOR~^>> . . . . . . . . . . 5-5
        5.5     ~^<<(COVARIANT) DIFFERENTIATION OF SPINORS~^>> . . 5-7


CHAPTER 6       SPACE DECLARATIONS, INDEXTYPE, SPLITTING

        6.1     ~^<<SPACE DECLARATIONS~^>> . . . . . . . . . . . . 6-1
        6.2     ~^<<INDEXTYPES AND SPLITTING~^>> . . . . . . . . . 6-2
        6.3     ~^<<SPLITTED SUBSTITUTIONS~^>> . . . . . . . . . . 6-4


CHAPTER 7       AUTOMATIC GENERATION OF TENSOR ALGORITHMS

        7.1     ~^<<INTRODUCTION~^>> . . . . . . . . . . . . . . . 7-1
        7.2     ~^<<TCOMP - TENSOR COMPILE~^>> . . . . . . . . . . 7-1
        7.3     ~^<<TCOMPOUT OR SAVBU - SAVE BULFS~^>> . . . . . . 7-2
        7.4     ~^<<(TCOMPOUT FILE ALL)~^>>  . . . . . . . . . . . 7-3
        7.4.1     TOP TENSORS SUFFICE -GIVES HIERARCHY:  . . . . . 7-3
        7.5     ~^<<<> MARKS EVALUATION TO TCOMP~^>> . . . . . . . 7-4
        7.6     ~^<<DIMENSION USAGE IN TCOMP~^>> . . . . . . . . . 7-4
        7.7     ~^<<MIXED DIMENSIONS IN TCOMP~^>>  . . . . . . . . 7-4
        7.8     ~^<<DETERMINANT AND INVERSE OF A MATRIX~^>>  . . . 7-5
        7.9     ~^<<INTERMEDIATE OBJECTS SELDOM NEEDED~^>> . . . . 7-6
        7.10    ~^<<PRODUCE A BLF-FILE FOR THE LISP COMPILER~^>> . 7-7
        7.11    ~^<<FACTORIZATION DONE BY TCOMP~^>>  . . . . . . . 7-7
        7.12    ~^<<IDENTIFY TERMS WITH SPECIFIC OBJECT~^>>  . . . 7-8
        7.13    ~^<<FACILITIES FOR CREATING DOCUMENTATION~^>>  . . 7-8
        7.14    ~^<<OVERLAPPING SYMMETRIES~^>> . . . . . . . . . . 7-9
        7.14.1    INDICIAL COMPUTATIONS WITH OVERLAP-SYM.  . . .  7-10
        7.14.2    COMPONENTWISE COMPUTATIONS WITH OVERLAP-SYM. .  7-10
        7.15    ~^<<TENSOR ALIAS, PACKAGE~^>>  . . . . . . . . .  7-11
        7.15.1    QUOTING CHARACTER  . . . . . . . . . . . . . .  7-11
        7.15.2    PACKAGE SYMBOL (STENSOR ONLY)  . . . . . . . .  7-12
        7.16    ~^<<ADDITIONAL COMMANDS IN BLF-FILES~^>> . . . .  7-12
                                                                Page 4


CHAPTER 8       WHILE COMPUTING COMPONENTS

        8.1     ~^<<TIMING~^>> . . . . . . . . . . . . . . . . . . 8-1
        8.2     ~^<<TRIGONOMETRIC SIMPLIFIER WTRIG~^>> . . . . . . 8-2
        8.3     ~^<<MIXING STENSOR AND SHEEP~^>> . . . . . . . . . 8-3
        8.4     ~^<<COMMANDS FOR ORDINARY SHEEP-SUBSTITUTIONS~^>>  8-5
        8.5     ~^<<WTERMS - WRITE NBR OF TERMS~^>>  . . . . . . . 8-6
        8.6     ~^<<IOMAKE - IN/OUTPUT MAKE~^>>  . . . . . . . . . 8-7


CHAPTER 9       BUCKETING, BATCH AND ERRORS

        9.1     ~^<<BUCKETING AND AUTOMATIC DISK USAGE~^>> . . . . 9-1
        9.2     ~^<<BATCH FOR REPETITIVE/TEDIOUS WORK~^>>  . . . . 9-3
        9.3     ~^<<ERROR MESSAGES~^>> . . . . . . . . . . . . . . 9-4
        9.4     ~^<<REPORTING AN ERROR~^>> . . . . . . . . . . . . 9-5


CHAPTER 10      FACILITIES THAT REQUIRE SOME KNOWLEDGE OF LISP

        10.1    ~^<<FUNDAMENTAL LISP-COMMANDS/CONCEPTS~^>> . . .  10-1
        10.2    ~^<<SPECIAL PRINTING OF TENSOR/INDICES~^>> . . .  10-3
        10.3    ~^<<PUSHV AND POPV~^>> . . . . . . . . . . . . .  10-4
        10.4    ~^<<SUBSTITUTION PROGRAMS~^>>  . . . . . . . . .  10-4
        10.5    ~^<<MAKING SUBSTITUTION PROGRAMS BY HAND~^>> . .  10-5
        10.6    ~^<<LIBRARY OF PRE-REQUIRED OBJECTS/FUNCTIONS~^>> 10-6
        10.7    ~^<<FURTHER INFORMATION~^>>  . . . . . . . . . .  10-7


APPENDIX A      

        A.1     ~^<<COORDINATE TRANSFORMATIONS~^>> . . . . . . . . A-1
        A.2     ~^<<MACHINES AND INSTALLATION~^>>  . . . . . . . . A-1





                            Edition  6,   nov  1986


                              For  version  2.26
.P
                                                                         Page 5


                                   ABSTRACT



        STENSOR is a system specialized on  formulas  with  tensors  or
        spinors with symbolic (letter) indices.  It works together with
        SHEEP.
        Formula input is very close to ordinary  textbook  conventions.
        Thus    a    formula    containing   ordinary   and   covariant
        differentiation  could   be:    <TSR L K ,M> + <TSR M L ;K>   .
        Primed spinor indices are understood, and that a repeated index
        is dummy etc.
        The representation is devoted, as the simplifier, which renames
        dummies  automatically  and handles other profound difficulties
        that are totally unknown from ordinary scalar algebra.
        Besides evaluation, differentiation  etc,  STENSOR  substitutes
        sums, e.g.  to exploit sin^2 x + cos^2 x = 1 optimally.
        There is a compiler that from any formula generates  a  program
        for  computing  individual  components  by  actually performing
        contractions etc.

                           ~^<<SIZE OF STENSOR:~^>>


        Blocks  XXXXX REDUCE 3
                XXXXX
        1500____XXXXX           Summed up size of the source code files,
                XXXXX           including their comments, for some
                XXXXX           languages. 1 block on VAX/VMS = 512 bytes
                XXXXX                   (July 1986)
                XXXXX
        1000____XXXXX           xxxxx STENSOR 2.26
                XXXXX           XXXXX
                XXXXX           XXXXX
                XXXXX           XXXXX
                XXXXX           XXXXX
         500____XXXXX           XXXXX
                XXXXX           XXXXX
                XXXXX           XXXXX           XXXXX SHEEP 2.04
                XXXXX           XXXXX           XXXXX
                XXXXX           XXXXX           XXXXX
           0____XXXXX___________XXXXX___________XXXXX____________

Blocks:          1817            1060             400
Source files:  ..SRC:*.*        STS:*.STS       NSHP:*.SL
Number of files:   22              75              61

               All files are very rarely needed simultaneously.
                                                                         Page 6


1  ~^<<INTRODUCTION:  A SAMPLE SESSION~^>>

The computer interaction is to the left,
with all user input underlined:         ^zComments indented to the right:

Username: ~^<_kilroy~^>_                        First login, giving your username
Password: ~^<_washere~^>_                       and some secret word (will not be seen).

 .... ^zAfter loginmessages, you are left talking to the operating system,which
        signals its readiness with a "$" or "%" as prompter. Then you could do:

$ ~^<_TYPE STSD:VMS.HLP~^>_             -for an introduction to VMS operating system,
% ~^<_cat $stsd/unix.hlp~^>_            -or this for the corresponding unix-help.
